
function comActivityPay(payment, pagePath) {
    var promise = new Bmob.Promise();
    api.addEventListener({
        name : 'onPaymentFinished'
    }, function(ret, err) {
        if (ret.value && ret.value.paymentID == payment.paymentID) {
            if (ret.value.result == 'success') {
                promise.resolve();
            }else if(ret.value.result == 'cancel'){
                var payError = {
                    code : 1,
                    message : ret.value.result,
                    result : ret.value.result
                }
                promise.reject(payError);
            }else {
                var payError = {
                    code : 889,
                    message : 'pay ' + ret.value.result,
                    result : ret.value.result
                }
                promise.reject(payError);
            }
        } else {
            consoledebug.log('onPaymentFinished ret and err is : ' + JSON.stringify(ret) + JSON.stringify(err));
            var payError = {
                code : 889,
                message : 'pay error',
                result : ret.value.result
            }
            promise.reject(err);
        }
    });
    
    payment.subject = '参与活动费用';
    comOpenWin('RMBpay', pagePath, payment, 0); 
    return promise;
}


//获取个人信息  通过判断自己的性别来显示价格
function getOwnerInfo(successCallback,errorCallback){
	var myAcount = getMyAccount();
	var hhIDs = [myAcount.hhID];
	getComUserInfo(hhIDs, function(results){
		if(results.length > 0){
			successCallback(results[0].sex);
		}else{
			errorCallback();
		}
	}, function(){
	}, function(error){
		consoledebug.log('getOwnerInfo error is '+ JSON.stringify(error));
		errorCallback(error);
	})
	
}
//跳转到活动详情页
function SkipDescriptContent(){
    activityInfos[0].oPhoto = activityInfos[0].activePhoto;
    if(activityInfos[0].photo == undefined){
    	activityInfos[0].photo = '../../image/defaultAvatar.png';
    }
	comOpenWin('sportInfo', '../../activity/',activityInfos[0],0);
}
//点击头像跳转到详情页
function openUserInfo(el){
    var hhID = $api.attr(el, 'id');
    hhID=Number(hhID);
    consoledebug.log('openUserInfo id is '+ hhID +typeof(hhID));
    comOpenWin('otherUserInfo','../../user/',hhID,0);
}

//判断活动对性别的限制
function judgeSex(sex){
	if(sex == 0){
		sex = "男女不限";
	}else if(sex == 1){
		sex = "男生";
	}else{
		sex = "女生";
	}
	return sex;
}
//群跳转
function enterGroup(groupID,groupName){
	var groupID = activeRecord.get("groupID");
	var groupName = activeRecord.get("groupName");
	enterGroupChat(groupID,groupName);
}
//跳转到活动群页面
function enterGroupChat(gGroupID,gGroupName){
	if(gGroupID != undefined){
		var objParam = {
			hisid : gGroupID,
			titleName : gGroupName,
			type : 'DISCUSSION',
			lastMsgId : -1
		};
		comOpenWin('chatAty', '../../window/',objParam,0);
	}else{
		api.toast({
	        msg:'自动建群出问题了，请手动建群联系吧'
        });
	}
}

function transActiveBeginTime(info) {
    if(info.applyDeadline){
        if (info.applyDeadline == "0") {
            info.applyDeadlineDate = "活动开始时";
            info.applyDeadline = "活动开始时";
        } else {
            info.applyDeadlineDate = (new Date(Number(info.applyDeadline))).Format("yy-MM-dd hh:mm");
            info.applyDeadline = info.applyDeadlineDate;
        }
    }
    if(info.beginTime){
        if (info.beginTime == "0") {
            info.beginDate = "越快越好";
            info.beginTime = "越快越好";
        } else {
            info.beginDate = (new Date(Number(info.beginTime))).Format("yy-MM-dd hh:mm");
            info.beginTime = info.beginDate;
        }
    }
}
