/**
 *
 * @param {Object} voteInfo
 * @param Number   voteTag    0:未发布:	1:已发布（未开始投票）		2：开始投票		3：结束投票（投票完成）		-1：删除投票
 * @param {Object} successCallback
 * @param {Object} errorCallback
 */

//创建活动投票
function creatActiveVoteInfo(voteInfo, successCallback, errorCallback) {
	consoledebug.log("creatActiveVoteInfo voteInfo is " + JSON.stringify(voteInfo));
	var Activity = Bmob.Object.extend("Activity");
    var query = new Bmob.Query(Activity);
    query.equalTo("ownerID",voteInfo.ownerID);
    query.equalTo("activityID",voteInfo.activityID);
    query.select("voteTag");
    query.find().then(function(result){
    	consoledebug.log("result is " + JSON.stringify(result));
    	result[0].set("voteTag",1);
    	result[0].save().then(function(results){
    		consoledebug.log("creatActiveVoteInfo results is " + JSON.stringify(results));
			consoledebug.log("creatActiveVoteInfo voteInfo 111  is " + JSON.stringify(voteInfo));
			var ActiveVoteInfo = Bmob.Object.extend("ActiveVoteInfo");
			var activeVoteInfo = new ActiveVoteInfo();
			activeVoteInfo.set("activityID",voteInfo.activityID);
			activeVoteInfo.set("ownerID",voteInfo.ownerID);
			activeVoteInfo.set("voteTitle",voteInfo.voteTitle);
			activeVoteInfo.set("voteDescription",voteInfo.voteDescription);
			activeVoteInfo.set("rewardLink",voteInfo.rewardLink);
			activeVoteInfo.set("photo",voteInfo.photo);
			activeVoteInfo.set("voteTag",1);
			activeVoteInfo.set("referrerID",voteInfo.referrerID);
			activeVoteInfo.save().then(function(activeVoteInfos) {
				successCallback(activeVoteInfos);
			}, function(error) {
				errorCallback(error);
			});
    	},function(error){
    		errorCallback(error);
    	})
    },function(error){
    	errorCallback(error);
    })
}

//活动参与者参加竞选
function attendActiveVoterInfo(voteInfo, successCallback, errorCallback) {
	consoledebug.log("creatActiveVoteInfo voteInfo is " + JSON.stringify(voteInfo));
	var AttendVoterInfo = Bmob.Object.extend("AttendVoterInfo");
	var attendVoterInfo = new AttendVoterInfo();
	attendVoterInfo.set("activityID", voteInfo.activityID);
	attendVoterInfo.set("ownerID", voteInfo.ownerID);
	attendVoterInfo.set("voterName", voteInfo.voterName);
	attendVoterInfo.set("voteDescription", voteInfo.attendDescription);
	attendVoterInfo.set("photo", voteInfo.photo);
	attendVoterInfo.set("selectState", 0);		//选择状态
	attendVoterInfo.set("activeVoteID", voteInfo.activeVoteID);
	attendVoterInfo.set("voteNum", 0);		//被投票的数量
	attendVoterInfo.set("userPhoto", voteInfo.userPhoto);
	attendVoterInfo.set("referrerID", voteInfo.referrerID);		//若投票发起人为合伙人，则参与人referrerID字段填发起人的hhID;否则为0
	attendVoterInfo.save().then(function(activeVoterInfos) {
		consoledebug.log("creatActiveVoteInfo activeVoterInfos 111 is " + JSON.stringify(activeVoterInfos));
		successCallback(activeVoterInfos);
	}, function(error) {
		consoledebug.log("creatActiveVoteInfo error 222 is " + JSON.stringify(error));
		errorCallback(error);
	});
}

//添加活动投票参与者上传的图片
function addActiveVoterPhotos(ownerID,activityID,photo,activeVoteID,successCallback, errorCallback){
	 var Table = Bmob.Object.extend("ActiveVoterPhotos");
     var activeVoterPhoto = new Table();
     activeVoterPhoto.set("ownerID", ownerID);
     activeVoterPhoto.set("activityID", activityID);
     activeVoterPhoto.set("photo", photo);
     activeVoterPhoto.set("activeVoteID", activeVoteID);
     activeVoterPhoto.save({
         success: function (voterPhoto) {
             consoledebug.log("addSkillPhotos skillPhoto is  "+JSON.stringify(voterPhoto));
             successCallback(voterPhoto);
        },
        error: function (error) {
             consoledebug.log("addSkillPhotos showSkillPhoto save error is  "+JSON.stringify(error));
             errorCallback(error);
       }
   });
}

//获取投票竞选参与者的信息
function getSelectVoterInfo(selectState,activityID,activeVoteID,successCallback, errorCallback){
	var AttendVoterInfo = Bmob.Object.extend("AttendVoterInfo");
	var query = new Bmob.Query(AttendVoterInfo);
	query.equalTo("selectState", selectState);
	query.equalTo("activityID", activityID);
	query.equalTo("activeVoteID", activeVoteID);
	query.find().then(function(result){
		successCallback(result)
	},function(error){
		errorCallback(error);
	})
}

function sureSelectActiveVoters(activityID,count,selectState,activeVoteID,ownerIDarray,successCallback, errorCallback){
	if(count < ownerIDarray.length){
		var AttendVoterInfo = Bmob.Object.extend("AttendVoterInfo");
		var query = new Bmob.Query(AttendVoterInfo);
		query.equalTo("ownerID", ownerIDarray[count]);
		query.equalTo("activityID", activityID);
		query.equalTo("activeVoteID", activeVoteID);
	    query.find().then(function(result){
		    consoledebug.log("sureSelectActiveVoters result is "+JSON.stringify(result));
			if(result.length > 0){
				result[0].set("selectState", selectState);
				result[0].save().then(function(){
					count++;
					sureSelectActiveVoters(activityID,count,selectState,activeVoteID,ownerIDarray,successCallback, errorCallback);
				},function(error){
					errorCallback(error);
				})
			}
	    },function(error){
	    	errorCallback(error);
	    })
    }else{
    	successCallback();
    }
}


//获取活动投票列表中的投票信息
function getActiveVoteInfo(activityID,successCallback, errorCallback){
	var ActiveVoteInfo = Bmob.Object.extend("ActiveVoteInfo");
	var query = new Bmob.Query(ActiveVoteInfo);
	query.equalTo("activityID", activityID);
	query.greaterThanOrEqualTo("voteTag", 1);
	query.find().then(function(result){
		successCallback(result)
	},function(error){
		errorCallback(error);
	})
}

//获取被举办方选中的竞选人列表
function getActiveVoterList(activityID,activeVoteID,successCallback, errorCallback){
	var AttendVoterInfo = Bmob.Object.extend("AttendVoterInfo");
	var query = new Bmob.Query(AttendVoterInfo);
	query.equalTo("activityID", activityID);
	query.equalTo("selectState", 1);
	query.equalTo("activeVoteID", activeVoteID);
	query.find().then(function(result){
		successCallback(result)
	},function(error){
		errorCallback(error);
	})
}



function activeVoting(ownerID,activityID,activeVoteID,referrerID,successCallback, errorCallback){
	var ActiveVoting = Bmob.Object.extend("ActiveVoting");
	var query = new ActiveVoting();
	query.set("ownerID", ownerID);
	query.set("activityID", activityID);
	query.set("activeVoteID", activeVoteID);
	query.set("voterhhID", getMyAccount().hhID);
	query.set("referrerID", referrerID);
    query.save().then(function (result) {
    	consoledebug.log("activityID ownerID 00000 is  "+activityID+" "+ownerID);
        consoledebug.log("addSkillPhotos result is  "+JSON.stringify(result));
        var AttendVoterInfo = Bmob.Object.extend("AttendVoterInfo");
		var attendVoterInfo = new Bmob.Query(AttendVoterInfo);
		attendVoterInfo.equalTo("activityID", activityID);
		attendVoterInfo.equalTo("ownerID", ownerID);
		attendVoterInfo.find().then(function(results){
			consoledebug.log("addSkillPhotos results 00000 is  "+JSON.stringify(results));
			results[0].set("voteNum",results[0].get("voteNum")+1);
			results[0].save().then(function () {
				successCallback()
			},function(){
				errorCallback(error);
			})
		},function(error){
			errorCallback(error);
		})
    }, function (error) {
        consoledebug.log("addSkillPhotos showSkillPhoto save error is  "+JSON.stringify(error));
        errorCallback(error);
    })
}

//获取 竞选投票人详情页信息
function getVoterUserInfo(ownerID,activityID,activeVoteID,successCallback, errorCallback){
	var AttendVoterInfo = Bmob.Object.extend("AttendVoterInfo");
	var query = new Bmob.Query(AttendVoterInfo);
	query.equalTo("activityID", activityID);
	query.equalTo("ownerID", ownerID);
	query.equalTo("activeVoteID", activeVoteID);
	query.find().then(function(result){
		consoledebug.log('getVoterUserInfo result is '+ JSON.stringify(result));
		successCallback(result);
	},function(error){
		errorCallback(error);
	})
}
//获取 竞选投票人详情页信息图片
function getVoterUserPhotos(ownerID,activityID,activeVoteID,successCallback, errorCallback){
	var ActiveVoterPhotos = Bmob.Object.extend("ActiveVoterPhotos");
	var query = new Bmob.Query(ActiveVoterPhotos);
	query.equalTo("activityID", activityID);
	query.equalTo("ownerID", ownerID);
	query.equalTo("activeVoteID", activeVoteID);
	query.find().then(function(photos){
		consoledebug.log('getVoterUserInfo photos is '+ JSON.stringify(photos));
		successCallback(photos);
	},function(error){
		errorCallback(error);
	})
}

//竞选参与者取消参与
//function deleteActiveVote(ownerID,activityID,activeVoteID,successCallback, errorCallback){
function deleteActiveVote(ownerID,activityID,activeVoteID,successCallback, errorCallback){
	var AttendVoterInfo = Bmob.Object.extend("AttendVoterInfo");
	var query = new Bmob.Query(AttendVoterInfo);
	query.equalTo("activityID", activityID);
	query.equalTo("ownerID", ownerID);
	query.equalTo("activeVoteID", activeVoteID);
	query.destroyAll({
	   success: function(){
	   		var ActiveVoterPhotos = Bmob.Object.extend("ActiveVoterPhotos");
			var activeVoterPhotos = new Bmob.Query(ActiveVoterPhotos);
			activeVoterPhotos.equalTo("activityID", activityID);
			activeVoterPhotos.equalTo("ownerID", ownerID);
			activeVoterPhotos.equalTo("activeVoteID",activeVoteID);
			activeVoterPhotos.find({
	   			success: function(results){
	   				for(var i = 0; i < results.length; i++){
	   					results[i].destroy();
	   				}
	   				successCallback();
	   			},
			   	error: function(err){
			   		errorCallback(err)
			   	}
			});
	   },
	   error: function(err){
	   		errorCallback(err)
	   }
   });
}

//竞选发布者取消发布
function deleteCreatActiveVote(ownerID,activityID, successCallback, errorCallback) {
	var Activity = Bmob.Object.extend("Activity");
    var query = new Bmob.Query(Activity);
    query.equalTo("ownerID",ownerID);
    query.equalTo("activityID",activityID);
    query.select("voteTag");
    query.find().then(function(result){
    	consoledebug.log("result is " + JSON.stringify(result));
    	result[0].set("voteTag",-1);
    	result[0].save().then(function(results){
    		consoledebug.log("creatActiveVoteInfo results is " + JSON.stringify(results));
			var ActiveVoteInfo = Bmob.Object.extend("ActiveVoteInfo");
			var activeVoteInfo = new Bmob.Query(ActiveVoteInfo);
			activeVoteInfo.equalTo("ownerID",ownerID);
    		activeVoteInfo.equalTo("activityID",activityID);
    		activeVoteInfo.equalTo("voteTag",1);
    		activeVoteInfo.select("voteTag");
    		activeVoteInfo.find().then(function(activeVoteInfos){
    			activeVoteInfos[0].set("voteTag",-1);
    			activeVoteInfos[0].save().then(function(voteInfos){
    				successCallback(voteInfos);
    			},function(error){
		    		errorCallback(error);
		    	})
    		},function(error){
	    		errorCallback(error);
	    	})
    	},function(error){
    		errorCallback(error);
    	})
    },function(error){
    	errorCallback(error);
    })
}



//开始投票startVote
function startActiveVote(ownerID,activityID,successCallback, errorCallback){
	var promises = [];
    var promise = new Bmob.Promise();
	getActiveVoterList(activityID,activeVoteID,function(voterList){
		for(var i = 0; i < voterList.length; i++){
			voterList[i].set('serialNum', i+1);
            promises.push(voterList[i].save());
		}
		Bmob.Promise.when(promises).then(function(){
			var Activity = Bmob.Object.extend("Activity");
		    var query = new Bmob.Query(Activity);
		    query.equalTo("ownerID",ownerID);
		    query.equalTo("activityID",activityID);
		    query.select("voteTag");
		    query.find().then(function(result){
		    	consoledebug.log("result is " + JSON.stringify(result));
		    	result[0].set("voteTag",2);
		    	result[0].save().then(function(){
					var ActiveVoteInfo = Bmob.Object.extend("ActiveVoteInfo");
					var activeVoteInfo = new Bmob.Query(ActiveVoteInfo);
					activeVoteInfo.equalTo("ownerID",ownerID);
		    		activeVoteInfo.equalTo("activityID",activityID);
		    		activeVoteInfo.equalTo("voteTag",1);
		    		activeVoteInfo.select("voteTag");
		    		activeVoteInfo.find().then(function(activeVoteInfos){
		    			activeVoteInfos[0].set("voteTag",2);
		    			activeVoteInfos[0].save().then(function(voteInfos){
		    				promise.resolve(voteInfos);
		    			},function(error){
				    		consoledebug.log('startActiveVote activeVoteInfo[0] error is '+ JSON.stringify(error));
        					promise.reject(error);
				    	})
		    		},function(error){
			    		consoledebug.log('startActiveVote activeVoteInfo error is '+ JSON.stringify(error));
        				promise.reject(error);
			    	})
		    	},function(error){
		    		consoledebug.log('startActiveVote result[0] error is '+ JSON.stringify(error));
        			promise.reject(error);
		    	})
		    },function(error){
		    	consoledebug.log('startActiveVote query.find() error is '+ JSON.stringify(error));
        		promise.reject(error);
		    })
        },function(errors){
            promise.reject(error);
        });
	}, function(error){
		consoledebug.log('startActiveVote getActiveVoterList error is '+ JSON.stringify(error));
        promise.reject(error);
	})
	
	return promise;
}


//结束投票
function endActiveVote(ownerID, activityID, successCallback, errorCallback) {
	var Activity = Bmob.Object.extend("Activity");
    var query = new Bmob.Query(Activity);
    query.equalTo("ownerID",ownerID);
    query.equalTo("activityID",activityID);
    query.select("voteTag");
    query.find().then(function(result){
    	consoledebug.log("result is " + JSON.stringify(result));
    	result[0].set("voteTag",3);
    	result[0].save().then(function(results){
    		consoledebug.log("creatActiveVoteInfo results is " + JSON.stringify(results));
			var ActiveVoteInfo = Bmob.Object.extend("ActiveVoteInfo");
			var activeVoteInfo = new Bmob.Query(ActiveVoteInfo);
			activeVoteInfo.equalTo("ownerID", ownerID);
			activeVoteInfo.equalTo("activityID", activityID);
			activeVoteInfo.equalTo("voteTag", 2);
			activeVoteInfo.select("voteTag");
			activeVoteInfo.find().then(function(activeVoteInfos) {
				activeVoteInfos[0].set("voteTag", 3);
				activeVoteInfos[0].save().then(function(voteInfos) {
					successCallback(voteInfos);
				}, function(error) {
					errorCallback(error);
				})
			}, function(error) {
				errorCallback(error);
			})
    	},function(error){
    		errorCallback(error);
    	})
    },function(error){
    	errorCallback(error);
    })
}




//获取投票结果  判断自己是否投票
function judgeIsVoted(voterhhID, activeVoteID, successCallback, errorCallback) {
	var ActiveVoting = Bmob.Object.extend("ActiveVoting");
	var query = new Bmob.Query(ActiveVoting);
	query.equalTo("voterhhID", voterhhID);
	query.equalTo("activeVoteID", activeVoteID);
	query.find().then(function(result) {
		successCallback(result)
	}, function(error) {
		errorCallback(error);
	})
}

//判断投票发起人是否是平台合伙人
function judgeIsPartner(hhID, successCallback, errorCallback){
	var UserInfo = Bmob.Object.extend("UserInfo");
	var query = new Bmob.Query(UserInfo);
	query.equalTo("hhID", hhID); 
	query.select("partner");
	query.find().then(function(result){
		var tag;
		if(result[0].get("partner") == 1){
			tag = true;
		}else{
			tag = false;
		}
		successCallback(tag);
	},function(error){
		errorCallback(error);
	})
}













