var gDB;
var DB_NAME = 'owlCache';
var DB_PATH;

var UserInfoColumnArray = ["hhID","nickName","sex","age","level","appraisement","describe","validateState","livingPlace","photo","lastReadTime","updateAt"];
var CreateUserInfo = 'CREATE TABLE IF NOT EXISTS UserInfo(hhID int PRIMARY KEY, nickName NVARCHAR(20), sex NCHAR(4), age int, level int, appraisement int, describe nvarchar(255), validateState int, livingPlace nvarchar(10), photo CLOB, lastReadTime FLOAT, updateAt CHAR(30))';

var CreateFriends = 'CREATE TABLE IF NOT EXISTS MyFriends(friendID int PRIMARY KEY, state int, reason NVARCHAR(40))';
//var CreateConversationList = 'CREATE TABLE IF NOT EXISTS ConversationList(targetId varchar(40) PRIMARY KEY, conversationTitle varchar(40), conversationType char(20), draft varchar(255), latestMessageText nvarchar(255), latestMessageExtra nvarchar(255), sentStatus char(10), objectName varchar(40), recievedStatus char(12), senderUserId varchar(40), unreadMessageCount int, receivedTime char(18), sentTime char(18), isTop int, latestMessageId int, updateAt CHAR(30))';
var CreateGroups = 'CREATE TABLE IF NOT EXISTS MyGroups(groupID int PRIMARY KEY, groupName NVARCHAR(20), builderHHID int, rongyunID varchar(40), maintain int, photo CLOB, updateAt CHAR(30))';
//var CreateHistoryMessages = 'CREATE TABLE IF NOT EXISTS HistoryMessages(messageId int, targetId varchar(40), content varchar(255), conversationType char(20), messageDirection char(8), objectName varchar(40), sentStatus char(12), senderUserId varchar(40), receivedTime char(18), sentTime char(18), updateAt CHAR(30), PRIMARY KEY(messageId, targetId))';
//var ConversationStatue = 'CREATE TABLE IF NOT EXISTS ConversationStatue(targetId varchar(40) PRIMARY KEY, unreadMessageCount int)'; 
var CreateMyOrders = 'CREATE TABLE IF NOT EXISTS MyOrders(orderID int, orderName NVARCHAR(30), classID NCHAR(6), beginTime char(18), place varchar(40), state int, notify int, ownership int, orderType int, updateAt CHAR(30), PRIMARY KEY(orderID, orderType))';


function openDB(callback) {
	var myAcount = getMyAccount();
    if(!(myAcount && myAcount.hhID)){
        consoledebug.log('cannot openDB, user does not login.');
        return;
    }
	DB_PATH = 'fs://' + myAcount.hhID + '/db/owlCache.db';
    consoledebug.log('openDB try to open ' + DB_PATH);
	gDB = api.require('db');
	gDB.openDatabase({
		name : DB_NAME,
		path : DB_PATH
	}, function(ret, err) {
		if (ret.status) {
			consoledebug.log('openDatabase success ' + JSON.stringify(ret));
			updateTable(callback);
			
//			createTable(CreateUserInfo, function(){
//				createTable(CreateGroups, function(){
//					createTable(CreateMyOrders,function(){
//						callback();
//					});
//				});
//			});
			//createTable(CreateConversationList);
			//createTable(CreateHistoryMessages);
			//createTable(ConversationStatue);
//			var testSql = "insert or replace into ConversationList (targetId, conversationTitle, conversationType, latestMessageText, latestMessageExtra, sentStatus, objectName, senderUserId, receivedTime, sentTime, latestMessageId, updateAt) values('200015', '阿尔山', 'DISCUSSION', '洛可可', '100032', 'SENT', 'RC:TxtMsg', '100032', 1448882736506, 1448882738000, 10, '2015-11-30 19:26:16');"	
//		    insertSql(testSql, function(){
//		    }, function(err){
//		    });
		} else {
			consoledebug.log('openDatabase error is ' + err.msg);
		}
	});
}


function updateTable(callback) {
	var sql = 'PRAGMA table_info([UserInfo])';
	selectSql(sql, function(results) {
		consoledebug.log('openDB selectSql results ' + JSON.stringify(results));
		var tableMap = [];
		for (var i = 0; i < results.length; i++) {
			tableMap[results[i].name] = results[i].name;
		}
		for (var i = 0; i < UserInfoColumnArray.length; i++) {
			if (tableMap[UserInfoColumnArray[i]] != UserInfoColumnArray[i]) {
				break;
			}
		}
		if (i < UserInfoColumnArray.length-1) {
			var fs = api.require('fs');
			var ret = fs.removeSync({
				path : DB_PATH
			});
//			if (ret.status) {
//				alert('删除成功！');
//			} else {
//				alert('删除失败！');
//			}
			gDB = api.require('db');
			gDB.openDatabase({
				name : DB_NAME,
				path : DB_PATH
			}, function(ret, err) {
				if (ret.status) {
					consoledebug.log('openDatabase success ' + JSON.stringify(ret));
					consoledebug.log('openDB createTable start 2');
					createTable(CreateUserInfo, function(){
						createTable(CreateGroups, function(){
							createTable(CreateMyOrders,function(){
								callback();
							});
						});
					});
				} else {
					consoledebug.log('openDatabase error is ' + err.msg);
				}
			});
		}else{
			consoledebug.log('openDB createTable start 1');
			createTable(CreateUserInfo, function(){
				createTable(CreateGroups, function(){
					createTable(CreateMyOrders,function(){
						callback();
					});
				});
			});
		}
	}, function(error) {
		consoledebug.log('openDB selectSql error ' + JSON.stringify(error));
	});
}


function closeDB(callback){
    var db = api.require('db');
    db.closeDatabase({
        name:DB_NAME
    }, function(ret, err){
        if(ret.status){
            consoledebug.log('closeDatabase success ' + JSON.stringify(ret));
            callback();
        }else{
            consoledebug.log('closeDatabase error is ' + JSON.stringify(err));
            callback();
        }
    });
}


function initDB() {
	gDB = api.require('db');
}


function createTable(sql, callback) {
	consoledebug.log('createTable sql is ' + sql);
	var db = api.require('db');
	db.executeSql({
		name : DB_NAME,
		sql : sql
	}, function(ret, err) {
		if (ret.status) {
			consoledebug.log('createTable success ' + JSON.stringify(ret));
		} else {
			consoledebug.log('createTable error is ' + err.msg);
		}
		callback(ret, err);
	});
}

  /**
   * 查询数据库数据
   * @param {String} 查询数据库的 sql 语句
   * @param {function} successCallback 成功执行后回调函数，定义为 .
   * 		successCallback(data);
   *        data 是 Json 数组
   * @param {function} errorCallback 操作失败后回调函数，定义为：
   * 		errCallback(err); error is a class, {code: number, msg:string}
   */
function selectSql(sql, successCallback, errorCallback) {
	consoledebug.log('selectSql sql is ' + sql);
	var db = api.require('db');
	db.selectSql({
		name : DB_NAME,
		sql : sql
	}, function(ret, err) {
		if (ret.status) {
			consoledebug.log('selectSql success ' + JSON.stringify(ret));
			var data = ret.data;
			successCallback(data);
		} else {
			consoledebug.log('selectSql error is ' + err.msg);
			errorCallback(err);
		}
	});
}

function insertSql(sql, successCallback, errorCallback) {
	consoledebug.log('insertSql sql is ' + sql);
	var db = api.require('db');
	db.executeSql({
		name : DB_NAME,
		sql : sql
	}, function(ret, err) {
		if (ret.status) {
			consoledebug.log('insertSql success ' + JSON.stringify(ret));
			successCallback();
		} else {
			consoledebug.log('insertSql error is ' + err.msg);
			errorCallback(err);
		}
	});
}

  /**
   * 获取用户信息
   * @param {String} 更新数据库的 sql 语句
   * @param {function} successCallback 成功执行后回调函数，定义为 .
   * 		successCallback();
   * @param {function} errorCallback 操作失败后回调函数，定义为：
   * 		errCallback(err); error is a class, {code: number, msg:string}
   */
function updateSql(sql, successCallback, errorCallback) {
	consoledebug.log('updateSql sql is ' + sql);
	var db = api.require('db');
	db.executeSql({
		name : DB_NAME,
		sql : sql
	}, function(ret, err) {
		if (ret.status) {
			successCallback();
			consoledebug.log('updateSql success ' + JSON.stringify(ret));
		} else {
			errorCallback(err);
			consoledebug.log('updateSql error is ' + err.msg);
		}
	});
}

function deleteSql(sql, successCallback, errorCallback) {
	var db = api.require('db');
	db.executeSql({
		name : DB_NAME,
		sql : sql
	}, function(ret, err) {
		if (ret.status) {
			consoledebug.log('deleteSql success ' + JSON.stringify(ret));
		} else {
			consoledebug.log('deleteSql error is ' + err.msg);
		}
	});
}

function beginTrans(successCallback, errorCallback) {
	var db = api.require('db');
	db.transaction({
	    name: DB_NAME,
	    operation: 'begin'
	}, function(ret, err){
	    if(ret.status){
	        successCallback();
	    }else{
	        errorCallback(err);
	    }
	});
}

function commitTrans(successCallback, errorCallback) {
	var db = api.require('db');
	db.transaction({
	    name: DB_NAME,
	    operation: 'commit'
	}, function(ret, err){
	    if(ret.status){
	        successCallback();
	    }else{
	        errorCallback(err);
	    }
	});
}

function rollbackTrans(successCallback, errorCallback) {
	var db = api.require('db');
	db.transaction({
	    name: DB_NAME,
	    operation: 'rollback'
	}, function(ret, err){
	    if(ret.status){
	        successCallback();
	    }else{
	        errorCallback(err);
	    }
	});
}



