
var CONVERSATION_TABLE_NAME = "ConversationList";
//var RONGYUN_SDK = "rongCloud";
var GROUPS_TABLE_NAME = "MyGroups";
var UNREAD_TABLE_NAME = "ConversationStatue";

function getComConversationList(initCallback, updateCallback, errorCallback) {
    var rong = api.require(RONGYUN_SDK);
    getCacheConversationList(function(LocalList){
        consoledebug.log('getCacheConversationList length is ' + LocalList.length);
    	initCallback(LocalList);
    }, function(err){
        consoledebug.log('getCacheConversationList error is ' + err.msg);
    });
    rong.getConversationList(function(ret, err) {
        if (ret.status == 'success') {
            if (ret.result && ret.result.length > 0) {
        		consoledebug.log('get Net ConversationList length is ' + ret.result.length);
                updateCacheConversationList(ret.result, function(){
				    getCacheConversationList(function(LocalList){
				        consoledebug.log('getCacheConversationList length is ' + LocalList.length);
				    	updateCallback(LocalList);
				    }, function(err){
				        consoledebug.log('getCacheConversationList error is ' + err.msg);
				    });
                },function(err){
                    consoledebug.log('updateCacheConversationList error is ' + err.msg);
                    errorCallback(err);
                });
            } else{
            	consoledebug.log('rong getConversationList length is 0.');
            }
        } else {
            consoledebug.log('rong getConversationList error is ' + err.msg);
            errorCallback(err);
        }
    });
}

function updateConversationList(updateCallback, errorCallback) {
    var rong = api.require(RONGYUN_SDK);
    rong.getConversationList(function(ret, err) {
        if (ret.status == 'success') {
            if (ret.result && ret.result.length > 0) {
                updateCacheConversationList(ret.result, function(){
				    getCacheConversationList(function(LocalList){
				        consoledebug.log('getCacheConversationList length is ' + LocalList.length);
				    	updateCallback(LocalList);
				    }, function(err){
				        consoledebug.log('getCacheConversationList error is ' + err.msg);
				    });
                },function(err){
                    consoledebug.log('updateCacheConversationList error is ' + err.msg);
                    errorCallback(err);
                });
            }
        } else {
            consoledebug.log('rong getConversationList error is ' + err.msg);
            errorCallback(err);
        }
    });
}

  /**
   * 获取对话列表
   * @param {function} successCallback 成功获取后回调函数，定义为 .
   *        successCallback(conversationList); conversationList 是 {Object[]} json 对象数组
   * 包含的key 为：targetId, conversationTitle, conversationType, draft, latestMessageText, latestMessageExtra, sentStatus, objectName, recievedStatus, senderUserId, unreadMessageCount, receivedTime, sentTime, isTop, latestMessageId
   * @param {function} errorCallback 操作失败后回调函数，定义为：
   *        errCallback(error); error is a class, {code: number, msg:string}
   */
function getCacheConversationList(successCallback, errorCallback){
    var sql = 'SELECT * FROM ' + CONVERSATION_TABLE_NAME + ' ORDER BY updateAt DESC;';
    selectSql(sql, function(conversationList){
        for(var i = 0; i < conversationList.length; i++) {
            conversationList[i].latestMessage = {};
            conversationList[i].latestMessage.text = conversationList[i].latestMessageText;
            conversationList[i].latestMessage.extra = conversationList[i].latestMessageExtra;
            //consoledebug.log('getCacheConversationList i latestMessage.text is ' + conversationList[i].latestMessage.text);
        }
        successCallback(conversationList);
    }, errorCallback);
}


function inertCacheConversationListPromis(conversation) {
    var promise = new Bmob.Promise();

    var sql = "replace into " + CONVERSATION_TABLE_NAME + " (";
    var i = 0;
    var Values = "values(";
    if (conversation.hasOwnProperty('targetId')) {
        Values += "'" + conversation.targetId + "'";
        sql += "targetId";
    }else{
        var err = {};
        err.code = 888;
        err.msg = "PRIMARY Key cannot be null";
        promise.reject(err);
        return;
    }
    if (conversation.hasOwnProperty('conversationTitle')) {
        Values += ", '" + conversation.conversationTitle + "'";
        sql += ", conversationTitle";
    }
    if (conversation.hasOwnProperty('conversationType')) {
        Values += ", '" + conversation.conversationType + "'";
        sql += ", conversationType";
    }
    if (conversation.hasOwnProperty('draft')) {
        Values += ", '" + conversation.draft + "'";
        sql += ", draft";
    }
    if (conversation.hasOwnProperty('latestMessage') && conversation.hasOwnProperty('latestMessage').text) {
        Values += ", '" + conversation.latestMessage.text + "'";
        sql += ", latestMessageText";
    }
    if (conversation.hasOwnProperty('latestMessage') && conversation.hasOwnProperty('latestMessage').extra) {
        Values += ", '" + conversation.latestMessage.extra + "'";
        sql += ", latestMessageExtra";
    }
    if (conversation.hasOwnProperty('sentStatus')) {
        Values += ", '" + conversation.sentStatus + "'";
        sql += ", sentStatus";
    }
    if (conversation.hasOwnProperty('objectName')) {
        Values += ", '" + conversation.objectName + "'";
        sql += ", objectName";
    }
    if (conversation.hasOwnProperty('recievedStatus')) {
        Values += ", '" + conversation.recievedStatus + "'";
        sql += ", recievedStatus";
    }
    if (conversation.hasOwnProperty('senderUserId')) {
        Values += ", '" + conversation.senderUserId + "'";
        sql += ", senderUserId";
    }
    if (conversation.hasOwnProperty('unreadMessageCount')) {
        Values += ", " + conversation.unreadMessageCount;
        sql += ", unreadMessageCount";
    }
    if (conversation.hasOwnProperty('receivedTime')) {
        Values += ", '" + conversation.receivedTime + "'";
        sql += ", receivedTime";
    }
    if (conversation.hasOwnProperty('sentTime')) {
        Values += ", '" + conversation.sentTime + "'";
        sql += ", sentTime";
    }
    if (conversation.hasOwnProperty('isTop')) {
        Values += ", " + conversation.isTop;
        sql += ", isTop";
    }
    if (conversation.hasOwnProperty('latestMessageId')) {
        Values += ", " + conversation.latestMessageId;
        sql += ", latestMessageId";
    }
    Values += ", '" + new Date().Format("yyyy-MM-dd hh:mm:ss") + "'";
    //Values += ", '2015-10-7 12:12:12'";
    sql += ", updateAt";
    
    sql += ") "
    Values += ");";
    sql += Values;
    insertSql(sql, function(){
        var rong = api.require(RONGYUN_SDK);
        rong.removeConversation({
            conversationType: conversation.conversationType,
            targetId: conversation.targetId+""
            }, function (ret, err) {
                consoledebug.log('rong removeConversation is ' + ret.status);
        })
        promise.resolve();
    }, function(err){
        promise.reject(err);
    });
    return promise;
}


function updateCacheConversationPromise(conversation) {
    var promise = new Bmob.Promise();
    
    var sql = "replace into " + CONVERSATION_TABLE_NAME + " set ";
    var targetId = 0;
    var conversationType;
    var Values = "";
    if (conversation.hasOwnProperty('targetId')) {
        targetId = conversation.targetId;
        Values += "targetId = " + conversation.targetId;
    }else{
        var err = {};
        err.code = 888;
        err.msg = "PRIMARY Key cannot be null";
        promise.reject(err);
        return;
    }
    if (conversation.hasOwnProperty('conversationTitle')) {
        Values += ", conversationTitle = '" + conversation.conversationTitle + "'";
    }
    if (conversation.hasOwnProperty('conversationType')) {
        conversationType = conversation.conversationType;
        Values += ", conversationType = '" + conversation.conversationType + "'";
    }
    if (conversation.hasOwnProperty('draft')) {
        Values += ", draft = " + conversation.draft;
    }
    if (conversation.hasOwnProperty('latestMessageText')) {
        Values += ", latestMessageText = '" + conversation.latestMessage.text + "'";
    }
    if (conversation.hasOwnProperty('latestMessageExtra')) {
        Values += ", latestMessageExtra = '" + conversation.latestMessage.extra + "'";
    }
    if (conversation.hasOwnProperty('sentStatus')) {
        Values += ", sentStatus = '" + conversation.sentStatus + "'";
    }
    if (conversation.hasOwnProperty('objectName')) {
        Values += ", objectName = '" + conversation.objectName + "'";
    }
    if (conversation.hasOwnProperty('recievedStatus')) {
        Values += ", recievedStatus = '" + conversation.recievedStatus + "'";
    }
    if (conversation.hasOwnProperty('senderUserId')) {
        Values += ", senderUserId = '" + conversation.senderUserId + "'";
    }
    if (conversation.hasOwnProperty('unreadMessageCount')) {
        Values += ", unreadMessageCount = " + conversation.unreadMessageCount;
    }
    if (conversation.hasOwnProperty('receivedTime')) {
        Values += ", receivedTime = " + conversation.receivedTime;
    }
    if (conversation.hasOwnProperty('sentTime')) {
        Values += ", sentTime = " + conversation.sentTime;
    }
    if (conversation.hasOwnProperty('isTop')) {
        Values += ", isTop = " + conversation.isTop;
    }
    if (conversation.hasOwnProperty('latestMessageId')) {
        Values += ", latestMessageId = " + conversation.latestMessageId;
    }
    Values += ", updateAt = '" + new Date().Format("yyyy-MM-dd hh:mm:ss") + "'";
    sql += Values + " WHERE targetId = " + targetId;
    updateSql(sql, function(){
        var rong = api.require(RONGYUN_SDK);
        rong.removeConversation({
            conversationType: conversationType,
            targetId: targetId+""
            }, function (ret, err) {
                consoledebug.log('rong removeConversation is ' + ret.status);
        })
        promise.resolve();
    }, function(err){
        consoledebug.log('updateCacheConversationPromise updateSql error is ' + err.msg);
        promise.reject(err);
    });
    return promise;
}


  /**
   * 更新对话列表信息集合到本地缓存
   * @param {Object[]} conversationList 用户对话列表 Json 对象数组
   * 包含的key 为：targetId, conversationTitle, conversationType, draft, latestMessage{text, extra}, sentStatus, objectName, recievedStatus, senderUserId, unreadMessageCount, receivedTime, sentTime, isTop, latestMessageId
   * @param {function} successCallback 成功插入列表后回调函数，定义为 .
   *        successCallback(); 
   * @param {function} errorCallback 操作失败后回调函数，定义为：
   *        errCallback(error); error is a class, {code: number, msg:string}
   */
function updateCacheConversationList(conversationList, successCallback, errorCallback){
	var promises = [];
	for (var i = 0; i < conversationList.length; i++) {
		promises.push(inertCacheConversationListPromis(conversationList[i]));
	}
	Bmob.Promise.when(promises).then(successCallback, errorCallback);
}

function removeConversation(targetId, successCallback, errorCallback){
    var sql = 'DELETE FROM ' + CONVERSATION_TABLE_NAME + ' WHERE targetId = "' + targetId + '"';
    deleteSql(sql, successCallback, errorCallback);
}

function clearComUnreadStatus(targetId, type, successCallback, errorCallback) {
    clearCacheUnread(targetId, function() {
        var rong = api.require(RONGYUN_SDK);
        rong.clearMessagesUnreadStatus({
            conversationType : type,
            targetId : targetId+""
        }, function(ret, err) {
            if (ret) {
                consoledebug.log('rong clearMessagesUnreadStatus is ' + ret.status);
            }
        });
        successCallback();
    }, function(err) {
        consoledebug.log('clearComUnreadStatus updateSql error is ' + err.msg);
        errorCallback(err);
    });
}


function addCacheUnreadCount(targetId, count, callback){
	var totalCount = 0;
	getCacheUnreadCount(targetId, function(unreadCount){
		totalCount = unreadCount + count;
		setCacheUnreadCount(targetId, totalCount, callback);
	},function(err){
		totalCount = count;
		insertCacheUnreadCount(targetId, totalCount);
        consoledebug.log('addCacheUnreadCount err is ' + err.msg);
	})
}

function setCacheUnreadCount(targetId, count, callback){
    var sql = "update " + UNREAD_TABLE_NAME + " set unreadMessageCount = " + count + ' WHERE targetId = "' + targetId + '"';
    updateSql(sql, function() {
    	//getCacheUnreadCount(targetId, function(){},function(){});
    	if(callback){
    		callback(count);
    	}
    },function(err){
        consoledebug.log('setCacheUnreadCount err is ' + err.msg);
    })
}

function insertCacheUnreadCount(targetId, count){
    var sql = "replace into " + UNREAD_TABLE_NAME + ' (targetId, unreadMessageCount) values("' + targetId + '", ' + count + ");";
    insertSql(sql, function() {
    	//getCacheUnreadCount(targetId, function(){},function(){});
    },function(err){
        consoledebug.log('insertCacheUnreadCount err is ' + err.msg);
    })
}

function clearCacheUnread(targetId){
	setCacheUnreadCount(targetId, 0);
}

function getCacheUnreadCount(targetId, successCallback, errorCallback){
	var myErr = {};
	var unreadMessageCount = 0;
    var sql = 'SELECT unreadMessageCount FROM ' + UNREAD_TABLE_NAME + ' WHERE targetId = "' + targetId + '"';
    selectSql(sql, function(conversationList){
    	if(conversationList.length > 0 && conversationList[0].unreadMessageCount){
    		unreadMessageCount = Number(conversationList[0].unreadMessageCount);
        	successCallback(unreadMessageCount);
    	} else {
    		myErr.code = 888;
    		myErr.msg = "selectSql length is 0";
    		errorCallback(myErr);
        	consoledebug.log('getCacheUnreadCount selectSql length is 0 ');
    	}
    }, function(err){
    	errorCallback(err);
        consoledebug.log('getCacheUnreadCount err is ' + err.msg);
    });
}



//////////////////////////////////////////// 组功能    ////////////////////////////////////////////////
function inertCacheGroupInfoPromis(groupInfo) {
	var promise = new Bmob.Promise();

	var sql = "insert or replace into " + GROUPS_TABLE_NAME + " (";
	var i = 0;
	var Values = "values(";
	if (groupInfo.hasOwnProperty('groupID')) {
		Values += groupInfo.groupID;
		sql += "groupID";
	}else{
        var err = {};
        err.code = 888;
        err.msg = "PRIMARY Key cannot be null";
		promise.reject(err);
		return;
	}
	if (groupInfo.hasOwnProperty('groupName')) {
		Values += ", '" + groupInfo.groupName + "'";
		sql += ", groupName";
	}
	if (groupInfo.hasOwnProperty('rongyunID')) {
		Values += ", '" + groupInfo.rongyunID + "'";
		sql += ", rongyunID";
	}
	if (groupInfo.hasOwnProperty('builderHHID')) {
		Values += ", " + groupInfo.builderHHID;
		sql += ", builderHHID";
	}
	if (groupInfo.hasOwnProperty('maintain')) {
		Values += ", " + groupInfo.maintain;
		sql += ", maintain";
	}
	if (groupInfo.hasOwnProperty('photo')) {
		Values += ", '" + groupInfo.photo + "'";
		sql += ", photo";
	}
	Values += ", '" + new Date().Format("yyyy-MM-dd hh:mm:ss") + "'";
	//Values += ", '2015-10-7 12:12:12'";
	sql += ", updateAt";
	
	sql += ") "
	Values += ");";
	sql += Values;
	insertSql(sql, function(){
		promise.resolve();
	}, function(err){
		promise.reject(err);
	});
	return promise;
}

  /**
   * 插入一条群组信息到本地缓存
   * @param {Object[]} groupInfos 组信息Json 对象数组
   * 包含的key 为：groupID, groupName, rongyunID, builderHHID, maintain, photo, updateAt
   * @param {function} successCallback 成功插入列表后回调函数，定义为 .
   * 		successCallback(); 
   * @param {function} errorCallback 操作失败后回调函数，定义为：
   * 		errCallback(error); error is a class, {code: number, msg:string}
   */
function inertCacheGroupInfos(groupInfos, successCallback, errorCallback) {
	var promises = [];
	for (var i = 0; i < groupInfos.length; i++) {
		promises.push(inertCacheGroupInfoPromis(groupInfos[i]));
	}
	Bmob.Promise.when(promises).then(successCallback, errorCallback);
}


function updateCacheGroupInfoPromise(groupInfo) {
	var promise = new Bmob.Promise();
	
	var sql = "update or replace " + GROUPS_TABLE_NAME + " set ";
	var hhID = 0;
	var Values = "";
	if (groupInfo.hasOwnProperty('groupID')) {
		hhID = groupInfo.groupID;
		Values += "groupID = " + groupInfo.groupID;
	}else{
        var err = {};
        err.code = 888;
        err.msg = "PRIMARY Key cannot be null";
        promise.reject(err);
		return;
	}
	if (groupInfo.hasOwnProperty('groupName')) {
		Values += ", groupName = '" + groupInfo.groupName + "'";
	}
	if (groupInfo.hasOwnProperty('rongyunID')) {
		Values += ", rongyunID = '" + groupInfo.rongyunID + "'";
	}
	if (groupInfo.hasOwnProperty('builderHHID')) {
		Values += ", builderHHID = " + groupInfo.builderHHID;
	}
	if (groupInfo.hasOwnProperty('maintain')) {
		Values += ", maintain = " + groupInfo.maintain;
	}
	if (groupInfo.hasOwnProperty('photo')) {
		Values += ", photo = '" + groupInfo.photo + "'";
	}
	Values += ", updateAt = '" + new Date().Format("yyyy-MM-dd hh:mm:ss") + "'";
	sql += Values + " WHERE hhID = " + hhID;
	updateSql(sql, function(){
		promise.resolve();
	}, function(err){
		promise.reject(err);
	});
	return promise;
}

  /**
   * 更新一组群组信息集合到本地缓存
   * @param {Object[]} groupInfos 群组信息Json 对象数组
   * 包含的key 为：groupID, groupName, rongyunID, builderHHID, maintain, photo, updateAt
   * @param {function} successCallback 成功插入列表后回调函数，定义为 .
   * 		successCallback(); 
   * @param {function} errorCallback 操作失败后回调函数，定义为：
   * 		errCallback(error); error is a class, {code: number, msg:string}
   */
function updateCacheGroupInfos(groupInfos, successCallback, errorCallback){
	var promises = [];
	for (var i = 0; i < groupInfos.length; i++) {
		promises.push(updateCacheGroupInfoPromise(groupInfos[i]));
	}
	Bmob.Promise.when(promises).then(successCallback, errorCallback);
}


  /**
   * 获取用户信息
   * @param {Number[]} rongyunIDs 群融云ID 数组
   * @param {function} successCallback 成功获取朋友列表后回调函数，定义为 .
   * 		successCallback(groupInfos); groupInfos 是 {Object[]} json 对象数组
   * 包含的key 为：groupID, groupName, rongyunID, builderHHID, maintain, photo, updateAt
   * @param {function} errorCallback 操作失败后回调函数，定义为：
   * 		errCallback(error); error is a class, {code: number, msg:string}
   */
function getCacheGroupInfo(rongyunIDs, successCallback, errorCallback){
	var containedIn = "";
	if(rongyunIDs.length == 0){
		consoledebug.log('getCacheGroupInfo error is length cannot be 0');
		var err = new Object();
		err.code = 888;
		err.msg = 'rongyunIDs length cannot be 0';
		errorCallback(err);
		return;
	}
	for(var i = 0; i<rongyunIDs.length - 1; i++){
		containedIn += "'" + rongyunIDs[i] + "', ";
	}
	containedIn += "'" + rongyunIDs[i] + "'";
	var sql = 'SELECT * FROM ' + GROUPS_TABLE_NAME + ' WHERE rongyunID IN ( ' + containedIn + ' );';
	selectSql(sql, function(groupInfos){
	   successCallback(groupInfos);
	}, errorCallback);
}

