//document.write('<script type="text/javascript" src="' + api.wgtRootDir+ '/script/cache/LocalDBCommon.js"></script>');

var USERINFO_TABLE_NAME = "UserInfo";
var FRIENDS_TABLE_NAME = "MyFriends";

  /**
   * 插入一条用户信息到本地缓存
   * @param {Object} userInfo 用户信息Json 对象
   * 包含的key 为：hhID, nickName, sex, age, level, appraisement, describe, livingPlace, photo 
   * @param {function} successCallback 成功插入列表后回调函数，定义为 .
   * 		successCallback(); 
   * @param {function} errorCallback 操作失败后回调函数，定义为：
   * 		errCallback(error); error is a class, {code: number, msg:string}
   */
function inertCacheUserInfo(userInfo, successCallback, errorCallback) {
	var sql = "insert or replace into " + USERINFO_TABLE_NAME + " (";
	var i = 0;
	var Values = "values(";
	if (userInfo.hasOwnProperty('hhID')) {
		Values += userInfo.hhID;
		sql += "hhID";
	}else{
	    var err = {};
	    err.code = 888;
	    err.msg = "PRIMARY Key cannot be null";
		errorCallback(err);
		return;
	}
	if (userInfo.hasOwnProperty('nickName')) {
		Values += ", '" + userInfo.nickName + "'";
		sql += ", nickName";
	}
	if (userInfo.hasOwnProperty('sex')) {
		Values += ", '" + userInfo.sex + "'";
		sql += ", sex";
	}
	if (userInfo.hasOwnProperty('age')) {
		Values += ", " + userInfo.age;
		sql += ", age";
	}
	if (userInfo.hasOwnProperty('level')) {
		Values += ", " + userInfo.level;
		sql += ", level";
	}
	if (userInfo.hasOwnProperty('appraisement')) {
		Values += ", " + userInfo.appraisement;
		sql += ", appraisement";
	}
	if (userInfo.hasOwnProperty('describe')) {
		Values += ", '" + userInfo.describe + "'";
		sql += ", describe";
	}
	if (userInfo.hasOwnProperty('livingPlace')) {
		Values += ", '" + userInfo.livingPlace + "'";
		sql += ", livingPlace";
	}
	if (userInfo.hasOwnProperty('photo')) {
		Values += ", '" + userInfo.photo + "'";
		sql += ", photo";
	}
	if (userInfo.hasOwnProperty('validateState')) {
		Values += ", " + userInfo.validateState;
		sql += ", validateState";
	}
	
	var lastReadTime = new Date().getTime();
	Values += ", " + lastReadTime;
	sql += ", lastReadTime";
//	Values += ", lastReadTime = " + lastReadTime;
//	sql += ", lastReadTime";
	
	Values += ", '" + new Date().Format("yyyy-MM-dd hh:mm:ss") + "'";
	sql += ", updateAt";
	
	sql += ") "
	Values += ");";
	sql += Values;
	insertSql(sql, successCallback, errorCallback);
}

function inertCacheUserInfoPromis(userInfo) {
	var promise = new Bmob.Promise();

	var sql = "insert or replace into " + USERINFO_TABLE_NAME + " (";
	var i = 0;
	var Values = "values(";
	if (userInfo.hasOwnProperty('hhID')) {
		Values += userInfo.hhID;
		sql += "hhID";
	}else{
        var err = {};
        err.code = 888;
        err.msg = "PRIMARY Key cannot be null";
		promise.reject(err);
		return;
	}
	if (userInfo.hasOwnProperty('nickName')) {
		Values += ", '" + userInfo.nickName + "'";
		sql += ", nickName";
	}
	if (userInfo.hasOwnProperty('sex')) {
		Values += ", '" + userInfo.sex + "'";
		sql += ", sex";
	}
	if (userInfo.hasOwnProperty('age')) {
		Values += ", " + userInfo.age;
		sql += ", age";
	}
	if (userInfo.hasOwnProperty('level')) {
		Values += ", " + userInfo.level;
		sql += ", level";
	}
	if (userInfo.hasOwnProperty('appraisement')) {
		Values += ", " + userInfo.appraisement;
		sql += ", appraisement";
	}
	if (userInfo.hasOwnProperty('describe')) {
		Values += ", '" + userInfo.describe + "'";
		sql += ", describe";
	}
	if (userInfo.hasOwnProperty('livingPlace')) {
		Values += ", '" + userInfo.livingPlace + "'";
		sql += ", livingPlace";
	}
	if (userInfo.hasOwnProperty('photo')) {
		Values += ", '" + userInfo.photo + "'";
		sql += ", photo";
	}
	if (userInfo.hasOwnProperty('validateState')) {
		Values += ", " + userInfo.validateState;
		sql += ", validateState";
	}
	
	var lastReadTime = new Date().getTime();
	Values += ", " + lastReadTime;
	sql += ", lastReadTime";
	
	Values += ", '" + new Date().Format("yyyy-MM-dd hh:mm:ss") + "'";
	//Values += ", '2015-10-7 12:12:12'";
	sql += ", updateAt";
	
	sql += ") "
	Values += ");";
	sql += Values;
	insertSql(sql, function(){
		promise.resolve();
	}, function(err){
		promise.reject(err);
	});
	return promise;
}

  /**
   * 插入一条用户信息到本地缓存
   * @param {Object[]} userInfo 用户信息Json 对象数组
   * 包含的key 为：hhID, nickName, sex, age, level, appraisement, describe, livingPlace, photo 
   * @param {function} successCallback 成功插入列表后回调函数，定义为 .
   * 		successCallback(); 
   * @param {function} errorCallback 操作失败后回调函数，定义为：
   * 		errCallback(error); error is a class, {code: number, msg:string}
   */
function inertCacheUserInfos(userInfos, successCallback, errorCallback) {
	beginTrans(function(){
//		var promise = Bmob.Promise.as();
//      $.each(userInfos, function(){
//          var result = this;
//          promise = promise.then(function() {
//				return inertCacheUserInfoPromis(result);
//          });
//      });
    	var promises = [];
        for(var i=0;i<userInfos.length;i++){
        	promises.push(inertCacheUserInfoPromis(userInfos[i]));
        }
		Bmob.Promise.when(promises).then(function(){
        //promise.then(function(){
			commitTrans(function(){
				successCallback();
			},function(err){
        		consoledebug.log('inertCacheUserInfos commitTrans error '+err.msg);
				errorCallback(err);
			});
        },function(err){
			commitTrans(function(){
				successCallback();
			},function(err){
        		consoledebug.log('inertCacheUserInfos commitTrans error '+err.msg);
				errorCallback(err);
			});
        	consoledebug.log('inertCacheUserInfos inertCacheUserInfoPromis error '+err.msg);
			//errorCallback(err);
        });
//		for(var i = 0; i < userInfos.length; i++){
//		    promise = promise.then(function() {
//				return inertCacheUserInfoPromis(userInfos[i]);
//		    });
//		}
	}, function(err){
		consoledebug.log('inertCacheUserInfos beginTrans error '+err.msg);
		errorCallback(err);
	});
}

  /**
   * 更新一组用户信息集合到本地缓存
   * @param {Object[]} userInfo 用户信息Json 对象数组
   * 包含的key 为：hhID, nickName, sex, age, level, appraisement, describe, livingPlace, photo 
   * @param {function} successCallback 成功插入列表后回调函数，定义为 .
   * 		successCallback(); 
   * @param {function} errorCallback 操作失败后回调函数，定义为：
   * 		errCallback(error); error is a class, {code: number, msg:string}
   */
function updateCacheUserInfos(userInfos, successCallback, errorCallback){
	beginTrans(function(){
//		var promise = Bmob.Promise.as();
//      $.each(userInfos, function(){
//          var result = this;
//          promise = promise.then(function() {
//				return updateCacheUserInfoPromise(result);
//          });
//      });
    	var promises = [];
        for(var i=0;i<userInfos.length;i++){
        	promises.push(updateCacheUserInfoPromise(userInfos[i]));
        }
		Bmob.Promise.when(promises).then(function(){
        //promise.then(function(){
			commitTrans(function(){
				successCallback();
			},function(err){
				consoledebug.log('updateCacheUserInfos commitTrans error '+err.msg);
				errorCallback(err);
			});
        },function(err){
			commitTrans(function(){
				successCallback();
			},function(err){
				consoledebug.log('updateCacheUserInfos commitTrans error '+err.msg);
				errorCallback(err);
			});
        	consoledebug.log('updateCacheUserInfos updateCacheUserInfoPromise error '+err.msg);
			//errorCallback(err);
        });
	}, function(err){
		consoledebug.log('updateCacheUserInfos beginTrans error '+err.msg);
		errorCallback(err);
	});
}
  /**
   * 更新一条用户信息到本地缓存
   * @param {Object} userInfo 用户信息Json 对象
   * 包含的key 为：hhID, nickName, sex, age, level, appraisement, describe, livingPlace, photo 
   * @param {function} successCallback 成功更新后回调函数，定义为 .
   * 		successCallback();
   * @param {function} errorCallback 操作失败后回调函数，定义为：
   * 		errCallback(error); error is a class, {code: number, msg:string}
   */
function updateCacheUserInfo(userInfo, successCallback, errorCallback) {
	var sql = "update or replace " + USERINFO_TABLE_NAME + " set ";
	var hhID = 0;
	var Values = "";
	if (userInfo.hasOwnProperty('hhID')) {
		hhID = userInfo.hhID;
		Values += "hhID = " + userInfo.hhID;
	}else{
        var err = {};
        err.code = 888;
        err.msg = "PRIMARY Key cannot be null";
        errorCallback(err);
		return;
	}
	if (userInfo.hasOwnProperty('nickName')) {
		Values += ", nickName = '" + userInfo.nickName + "'";
	}
	if (userInfo.hasOwnProperty('sex')) {
		Values += ", sex = '" + userInfo.sex + "'";
	}
	if (userInfo.hasOwnProperty('age')) {
		Values += ", age = " + userInfo.age;
	}
	if (userInfo.hasOwnProperty('level')) {
		Values += ", level = " + userInfo.level;
	}
	if (userInfo.hasOwnProperty('appraisement')) {
		Values += ", appraisement = " + userInfo.appraisement;
	}
	if (userInfo.hasOwnProperty('describe')) {
		Values += ", describe = '" + userInfo.describe + "'";
	}
	if (userInfo.hasOwnProperty('livingPlace')) {
		Values += ", livingPlace = '" + userInfo.livingPlace + "'";
	}
	if (userInfo.hasOwnProperty('photo')) {
		Values += ", photo = '" + userInfo.photo + "'";
	}
	if (userInfo.hasOwnProperty('validateState')) {
		Values += ", validateState = " + userInfo.validateState;
	}
	
	var lastReadTime = new Date().getTime();
	Values += ", lastReadTime = " + lastReadTime;
	
	Values += ", updateAt = '" + new Date().Format("yyyy-MM-dd hh:mm:ss") + "'";
	sql += Values + " WHERE hhID = " + hhID;
	updateSql(sql, successCallback, errorCallback);
}

function updateCacheUserInfoPromise(userInfo) {
	var promise = new Bmob.Promise();
	
	var sql = "update or replace " + USERINFO_TABLE_NAME + " set ";
	var hhID = 0;
	var Values = "";
	if (userInfo.hasOwnProperty('hhID')) {
		hhID = userInfo.hhID;
		Values += "hhID = " + userInfo.hhID;
	}else{
        var err = {};
        err.code = 888;
        err.msg = "PRIMARY Key cannot be null";
        promise.reject(err);
		return;
	}
	if (userInfo.hasOwnProperty('nickName')) {
		Values += ", nickName = '" + userInfo.nickName + "'";
	}
	if (userInfo.hasOwnProperty('sex')) {
		Values += ", sex = '" + userInfo.sex + "'";
	}
	if (userInfo.hasOwnProperty('age')) {
		Values += ", age = " + userInfo.age;
	}
	if (userInfo.hasOwnProperty('level')) {
		Values += ", level = " + userInfo.level;
	}
	if (userInfo.hasOwnProperty('appraisement')) {
		Values += ", appraisement = " + userInfo.appraisement;
	}
	if (userInfo.hasOwnProperty('describe')) {
		Values += ", describe = '" + userInfo.describe + "'";
	}
	if (userInfo.hasOwnProperty('livingPlace')) {
		Values += ", livingPlace = '" + userInfo.livingPlace + "'";
	}
	if (userInfo.hasOwnProperty('photo')) {
		Values += ", photo = '" + userInfo.photo + "'";
	}
	if (userInfo.hasOwnProperty('validateState')) {
		Values += ", validateState = " + userInfo.validateState;
	}
	
	var lastReadTime = new Date().getTime();
	Values += ", lastReadTime = " + lastReadTime;
	
	Values += ", updateAt = '" + new Date().Format("yyyy-MM-dd hh:mm:ss") + "'";
	sql += Values + " WHERE hhID = " + hhID;
	updateSql(sql, function(){
		promise.resolve();
	}, function(err){
		promise.reject(err);
		consoledebug.log('updateCacheUserInfoPromise 111  err is ' + JSON.stringify(err));
	});
	return promise;
}

  /**
   * 获取用户信息
   * @param {Number} hhIDs 用户 hhID 数组
   * @param {function} successCallback 成功获取朋友列表后回调函数，定义为 .
   * 		successCallback(userInfos); userInfos 是 {Object[]} json 对象数组
   * 包含的key 为：hhID, nickName, sex, age, level, appraisement, describe, livingPlace, photo 
   * @param {function} errorCallback 操作失败后回调函数，定义为：
   * 		errCallback(error); error is a class, {code: number, msg:string}
   */
function getCacheUserInfo(hhIDs, successCallback, errorCallback){
//	var hhIDs = [];
//	for(var i = 0; i < hhIDArray.length; i++){
//		if(hhIDArray[i]||hhIDArray[i] == 0){
//			hhIDs.push(hhIDArray[i]);
//		}
//	}
	var containedIn = "";
	if(hhIDs.length == 0){
		consoledebug.log('getCacheUserInfo error is length cannot be 0');
		var err = new Object();
		err.code = 888;
		err.msg = 'hhIDs length cannot be 0';
		errorCallback(err);
		return;
	}
	for(var i = 0; i<hhIDs.length - 1; i++){
		if(hhIDs[i]||hhIDs[i] == 0){
			containedIn += hhIDs[i] + ', ';
		}
	}
	containedIn += hhIDs[i];
	var sql = 'SELECT * FROM ' + USERINFO_TABLE_NAME + ' WHERE hhID IN ( ' + containedIn + ' );';
	selectSql(sql, function(userInfos){
	consoledebug.log("getCacheUserInfo selectSql is  "+JSON.stringify(userInfos));
	   var jsons = [];
	   UserInfoSqliteToJson(userInfos, jsons);
	   successCallback(jsons);
	}, errorCallback);
}


  /**
   * 初始化一条用户信息到本地缓存
   * @param {Number} hhID 用户ID
   * @param {String} sex  用户性别
   * @param {function} successCallback 成功更新后回调函数，定义为 .
   * 		successCallback();
   * @param {function} errorCallback 操作失败后回调函数，定义为：
   * 		errCallback(error); error is a class, {code: number, msg:string}
   */
function initCacheUserInfo(hhID, sex, nickName, successCallback, errorCallback){
	var userInfo = new Object();
	userInfo.hhID = hhID;
	userInfo.sex = sex;
	userInfo.nickName = nickName;
	//userInfo.age = hhID;
	userInfo.level = 1;
	userInfo.appraisement = 6;
	//userInfo.describe = hhID;
	//userInfo.livingPlace = hhID;
	//userInfo.photo = 'image/defaultAvatar.png';
	inertCacheUserInfo(userInfo, successCallback, errorCallback);
}


  /**
   * 更新我的朋友列表到本地缓存
   * @param {Object[]} friends 用户朋友列表
   * 包含的key 为：friendID, state, reason
   * @param {function} successCallback 成功更新后回调函数，定义为 .
   * 		successCallback();
   * @param {function} errorCallback 操作失败后回调函数，定义为：
   * 		errCallback(error); error is a class, {code: number, msg:string}
   */
function updateCacheMyFriends(friends, successCallback, errorCallback) {
	var sql = "update or replace " + FRIENDS_TABLE_NAME + " set ";
	var Values = "";
	if (friends.hasOwnProperty('friendID')) {
		Values += "friendID = " + friends.friendID;
	}else{
        var err = {};
        err.code = 888;
        err.msg = "PRIMARY Key cannot be null";
		errorCallback(err);
		return;
	}
	if (friends.hasOwnProperty('state')) {
		Values += ", state = '" + friends.state + "'";
	}
	if (friends.hasOwnProperty('reason')) {
		Values += ", reason = '" + friends.reason + "'";
	}
	Values += ", updateAt = '" + new Date().Format("yyyy-MM-dd hh:mm:ss") + "'";
	sql += Values;
	updateSql(sql, successCallback, errorCallback);
}

  /**
   * 获取我的朋友列表缓存
   * @param {function} successCallback 成功获取朋友列表后回调函数，定义为 .
   * 		successCallback(friends); friends 是 {Object[]} json 对象数组
   * 包含的key 为：friendID, state, reason
   * @param {function} errorCallback 操作失败后回调函数，定义为：
   * 		errCallback(error); error is a class, {code: number, msg:string}
   */
function getCacheMyFriends(successCallback, errorCallback){
	var sql = 'SELECT * FROM ' + FRIENDS_TABLE_NAME;
	selectSql(sql, successCallback, errorCallback);
}

  /**
   * 把从 sqlite 查到的数据转换成正常 json 对象。
   * AC 数据库查询的接口取出的数据都是字符串类型，数字类型的需要自己手工转
   * @param {function} successCallback 成功获取朋友列表后回调函数，定义为 .
   *        successCallback(friends); friends 是 {Object[]} json 对象数组
   * 包含的key 为：friendID, state, reason
   * @param {function} errorCallback 操作失败后回调函数，定义为：
   *        errCallback(error); error is a class, {code: number, msg:string}
   */
function UserInfoSqliteToJson(userInfos, jsonInfos){
    for(var i = 0; i < userInfos.length; i++){
        var json = {};
        json.hhID = Number(userInfos[i].hhID);
        json.age = Number(userInfos[i].age);
        json.level = Number(userInfos[i].level);
        json.appraisement = Number(userInfos[i].appraisement);
        json.nickName = userInfos[i].nickName;
        json.sex = userInfos[i].sex;
        json.describe = userInfos[i].describe;
        json.livingPlace = userInfos[i].livingPlace;
        json.photo = userInfos[i].photo;
        json.updateAt = userInfos[i].updateAt;
        jsonInfos.push(json);
    }
}

/*
 * 获取本地更新时的最早时间
 */
function getCacheUserInfoUpdatetime(successCallback, errorCallback){
    var sql = 'SELECT updateAt FROM ' + USERINFO_TABLE_NAME + " ORDER BY updateAt ASC LIMIT 1;";
    selectSql(sql, function(time){
    	//格式 ：[{"max(updateAt)":""}]
    	consoledebug.log('getCacheAllUserhhID selectSql time is ' + JSON.stringify(time));
        
        var earliestTime;
        if(time.length > 0){
        	earliestTime = time[0].updateAt;
        }
        successCallback(earliestTime);
    }, function(err){
    	errorCallback(err)
    });
}

/*
 * 获取本地缓存的所有用户的hhID
 */
function getAllCacheUserhhID(){
	var promise = new Bmob.Promise();
	var sql = 'SELECT hhID FROM ' + USERINFO_TABLE_NAME + " ORDER BY updateAt ASC";
	selectSql(sql, function(hhIDs){
		consoledebug.log('getCacheAllUserhhID selectSql hhIDs is ' + JSON.stringify(hhIDs));
		var hhIDArray = [];
		for(var i = 0; i < hhIDs.length; i++){
			var hhID = Number(hhIDs[i].hhID);
			hhIDArray.push(hhID);
		}
		promise.resolve(hhIDArray);
    }, function(err){
		promise.reject(error);
    });
    return promise;
}

/*
 * 获取本地缓存的所有用户的hhID
 */
function getAllCacheUserInfo(successCallback, errorCallback){
	var promise = new Bmob.Promise();
	var sql = 'SELECT * FROM ' + USERINFO_TABLE_NAME + " ORDER BY updateAt ASC";
	selectSql(sql, function(userInfo){
		successCallback(userInfo);
	}, function(error){
		errorCallback(error);
	});
}

/*
 * update更新时间
 */
function updateCacheUserInfoTime(userInfo,nowTime){
	var promise = new Bmob.Promise();
	
	var sql = "update or replace " + USERINFO_TABLE_NAME + " set ";
	var Values = "lastReadTime = " + nowTime;
	sql += Values;
	updateSql(sql, function(){
		promise.resolve();
	}, function(error){
		consoledebug.log('updateCacheordersPromise updateSql error is ' + error.msg);
        promise.reject(error);
	});
	return promise;
}


/*
 * 删除当前用户一个月内未读的用户
 * 
 */

function deleteCacheUserInfo(lastMonthTime, successCallback, errorCallback){
    var sql = 'DELETE FROM ' + USERINFO_TABLE_NAME + " WHERE lastReadTime < " + lastMonthTime;
    updateSql(sql, successCallback, errorCallback);
}




