
var RONGYUN_SDK = "rongCloud2";

    
var NTFMSG_ENROLL = '报名了您的求助';     //报名的通知消息
var NTFMSG_QUIT_ENROLL = '退出报名了';     //报名的通知消息
var NTFMSG_ORDER_CANCEL = '取消求助订单了';     //报名的通知消息
var NTFMSG_HELPER_CONFIRM = '选中您为帮助人了！';     //报名的通知消息
var NTFMSG_ONE_COMPLETE = '完成帮助了！'
var NTFMSG_ASKER_COMPLETE_ALL = '已经验收了！'
var NTFMSG_ASKER_COMPLETE_ONCE = '已经验收,并再次下单了！'
var NTFMSG_HELPER_COMPLETE_ONCE = '对订单进行了评价，并再次接单了！'
var NTFMSG_HELPER_COMPLETE_ALL = '对订单进行了评价！'

function sendCreateGroupEvent(){
    api.sendEvent({
    name: 'onCreateGroup'
    });
}

function transBeginTime(info) {
    if(info.applyDeadlineTime){
        if (info.applyDeadlineTime == "0") {
            info.applyDeadlineDate = "帮助开始时";
            info.applyDeadline = "帮助开始时";
        } else {
            info.applyDeadlineDate = (new Date(Number(info.applyDeadlineTime))).Format("yy-MM-dd hh:mm");
            info.applyDeadline = info.applyDeadlineDate;
        }
    }
    if(info.beginTime){
        if (info.beginTime == "0") {
            info.beginDate = "越快越好";
            info.beginTime = "越快越好";
        } else {
            info.beginDate = (new Date(Number(info.beginTime))).Format("yy-MM-dd hh:mm");
            info.beginTime = info.beginDate;
        }
    }
}

/**
 * 创建群
 *
 * @param {String} groupName 群名称
 * @param {String} rongyunID 融云IM 群ID
 * @param {function} successCallback 成功后回调函数，定义为 .
 *        successCallback(group); group 是 {Bmob.Object} 类，通过 group.get(key) 可获取值，
 *        可用的 key 有 "groupID", "builderHHID", "rongyunID", "groupName", "buildTime"
 * @param {function} errorCallback 操作失败后回调函数，定义为：
 *        errCallback(error); error is a class, {code: number, message:string}
 */
function createGroupBySystem(groupName, rongyunID, successCallback, errorCallback) {
    var myAcount = getMyAccount();
    if (myAcount) {
        newGroupID(function(groupID) {
            var Group = Bmob.Object.extend("Group");
            var group = new Group();
            group.set("builderHHID", myAcount.hhID);
            group.set("groupID", groupID);
            group.set("groupName", groupName);
            group.set("rongyunID", rongyunID);
            group.set("buildTime", new Date());
            group.set("maintain", 0);
            group.set("inSystemUse", 1);
            //添加数据，第一个入口参数是null
            group.save().then(function(group) {
                var GroupMembers = Bmob.Object.extend("GroupMembers");
                var groupMembers = new GroupMembers();
                groupMembers.set("hhID", myAcount.hhID);
                groupMembers.set("groupID", groupID);
                groupMembers.set("nickname", myAcount.nickName);
                groupMembers.set("state", 0);
                groupMembers.set("reason", "群主拉入");
                groupMembers.set("joinTime", new Date());
                groupMembers.set("noDisturb", false);
                groupMembers.set("status", 0);
                
                var UserInfo = Bmob.Object.extend("UserInfo");
                var bmobUserInfo = new UserInfo();
                bmobUserInfo.id = myAcount.userInfoId;
                groupMembers.set("userInfo", bmobUserInfo);
                //添加数据，第一个入口参数是null
                groupMembers.save().then(function(member){
                    successCallback(group);
                }, function(error){
                    consoledebug.log('createGroupBySystem groupMembers save error ' + JSON.stringify(error));
                    errorCallback(error);
                });
            }, function(error){
                consoledebug.log('createGroupBySystem group save error ' + JSON.stringify(error));
                errorCallback(error);
            });
        }, function(error){
            consoledebug.log('createGroupBySystem newGroupID error ' + JSON.stringify(error));
            errorCallback(error);
        });
    }
}

/**
 * 创建群
 * @param groupName 群名称
 * @param myhhID 自己的ID
 * @param {function} successCallback 成功获取朋友列表后回调函数，定义为 .
 *      successCallback(group); group 是 {Bmob.Object} 类型，群信息表记录
 * @param {function} errorCallback 操作失败后回调函数，定义为：
 *      errCallback(error); error is a class, {code: number, message:string}
 */
function orderCreateGroup(groupName, successCallback, errorCallback) {
    var rong = api.require(RONGYUN_SDK);
    rong.createDiscussion({
        name : groupName,
        userIdList : ['0']
    }, function(ret, err) {
        consoledebug.log("orderCreateGroup is 11111 " + groupName + " " + JSON.stringify(ret) + " " + JSON.stringify(err));
        if (ret && ret.status == 'success') {
            var groupid = ret.result.discussionId;
            createGroupBySystem(groupName, groupid, function(group) {
                consoledebug.log('建群结果：成功' + JSON.stringify(group));
                //sendCreateGroupEvent();
                successCallback(group);
            }, function(err) {
                consoledebug.log('建群结果：error' + JSON.stringify(err));
                errorCallback(err);
            });
        } else {
            consoledebug.log('orderCreateGroup rong.createDiscussion：error' + JSON.stringify(err));
            errorCallback(err);
        }
    })
}

function deleteCoversetion(rongyunID) {
	var rong = api.require(RONGYUN_SDK);
	rong.removeConversation({
		conversationType : 'DISCUSSION',
		targetId : rongyunID + ""
	}, function(ret, err) {
		if (ret) {
			api.sendEvent({
				name : 'onConversationDelete',
				extra : {
					targetId : rongyunID + "",
					type : 'DISCUSSION'
				}
			});
		}
	})
	rong.clearMessages({
		conversationType : 'DISCUSSION',
		targetId : rongyunID + ""
	}, function(ret, err) {
		//api.toast({ msg: ret.status });
	})
}

function orderDeleteGroup(rongyunID, successCallback, errorCallback){
    consoledebug.log("orderDeleteGroup rongyunID is  " + rongyunID);
    getGroupInfoByRyid(rongyunID, function(groupInfo){
        if(groupInfo.get('maintain') == 0){
        	deleteCoversetion(rongyunID);
            quitGroup(groupInfo.get('groupID'),function(){
                var rong = api.require(RONGYUN_SDK);
                rong.quitDiscussion({
                        discussionId: rongyunID+""
                    }, function (ret, err) {
                        api.sendEvent({
                        name: 'onGroupQuit',
                        extra: {targetId: rongyunID}
                        });
                        if (ret.status == 'success'){
                            consoledebug.log("orderDeleteGroup quitDiscussion success is  " + JSON.stringify(ret));
                        }
                        else{
                            consoledebug.log("orderDeleteGroup quitDiscussion err is  " + JSON.stringify(err));
                        }
                })
                successCallback();
            },function(error){
                consoledebug.log("orderDeleteGroup quitGroup error is  " + JSON.stringify(error));
                errorCallback(error);
            })
        }else{
            groupInfo.set("inSystemUse", 0);
        	groupInfo.save().then(function(){
				api.sendEvent({
					name : 'onCreateGroup'
				}); 
        	}, errorCallback);
        }
    },function(error){
        consoledebug.log("orderDeleteGroup getGroupInfoByRyid error is  " + JSON.stringify(error));
        errorCallback(error);
    })
}


function makeHelperGroup(groupRongID, helperList, groupID, successCallback, errorCallback){
	var rong = api.require(RONGYUN_SDK);
	rong.getDiscussion({
        discussionId: groupRongID+""
    }, function (ret, err) {
        if (ret.status == 'success'){
            consoledebug.log("makeHelperGroup getDiscussion is  " + JSON.stringify(ret));
        	var removeMemberList = ret.result.memberIdList;
        	var addMemberList = helperList.concat();
        	var myAccount = getMyAccount();
        	addMemberList.push(myAccount.hhID);
        	//找出需要从群中删除的报名人，找出还没有加群的报名人
        	for(var i=0;i<removeMemberList.length;i++){
        		removeMemberList[i] = Number(removeMemberList[i]);
        		for(var j=0;j<addMemberList.length;j++){
        			if(removeMemberList[i] == addMemberList[j]){
        				removeMemberList.splice(i,1);  
        				addMemberList.splice(j,1);  
        				i-=1;
        				break;
        			}
        		}
        	}
            
            rongAddMember(groupRongID, addMemberList, groupID, function(){
            	rongRemoveMember(groupRongID, removeMemberList, groupID, function(){
            		successCallback();
	            }, errorCallback)
            },errorCallback);
        } else{
            consoledebug.log("makeHelperGroup getDiscussion err is  " + JSON.stringify(err));
            errorCallback(err);
        }
	})
}

function rongAddMember(groupRongID, addMemberList, groupID, successCallback, errorCallback) {
	var rong = api.require(RONGYUN_SDK);
	if(addMemberList.length == 0){
		successCallback();
		return;
	}
	rong.addMemberToDiscussion({
		discussionId : groupRongID + "",
		userIdList : addMemberList
	}, function(ret, err) {
		//不管是否成功，都要执行后续操作
		addGroupMembers(groupID, addMemberList, function() {
			successCallback();
		}, function(error) {
			consoledebug.log("makeHelperGroup addGroupMembers err is  " + JSON.stringify(error));
			errorCallback(error);
		});
	});
}


function rongRemoveMember(groupRongID, removeMemberList, groupID, successCallback, errorCallback) {
	if(removeMemberList.length == 0){
		successCallback();
		return;
	}
	systemRemoveGroupMembers(groupID, removeMemberList, function() {
		removeRongyunMembers(groupRongID, removeMemberList, function() {
			successCallback();
		}, function(error) {
			consoledebug.log("makeHelperGroup removeRongyunMembers error is  " + JSON.stringify(error));
			errorCallback(error);
		})
	}, function(error) {
		consoledebug.log("makeHelperGroup removeGroupMembers error is  " + JSON.stringify(error));
		errorCallback(error);
	});
}


function comConfirmHelperDone(orderRecord, confirmList, groupID, successCallback, errorCallback) {
	syncCacheOrderState(orderRecord.get('orderID'), 0, ASKER_ORDER_RUNNING, function() {
		freashRunningOrderCall();
	}, function(error) {
	});
	makeHelperGroup(orderRecord.get('groupID'), confirmList, groupID, function() {
        var myname = getMyAccount().nickname
        var loserList = gCandidatehhIDs.concat();
        for(var i=0;i<confirmList.length;i++){
        	loserList.remove(confirmList[i]);
        }
		for(var i=0;i<loserList.length;i++){
			sendLoseSeatNotify(orderRecord.get('orderID'), loserList[i], myname);
		}
		var msg = {
			orderID : orderRecord.get('orderID'), //订单ID
			orderType : 0, //0为求助，1为秀场，2为活动
			state : OPERATION_ASKER_SELECT, //操作状态
			notifyText : myname + NTFMSG_HELPER_CONFIRM //用户的提示消息文本
		} 
		sendOrderNotificationMsgGroup(orderRecord.get('groupID'), msg, function() {
			successCallback();
		}, function(error) {
        	successCallback();
		});
	}, errorCallback);
}


function sendLoseSeatNotify(orderID, receiverID, senderName) {
	var msg = {
		orderID : orderID, //订单ID
		orderType : 0, //0为求助，1为秀场，2为活动
		state : OPERATION_ASKER_SELECT, //变化后的状态
		notifyText : senderName + "没有选您为帮助人" //用户的提示消息文本
	}
	sendOrderNotificationMsg(receiverID, msg, function() {
	}, function() {
	}); 
}


/**
 * 我的正在报名中的求助列表
 * @param ownerID
 * @param {function} successCallback 成功获取朋友列表后回调函数，定义为 .
 * 		successCallback(results); results 是 {Bmob.Object} 对象数组，通过 results[x].get(key) 可获取值，
 * 		可用的 key 有 "orderID","orderName","payment","helperNum","helperSex","applyDeadline","place","description",
 * 		"photo","state"
 * @param {function} errorCallback 操作失败后回调函数，定义为：
 * 		errCallback(error); error is a class, {code: number, message:string}
 * @constructor
 */
function comGetMyInviteOrders(ownerID,successCallback, errorCallback){
	getInviteOrders(ownerID, successCallback, errorCallback);
}

/**
 * 我的正在进行中的求助列表
 * @param hhID
 * @param {function} successCallback 成功获取朋友列表后回调函数，定义为 .
 *      successCallback(results); results 是 {Object} 对象数组，
 *      可用的 key 有 包含的key 为：orderID, orderName, classID, beginTime, place, state, notify, ownership, orderType, updateAt
 * @param {function} errorCallback 操作失败后回调函数，定义为：
 *      errCallback(error); error is a class, {code: number, message:string}
 * @constructor
 */
function comGetRunningOrders(hhID, successCallback, errorCallback){
	var needUpdateOrders = [];
	getCacheOrders(function(locOrders) {
		consoledebug.log('comGetRunningOrders getCacheOrders locOrders is ' + JSON.stringify(locOrders));
		successCallback(locOrders);
	}, errorCallback);

	updataHelpOrders(hhID, function(helpOrderList) {
		updataActiveOrders(hhID, function(activeOrderList) {
			if (helpOrderList.length > 0 || activeOrderList.length > 0) {
				getCacheOrders(function(locOrders) {
					consoledebug.log('comGetRunningOrders update getCacheOrders locOrders is ' + JSON.stringify(locOrders));
					successCallback(locOrders);
				}, errorCallback);
			}
		}, errorCallback);
	}, errorCallback);
}

function comGetRunningOrdersV2(hhID, successCallback, errorCallback){
	getEarliestUpdatetimeCacheOrder(function(lastUpdateTime){
		var nowTime = new Date();
		
		var acitvityPromise = getNewRunningActivity(hhID, lastUpdateTime);
		var helpPromise = getNewRunningOrders(hhID, lastUpdateTime);
		var acitvityLocalPromise = getCacheTypeOrders(1);
		var helpLocalPromise = getCacheTypeOrders(0);
		
		var acitvPromises = [acitvityPromise, acitvityLocalPromise];
		var helpPromises = [helpPromise, helpLocalPromise];
		
		var ActivityDonePromise = new Bmob.Promise();
		var helpDonePromise = new Bmob.Promise();
	    var promises = [ActivityDonePromise, helpDonePromise];
	    var updateLocolOrders = [];
	    var insertLocolOrders = [];
	    	
		Bmob.Promise.when(acitvPromises).then(function(activeOrderList, acitveLocalMap){
			makeActivityOrdersLocalData(hhID, activeOrderList, function(activityLocal){
				for(var i=0; i<activityLocal.length; i++){
					if(acitveLocalMap[activityLocal[i].orderID]){
						updateLocolOrders.push(activityLocal[i]);
					}else{
						insertLocolOrders.push(activityLocal[i]);
					}
				}
				ActivityDonePromise.resolve();
			},function(error){
				consoledebug.log('comGetRunningOrdersV2 makeActivityOrdersLocalData error is ' + JSON.stringify(error));
	        	ActivityDonePromise.reject(error);
			})
		},function(error){
			consoledebug.log('comGetRunningOrdersV2 acitvPromises when error is ' + JSON.stringify(error));
	        ActivityDonePromise.reject(error);
		});
		
		Bmob.Promise.when(helpPromises).then(function(helpOrderList, helpLocalMap){
			makeHelpOrdersLocalData(hhID, helpOrderList, function(helpLocal){
				for(var i=0; i<helpLocal.length; i++){
					if(helpLocalMap[helpLocal[i].orderID]){
						updateLocolOrders.push(helpLocal[i]);
					}else{
						insertLocolOrders.push(helpLocal[i]);
					}
				}
				helpDonePromise.resolve();
			},function(error){
				consoledebug.log('comGetRunningOrdersV2 makeHelpOrdersLocalData error is ' + JSON.stringify(error));
	        	helpDonePromise.reject(error);
			})
		},function(error){
			consoledebug.log('comGetRunningOrdersV2 helpPromises when error is ' + JSON.stringify(error));
	        helpDonePromise.reject(error);
		});
		
		Bmob.Promise.when(promises).then(function(){
			var localPromise1 = Bmob.Promise.as();
			var localPromise2 = Bmob.Promise.as();
			if (updateLocolOrders.length > 0) {
				localPromise1 = updateCacheMyOrders(updateLocolOrders);
			}
			if (insertLocolOrders.length > 0) {
				localPromise2 = insertCacheOrders(insertLocolOrders);
			}
			var localPromises = [localPromise1, localPromise2];
			Bmob.Promise.when(localPromises).then(function() {
				var strNowDate = nowTime.Format("yyyy-MM-dd hh:mm:ss");
				setUpdatetimeCacheOrder(strNowDate, function(){
					getCacheOrders(function(locOrders) {
						consoledebug.log('comGetRunningOrdersV2 update getCacheOrders locOrders is ' + JSON.stringify(locOrders));
						successCallback(locOrders);
					}, errorCallback);
				},function(){});
			}, function(error) {
				consoledebug.log('comGetRunningOrdersV2 localPromises when error is ' + JSON.stringify(error));
				getCacheOrders(function(locOrders) {
					consoledebug.log('comGetRunningOrdersV2 update getCacheOrders locOrders is ' + JSON.stringify(locOrders));
					successCallback(locOrders);
				}, errorCallback);
			}); 
		},function(error){
			consoledebug.log('comGetRunningOrdersV2 promises when error is ' + JSON.stringify(error));
			getCacheOrders(function(locOrders) {
				consoledebug.log('comGetRunningOrdersV2 update getCacheOrders locOrders is ' + JSON.stringify(locOrders));
				successCallback(locOrders);
			}, errorCallback);
		});
	},function(){});
}

//wzg修改*********************************************************

/**
 * 我的正在进行中的求助列表
 * @param hhID
 * @param {function} successCallback 成功获取朋友列表后回调函数，定义为 .
 *      successCallback(results); results 是 {Object} 对象数组，
 *      可用的 key 有 包含的key 为：orderID, orderName, classID, beginTime, place, state, notify, ownership, orderType, updateAt
 * @param {function} errorCallback 操作失败后回调函数，定义为：
 *      errCallback(error); error is a class, {code: number, message:string}
 * @constructor
 */
function makeHelpOrdersLocalData(hhID, needUpdateOrders, successCallback, errorCallback) {
	var aDates = [];
	var helperOrderIDs = [];
	keys = ["orderID", "ownerID", "orderName", "classID", "applyDeadlineTime", "place", "beginTime", "state"];
	for (var i = 0; i < needUpdateOrders.length; i++) {
		var objDate = {};
		bmob2Obj(keys, needUpdateOrders[i], objDate);
		if (objDate.state == 1 && objDate.applyDeadlineTime != "0") {//正在报名中
			objDate.beginTime = objDate.applyDeadlineTime;
		}
		if (objDate.ownerID == hhID) {
			objDate.ownership = 0;
		} else {
			objDate.ownership = 1;
			helperOrderIDs.push(objDate.orderID);
		}
		objDate.orderType = 0;
		objDate.notify = 0;
		aDates.push(objDate);
		consoledebug.log("GetRunningOrders is " + JSON.stringify(objDate));
	}
	//如果需要更新的订单中，有自己是帮助人的订单，则此订单的状态需要从 helperList 表中查出
	if (helperOrderIDs.length > 0) {
		GetHelperOrdersState(hhID, helperOrderIDs, function(helperList) {
			consoledebug.log("comGetRunningOrders helperList is " + JSON.stringify(helperList));
			var j = 0;
			for (var i = 0; i < aDates.length; i++) {
				if (aDates[i].orderID == helperList[j].get('orderID')) {
					aDates[i].state = helperList[j++].get('state');
					if (j >= helperList.length)
						break;
				}
			}
			consoledebug.log("comGetRunningOrders aDates is " + JSON.stringify(aDates));
			successCallback(aDates);
		}, function(error) {
			consoledebug.log("comGetRunningOrders GetHelperOrdersState error is " + JSON.stringify(error));
			errorCallback(error);
		});
	} else {
		successCallback(aDates);
	}
}


function updataHelpOrders(hhID, successCallback, errorCallback){
	var needUpdateOrders = [];
	var allOrders = [];
	getCacheTypeOrders(0, function(locOrders) {
		allOrders = locOrders;
		consoledebug.log('comGetRunningOrders getCacheOrders helpOrders is '+ JSON.stringify(allOrders));
		GetRunningOrders(hhID, function(orderList) {
			consoledebug.log('comGetRunningOrders local date less then wanted ' + orderList.length +" "+ locOrders.length);
			if (orderList.length > locOrders.length) {
				consoledebug.log('comGetRunningOrders local date less then wanted ' + orderList.length +" "+ locOrders.length);
				if(locOrders.length == 0){
					needUpdateOrders = orderList;
				}else{
					for (var i = 0; i < orderList.length; i++) {
						for (var j = 0; j < locOrders.length; j++) {
							if (locOrders[j].orderID == orderList[i].get("orderID")) {
								break;
							}
						}
						if (j >= locOrders.length) {
							needUpdateOrders.push(orderList[i]);
						}
					}
				}
			}else{
				consoledebug.log('comGetRunningOrders need not update ' + orderList.length);
//				return;
			}
			consoledebug.log('comGetRunningOrders need update is ' + needUpdateOrders.length + JSON.stringify(needUpdateOrders));
			
			var aDates = [];
            var helperOrderIDs = [];
			keys = ["orderID", "ownerID", "orderName", "classID", "applyDeadlineTime", "place", "beginTime", "state"];
			for (var i = 0; i < needUpdateOrders.length; i++) {
				var objDate = {};
				bmob2Obj(keys, needUpdateOrders[i], objDate);
				if(objDate.state == 1 && objDate.applyDeadlineTime != "0"){		//正在报名中
					objDate.beginTime = objDate.applyDeadlineTime;
				}
				if(objDate.ownerID == hhID){
					objDate.ownership = 0;
				}else{
					objDate.ownership = 1;
					helperOrderIDs.push(objDate.orderID);
				}
				objDate.orderType = 0;
				objDate.notify = 0;
				aDates.push(objDate);
				allOrders.push(objDate);
				consoledebug.log("GetRunningOrders is " + JSON.stringify(objDate));
			}
			//如果需要更新的订单中，有自己是帮助人的订单，则此订单的状态需要从 helperList 表中查出
			if(helperOrderIDs.length > 0){
                GetHelperOrdersState(hhID, helperOrderIDs, function(helperList){
                    consoledebug.log("comGetRunningOrders helperList is " + JSON.stringify(helperList));
                    var j=0;
                    for(var i=0;i<aDates.length;i++){
                        if(aDates[i].orderID == helperList[j].get('orderID')){
                            aDates[i].state = helperList[j++].get('state');
                            if(j >= helperList.length)
                                break;
                        }
                    }
                    consoledebug.log("comGetRunningOrders aDates is " + JSON.stringify(aDates));
                    insertCacheOrders(aDates, function(){
                        successCallback(allOrders);
                    },function(err){
                        consoledebug.log("comGetRunningOrders insertCacheOrders error is " + JSON.stringify(err));
                    	successCallback(allOrders);
                    })
                },function(error){
                    consoledebug.log("comGetRunningOrders GetHelperOrdersState error is " + JSON.stringify(error));
                    successCallback(allOrders);
                });
			}else {
                insertCacheOrders(aDates, function(){
                    successCallback(allOrders);
                },function(err){
                    consoledebug.log("insertCacheOrders error is " + JSON.stringify(err));
                    successCallback(allOrders);
                })
			}
		}, function(error) {
			consoledebug.log("GetRunningOrders fail " + JSON.stringify(error));
            successCallback(allOrders);
		})
	}, errorCallback);
}

function makeActivityOrdersLocalData(hhID, needUpdateOrders, successCallback, errorCallback) {
	var aDates = [];
	var helperOrderIDs = [];
	keys = ["orderID", "ownerID", "orderName", "classID", "applyDeadline", "place", "beginTime", "state", "activityID", "activityName"];
	for (var i = 0; i < needUpdateOrders.length; i++) {
		var objDate = {};
		bmob2Obj(keys, needUpdateOrders[i], objDate);
		if (objDate.state == 1) {//正在报名中
			objDate.beginTime = objDate.applyDeadline;
		}
		if (objDate.ownerID == hhID) {
			objDate.ownership = 2;
			objDate.orderID = objDate.activityID;
			consoledebug.log("objDate.orderID is " + objDate.orderID)
			objDate.orderName = objDate.activityName;
		} else {
			objDate.ownership = 3;
			objDate.orderID = objDate.activityID;
			consoledebug.log("objDate.orderID is " + objDate.orderID)
			objDate.orderName = objDate.activityName;
			helperOrderIDs.push(objDate.orderID);
		}
		objDate.orderType = 1;
		objDate.notify = 0;
		aDates.push(objDate);
		consoledebug.log("GetRunningOrders is " + JSON.stringify(objDate));
	}
	//如果需要更新的订单中，有自己是帮助人的订单，则此订单的状态需要从 helperList 表中查出
	if (helperOrderIDs.length > 0) {
		GetActivityOrdersState(hhID, helperOrderIDs, function(helperList) {
			consoledebug.log("makeActivityOrdersLocalData Activity is " + JSON.stringify(helperList));
			var j = 0;
			for (var i = 0; i < aDates.length; i++) {
				if (aDates[i].orderID == helperList[j].get('orderID')) {
					aDates[i].state = helperList[j++].get('state');
					if (j >= helperList.length)
						break;
				}
			}
			consoledebug.log("makeActivityOrdersLocalData aDates is " + JSON.stringify(aDates));
			successCallback(aDates);
		}, function(error) {
			consoledebug.log("makeActivityOrdersLocalData GetActivityOrdersState error is " + JSON.stringify(error));
			errorCallback(error);
		});
	} else {
		successCallback(aDates);
	}
}


function updataActiveOrders(hhID, successCallback, errorCallback){
	var needUpdateOrders = [];
	var allOrders = [];
	getCacheTypeOrders(1, function(locOrders) {
		allOrders = locOrders;
		consoledebug.log('comGetRunningOrders getCacheOrders allOrders is '+ JSON.stringify(allOrders));
		GetRunningActivity(hhID, function(orderList) {
			consoledebug.log('comGetRunningOrders local date less then wanted ' + orderList.length +" "+ locOrders.length);
			if (orderList.length > locOrders.length) {
				consoledebug.log('comGetRunningOrders local date less then wanted ' + orderList.length +" "+ locOrders.length);
				if(locOrders.length == 0){
					needUpdateOrders = orderList;
				}else{
					for (var i = 0; i < orderList.length; i++) {
						for (var j = 0; j < locOrders.length; j++) {
							if (locOrders[j].orderID == orderList[i].get("orderID")) {
								break;
							}
						}
						if (j >= locOrders.length) {
							needUpdateOrders.push(orderList[i]);
						}
					}
				}
			}else{
				consoledebug.log('comGetRunningOrders need not update ' + orderList.length);
				return;
			}
			consoledebug.log('comGetRunningOrders need update is ' + needUpdateOrders.length + JSON.stringify(needUpdateOrders));
			
			var aDates = [];
            var helperOrderIDs = [];
			keys = ["orderID", "ownerID", "orderName", "classID", "applyDeadline", "place", "beginTime", "state","activityID","activityName"];
			for (var i = 0; i < needUpdateOrders.length; i++) {
				var objDate = {};
				bmob2Obj(keys, needUpdateOrders[i], objDate);
				if(objDate.state == 1){		//正在报名中
					objDate.beginTime = objDate.applyDeadline;
				}
				if(objDate.ownerID == hhID){
					objDate.ownership = 2;
					objDate.orderID = objDate.activityID;
					consoledebug.log("objDate.orderID is " + objDate.orderID)
					objDate.orderName = objDate.activityName;
				}else{
					objDate.ownership = 3;
					objDate.orderID = objDate.activityID;
					consoledebug.log("objDate.orderID is " + objDate.orderID)
					objDate.orderName = objDate.activityName;
					helperOrderIDs.push(objDate.orderID);
				}
				objDate.orderType = 1;
				objDate.notify = 0;
				aDates.push(objDate);
				allOrders.push(objDate);
				consoledebug.log("GetRunningOrders is " + JSON.stringify(objDate));
			}
			//如果需要更新的订单中，有自己是帮助人的订单，则此订单的状态需要从 helperList 表中查出
			if(helperOrderIDs.length > 0){
                GetActivityOrdersState(hhID, helperOrderIDs, function(helperList){
                    consoledebug.log("comGetRunningOrders helperList is " + JSON.stringify(helperList));
                    var j=0;
                    for(var i=0;i<aDates.length;i++){
                        if(aDates[i].orderID == helperList[j].get('orderID')){
                            aDates[i].state = helperList[j++].get('state');
                            if(j >= helperList.length)
                                break;
                        }
                    }
                    consoledebug.log("comGetRunningOrders aDates is " + JSON.stringify(aDates));
                    insertCacheOrders(aDates, function(){
                        successCallback(allOrders);
                    },function(err){
                        consoledebug.log("comGetRunningOrders insertCacheOrders error is " + JSON.stringify(err));
                        successCallback(allOrders);
                    })
                },function(error){
                    consoledebug.log("comGetRunningOrders GetHelperOrdersState error is " + JSON.stringify(error));
                        successCallback(allOrders);
                });
			}else {
                insertCacheOrders(aDates, function(){
                    successCallback(allOrders);
                },function(err){
                    consoledebug.log("insertCacheOrders error is " + JSON.stringify(err));
                    successCallback(allOrders);
                })
			}
		}, function(error) {
			consoledebug.log("GetRunningOrders fail " + JSON.stringify(error));
            successCallback(allOrders);
		})
	}, errorCallback);
}

//wzg修改***************************************************************************

/**
 * 更新一个我的正在进行中的求助信息
 * @param orderID
 * @param {function} successCallback 成功获取朋友列表后回调函数，定义为 .
 *      successCallback(); results 是 {Object} 对象数组，
 * @param {function} errorCallback 操作失败后回调函数，定义为：
 *      errCallback(error); error is a class, {code: number, message:string}
 * @constructor
 */
function comUpdateOneRunningOrder(orderID, orderType, successCallback, errorCallback){
    getOneCacheOrder(orderID, function(orderInfo){
    	if(orderInfo == undefined){
    		successCallback();
    		return;
    	}
        if(orderInfo.ownership == 0){
            GetAskerOrderState(orderID, function(state){
                setCacheOrderNewState(orderID, orderType, state, successCallback, errorCallback);
            },function(error){
                errorCallback(error);
            })
        }else if (orderInfo.ownership == 1){
            GetHelperOrderState(orderID, function(state){
                setCacheOrderNewState(orderID, orderType, state, successCallback, errorCallback);
            },function(error){
                errorCallback(error);
            })
        }else if (orderInfo.ownership == 2){
            GetAskerActiveOrderState(orderID, function(state){
                setCacheOrderNewState(orderID, orderType, state, successCallback, errorCallback);
            },function(error){
                errorCallback(error);
            })
        }else if (orderInfo.ownership == 3){
            GetHelperActiveOrderState(orderID, function(state){
                setCacheOrderNewState(orderID, orderType, state, successCallback, errorCallback);
            },function(error){
                errorCallback(error);
            })
        }
    },function(error){
        var myAccount = getMyAccount();
        comGetRunningOrdersV2(myAccount.hhID, successCallback, errorCallback);
    })
}

/**
 * 发布帮助信息
 * @param {Object} helpInfo:  类对象，求助信息
 * 包含的属性 为：{
 *              orderType: Number,        //订单模板，0为一般求助，1为出行类，2为职场类，3为爱好类
 *              orderName: String,        //订单名称
 *              ownerID: Number,        //求助人ID
 *              classID: Number,        //求助类别ID，为互助二级分类表中的ID
 *              groupID: Number,        //群ID
 *              payment: Number,        //报酬
 *              helperNum: Number,        //帮忙人数
 *              helperSex: String,        //帮忙人性别,0为不限，1为男性，2为女性
 *              applyDeadline: String,        //报名截止时间
 *              beginTime: String,        //帮助开始时间
 *              place: String,        //帮助地点
  *             selectMode: Number,        //候选人选择，0为自己手选，1为系统推荐，3为先来先得
  *             privacyMode: Number,        //隐私，0为所有人可见，1为指定人可见
  *             repeatMode: Number,        //重复任务，0为单次任务，1为重复任务
  *             description: String,      //任务描述
  *             dataurl: String,      //照片的64位编码
  *             orderGeo: String,      //任务位置，数据类型为Geo，为任务地点坐标
  *             messageOne: String,      //额外信息1，如订单为出行类，则为帮助人年龄；如订单为职场类，则为学历，如订单为爱好类，则0为教练，1为陪练
  *             messageTwo: String,      //额外信息2，如订单为出行类，则为帮助时长；如订单为职场类，则为行业，如订单为爱好类，则为空
  *             messageThree: String,      //额外信息3，如订单为出行类，则为有无私家车，0为没有，1为有；如订单为职场类，则为职业，如订单为爱好类，则为空
  *             messageFour: String,      //额外信息4，如订单为出行类，则为车辆等级；如订单为职场类，则为工作年限，如订单为爱好类，则为空
  *             messageFive: String,      //额外信息5，如订单为出行类，则为驾龄；如订单为职场类，则为公司，如订单为爱好类，则为空
  *             }
 * @param {function} successCallback 成功后回调函数，定义为 .
 * 		successCallback(helpOrder.orderID);helpOrder.orderID为订单编号
 * @param {function} errorCallback 操作失败后回调函数，定义为：
 * 		errCallback(error); error is a class, {code: number, message:string}
 */
function comIssueHelpOrder(helpInfo, groupName, successCallback, errorCallback){
    consoledebug.log("comIssueHelpOrder helpInfo is " + JSON.stringify(helpInfo));
    orderCreateGroup(groupName, function(group){
        helpInfo.group = group;
        helpInfo.groupID = group.get('rongyunID');
        insertHelpOrder(helpInfo, function(helpOrder){
        	consoledebug.log("comIssueHelpOrder insertHelpOrder photo 333333333 is " + helpOrder.get("photo"));
        	consoledebug.log("comIssueHelpOrder insertHelpOrder tPhoto 333333333 is " + helpOrder.get("tPhoto"));
			clearTempFiles(function(){});
            successCallback(helpOrder);
        },function(error){
            consoledebug.log("comIssueHelpOrder insertHelpOrder error is " + JSON.stringify(error));
			clearTempFiles(function(){});
            errorCallback(error);
        })
    },function(error){
        consoledebug.log("comIssueHelpOrder orderCreateGroup error is " + JSON.stringify(error));
		clearTempFiles(function(){});
        errorCallback(error);
    });
}

function comInsertCacheOrders(helpInfo, orderID, successCallback, errorCallback) {
	var localOrder = {};
	localOrder.orderID = orderID;
	localOrder.orderName = helpInfo.orderName;
	localOrder.classID = helpInfo.classID + '';
	localOrder.beginTime = helpInfo.applyDeadlineTime;
	localOrder.place = helpInfo.place;
	localOrder.orderGeo = helpInfo.orderGeo;
	localOrder.applyDeadlineTime = helpInfo.applyDeadlineTime;
	localOrder.ownership = 0;
	localOrder.orderType = 0;
	localOrder.state = 1;
	localOrder.notify = 0;
	consoledebug.log("comInsertCacheOrders localOrder is " + JSON.stringify(localOrder));
	var aOrders = [];
	aOrders.push(localOrder);
	insertCacheOrders(aOrders, function() {
		setTimeout(function() {
			freashRunningOrderCall();	//可能是时间不够，直接调用无法刷新
		}, 100)
        //freashRunningOrderCall();		
		successCallback();
	}, function(err) {
		consoledebug.log("comInsertCacheOrders error is " + JSON.stringify(err));
		//err.message = err.msg;
		errorCallback(err);
	});
}


function freashRunningOrderCall(){
//  api.execScript({
//      name : 'root',
//      frameName : 'waying',
//      script : 'freashRunningOrder()'
//  });
    api.sendEvent({
        name : 'comIssueHelpOrder',
        extra : {
        }
    });
}

/**
 * 报名
 * @param orderTable {Bmob.Object} bmob SDK 查询出来的 ‘HelpOrder’ 表的对象
 * @param myHhID {Number} 自己的 hhID
 * @param entryfee {Number} 报名费
 * @param {function} successCallback 成功获取朋友列表后回调函数，定义为 .
 *      successCallback(results); results 是 {Object} 对象数组，
 *      可用的 key 有 包含的key 为：orderID, orderName, classID, beginTime, place, state, notify, ownership, orderType, updateAt
 * @param {function} errorCallback 操作失败后回调函数，定义为：
 *      errCallback(error); error is a class, {code: number, message:string}
 * @constructor
 */
//function comHelpEnroll(orderTable, myHhID, entryfee, successCallback, errorCallback) {
//	if(orderTable.get("ownerID") == myHhID){
//		var error = {};
//		error.code = 888;
//		error.massage = 'order owner cannot to enroll';
//		errorCallback(error);
//		return;
//	}
//	
//	InserthelpEnroll(orderTable, myHhID, entryfee, function(helperList) {
//		keys = ["orderID", "ownerID", "orderName", "classID", "applyDeadline", "place", "beginTime", "state"];
//		var objDate = {};
//		bmob2Obj(keys, orderTable, objDate);
//		if (objDate.state == 1) {//正在报名中
//			objDate.beginTime = objDate.applyDeadline;
//		}
//		objDate.ownership = 1;	//帮助人
//		objDate.orderType = 0;
//		objDate.notify = 0;
//		var aDates = [];
//		aDates.push(objDate);
//		consoledebug.log("GetRunningOrders is " + JSON.stringify(objDate));
//		insertCacheOrders(aDates, function() {
//          freashRunningOrderCall();
//          var msg = {
//              orderID : objDate.orderID, //订单ID
//              orderType : 0, //0为求助，1为秀场，2为活动
//              state : OPERATION_HELPER_ENROLL, 
//              notifyText : getMyAccount().nickname + NTFMSG_ENROLL,  //用户的提示消息文本
//              rongyunID : orderTable.get("groupID")
//          }
//          sendOrderNotificationMsg(orderTable.get("ownerID"), msg, function() {
//              successCallback(helperList);
//          }, function() {
//              successCallback(helperList);
//          }); 
//		}, function(err) {
//          errorCallback(err);
//			consoledebug.log("insertCacheOrders error is " + JSON.stringify(err));
//		})
//	}, function(error) {
//	   consoledebug.log('InserthelpEnroll err is '+ JSON.stringify(error));
//		errorCallback(error);
//	});
//}


function comHelpEnrollDone(orderTable, successCallback, errorCallback) {
	keys = ["orderID", "ownerID", "orderName", "classID", "applyDeadlineTime", "place", "beginTime", "state"];
	var objDate = {};
	bmob2Obj(keys, orderTable, objDate);
	if (objDate.state == 1) {//正在报名中
		objDate.beginTime = objDate.applyDeadlineTime;
	}
	objDate.ownership = 1;
	//帮助人
	objDate.orderType = 0;
	objDate.notify = 0;
	if(orderTable.get("selectMode") == 3 && orderTable.get("isPaid") == 1){
		objDate.state = HELPER_ORDER_RUNNING;
	}
	var aDates = [];
	aDates.push(objDate);
	consoledebug.log("GetRunningOrders is " + JSON.stringify(objDate));
	insertCacheOrders(aDates, function() {
		freashRunningOrderCall();
		var msg = {
			orderID : objDate.orderID, //订单ID
			orderType : 0, //0为求助，1为秀场，2为活动
			state : OPERATION_HELPER_ENROLL,
			notifyText : getMyAccount().nickname + NTFMSG_ENROLL, //用户的提示消息文本
			rongyunID : orderTable.get("groupID")
		}
		sendOrderNotificationMsg(orderTable.get("ownerID"), msg, function() {
			successCallback();
		}, function() {
			successCallback();
		});
	}, function(err) {
		errorCallback(err);
		consoledebug.log("insertCacheOrders error is " + JSON.stringify(err));
	})
}


function comCancelHelpOrder(orderRecord,successCallback, errorCallback) {
    if (!orderRecord) {
        consoledebug.log("comCancelHelpOrder orderRecord is wrong. ");
        return;
    }
    
//  var HelpOrder = Bmob.Object.extend("HelpOrder");
//  var query = new Bmob.Query(HelpOrder);
//  query.set("cancelreason",reason);
//  query.save().then(function(){
    	deleteCacheOrder(orderRecord.get("orderID"), 0, function() {
	        freashRunningOrderCall();
	        var msg = {
	            orderID : orderRecord.get("orderID"), //订单ID
	            orderType : 0, //0为求助，1为秀场，2为活动
	            state : OPERATION_ASKER_CANCEL1,
	            notifyText : getMyAccount().nickname + NTFMSG_ORDER_CANCEL //用户的提示消息文本
	        }
	        sendOrderNotificationMsgGroup(orderRecord.get("groupID"), msg, function() {
	        	successCallback(); 
	        }, function() {
	        	successCallback(); 
	        });
	//      cancelHelpOrder(orderRecord, function(helperList) {
	//      }, function(error) {
	//          consoledebug.log("insertCacheOrders error is " + JSON.stringify(error));
	//          errorCallback(error);
	//      })
	    }, function(err) {
	        consoledebug.log("insertCacheOrders error is " + JSON.stringify(err));
	        errorCallback(err);
	    });
//  },function(error){
//  	consoledebug.log("comCancelHelpOrder error is " + JSON.stringify(error));
//  })
    
    
}
function comQuitHelpEnroll(orderID, ownerID, groupID,successCallback, errorCallback){
	consoledebug.log("orderID, ownerID, groupID are " + orderID+" "+ownerID+" "+groupID)
    var myAcount = getMyAccount();
    deleteCacheOrder(orderID, 0, function(){
        quitHelpEnroll(orderID, myAcount.hhID, function(){
            freashRunningOrderCall();
            var msg = {
                orderID : orderID, //订单ID
                orderType : 0, //0为求助，1为秀场，2为活动
                state : OPERATION_HELPER_QUIT1, //变化后的状态
                groupID:groupID,
                notifyText : getMyAccount().nickname + NTFMSG_QUIT_ENROLL //用户的提示消息文本
            }
            sendOrderNotificationMsg(ownerID, msg, function() {
            	successCallback();
            }, function() {
            	successCallback();
            });

        },function(error){
            consoledebug.log("quitHelpEnroll error is " + JSON.stringify(error));
            errorCallback(error);
        })
    },function(err){
        consoledebug.log("deleteCacheOrder error is " + JSON.stringify(err));
        errorCallback(err);
    })
}

function comHelperFinish(orderRecord, myHHID, successCallback, errorCallback){
	helperFinish(orderRecord, myHHID, function(){
		syncCacheOrderState(orderRecord.get('orderID'), 0, HELPER_ORDER_CHECKING, function(){
            freashRunningOrderCall();
		},function(error){});

		var msg = {
			orderID : orderRecord.get('orderID'), //订单ID
			orderType : 0, //0为求助，1为秀场，2为活动
			state : OPERATION_HELPER_COMPLETE,
			notifyText : getMyAccount().nickname + NTFMSG_ONE_COMPLETE //用户的提示消息文本
		}
		sendOrderNotificationMsg(orderRecord.get("ownerID"), msg, function() {
			successCallback();
		}, function() {
			successCallback();
		});
	}, errorCallback)
}

/**
 * 求助人验收帮助，完成全部
 * @param {Bmob.Object} orderRecord HelpOrder 表对象
 * @param {function} successCallback 成功获取朋友列表后回调函数，定义为 .
 *      successCallback(helperList); helperList 是 {Bmob.Object} 对象数组，此订单的求助人列表，
 *      可用的 key 有 "orderID","state","ownerID"
 * @param {function} errorCallback 操作失败后回调函数，定义为：
 *      errCallback(error); error is a class, {code: number, message:string}
 */
function comHelpCompleteAllDone(orderRecord, successCallback, errorCallback) {
    consoledebug.log('comHelpCompleteAllDone orderRecord is ' + JSON.stringify(orderRecord));
    syncCacheOrderState(orderRecord.get('orderID'), 0, ASKER_ORDER_APPRAISING, function() {
        freashRunningOrderCall();
    }, function(error) {
        consoledebug.log('comHelpCompleteAll syncCacheOrderState error is ' + JSON.stringify(error));
    });

    var msg = {
        orderID : orderRecord.get('orderID'), //订单ID
        orderType : 0, //0为求助，1为秀场，2为活动
        state : OPERATION_ASKER_COMPLETE_ALL, //操作状态
        notifyText : getMyAccount().nickname + NTFMSG_ASKER_COMPLETE_ALL //用户的提示消息文本
    }
    sendOrderNotificationMsgGroup(orderRecord.get('groupID'), msg, function() {
        successCallback();
    }, function(error) {
        consoledebug.log('comHelpCompleteAll sendOrderNotificationMsgGroup error is ' + JSON.stringify(error));
        successCallback();
    });
}


/**
 * 求助人验收帮助，完成一次
 * @param {Bmob.Object} orderRecord HelpOrder 表对象
 * @param {function} successCallback 成功获取朋友列表后回调函数，定义为 .
 *      successCallback(newOrderRecord); 
 * @param {function} errorCallback 操作失败后回调函数，定义为：
 *      errCallback(error); error is a class, {code: number, message:string}
 */
function comHelpCompleteOnceDone(orderRecord, successCallback, errorCallback) {
    syncCacheOrderState(orderRecord.get('orderID'), 0, ASKER_ORDER_APPRAISING, function() {
        var repeatOrder = orderRecord.get('repeatOrder');
        var objRepeatOrder = {}
        var keys = ["orderID", "classID", "ownerID", "orderName", "payment", "helperNum", "helperSex", "beginTime", "applyDeadline", "place", "description", "photo", "ID", "orderGeo", "privacyMode", "selectMode", "repeatMode", "state", "repeatTimes"];
        bmob2Obj(keys, repeatOrder, objRepeatOrder);
        var aOrders = [];
        aOrders.push(objRepeatOrder);
        insertCacheOrders(aOrders, function() {
            successCallback();
            freashRunningOrderCall();
        }, function(err) {
            err.message = err.msg;
            consoledebug.log("comIssueHelpOrder insertCacheOrders error is " + JSON.stringify(err));
            errorCallback(err);
        });
    }, function(error) {
    });

    var msg = {
        orderID : orderRecord.get('orderID'), //订单ID
        orderType : 0, //0为求助，1为秀场，2为活动
        state : OPERATION_ASKER_COMPLETE_ONCE, //操作状态
        notifyText : getMyAccount().nickname + NTFMSG_ASKER_COMPLETE_ONCE //用户的提示消息文本
    }
    sendOrderNotificationMsgGroup(orderRecord.get('groupID'), msg, function() {
        successCallback();
    }, function(error) {
        successCallback();
    });
}

/**
 * 帮助人 结算处理，不再接了
 * @param {Bmob.Object} orderRecord HelpOrder 表对象
 * @param {Number} myHHID   自己的ID
 * @param {Number} appraisement  评价，取值为2到10之间的偶数（半颗心不能选上）
 * @param {function} successCallback 成功获取朋友列表后回调函数，定义为 .
 *      successCallback(); 
 * @param {function} errorCallback 操作失败后回调函数，定义为：
 *      errCallback(error); error is a class, {code: number, message:string}
 */
function comHelperCompleteAll(orderRecord, myHHID, appraisement, successCallback, errorCallback) {
	helperCompleteAll(orderRecord, myHHID, appraisement, function(){
		deleteCacheOrder(orderRecord.get('orderID'), 0, function(){
            freashRunningOrderCall();
		},function(error){});

		var msg = {
			orderID : orderRecord.get('orderID'), //订单ID
			orderType : 0, //0为求助，1为秀场，2为活动
			state : OPERATION_HELPER_TAKE_NOMORE, //操作状态
			notifyText : getMyAccount().nickname + NTFMSG_HELPER_COMPLETE_ALL //用户的提示消息文本
		}
		sendOrderNotificationMsg(orderRecord.get("ownerID"), msg, function() {
			deleteCoversetion(orderRecord.get("groupID"));
			successCallback();
		}, function() {
			successCallback();
		});
	}, function(error){
    	consoledebug.log("comHelperCompleteAll helperCompleteAll error is " + JSON.stringify(error));
        errorCallback(error);
	})
}



/**
 * 帮助人 结算处理，再接一次
 * @param {Bmob.Object} orderRecord HelpOrder 表对象
 * @param {Number} myHHID   自己的ID
 * @param {Number} appraisement  评价，取值为2到10之间的偶数（半颗心不能选上）
 * @param {function} successCallback 成功获取朋友列表后回调函数，定义为 .
 *      successCallback(); 
 * @param {function} errorCallback 操作失败后回调函数，定义为：
 *      errCallback(error); error is a class, {code: number, message:string}
 */
function comHelperCompleteOnce(orderRecord, myHHID, appraisement, successCallback, errorCallback) {
	helperCompleteOnce(orderRecord, myHHID, appraisement, function(){
		deleteCacheOrder(orderRecord.get('orderID'), 0, function(){
			var repeatOrder = orderRecord.get('repeatOrder');
          	consoledebug.log("comHelperCompleteOnce helperCompleteOnce repeatOrder is " + JSON.stringify(repeatOrder));
			var objRepeatOrder = {} 
			var keys = ["orderID","classID","ownerID","ownership","orderName","payment","helperNum","helperSex","beginTime","applyDeadline","place","description","photo","ID","orderGeo","privacyMode","selectMode","repeatMode","state","repeatTimes"];
			bmob2Obj(keys, repeatOrder, objRepeatOrder);
            var aOrders = [];
            objRepeatOrder.ownership = 1;
            objRepeatOrder.state = HELPER_ORDER_RUNNING;
            aOrders.push(objRepeatOrder);
            consoledebug.log("comHelperCompleteOnce helperCompleteOnce aOrders is " + JSON.stringify(aOrders));
            insertCacheOrders(aOrders, function(){
                successCallback(aOrders);
                consoledebug.log("freashRunningOrderCall is start")
            	freashRunningOrderCall();
            }, function(err){
                err.message = err.msg;
                consoledebug.log("comIssueHelpOrder insertCacheOrders error is " + JSON.stringify(err));
                errorCallback(err);
            });
		},function(error){});

		var msg = {
			orderID : orderRecord.get('orderID'), //订单ID
			orderType : 0, //0为求助，1为秀场，2为活动
			state : OPERATION_HELPER_TAKE_MORE, //操作状态
			notifyText : getMyAccount().nickname + NTFMSG_HELPER_COMPLETE_ONCE //用户的提示消息文本
		}
		sendOrderNotificationMsg(orderRecord.get("ownerID"), msg, function() {
			successCallback();
		}, function() {
			successCallback();
		});

	}, function(error){
        errorCallback(error);
    	consoledebug.log("comHelperCompleteOnce helperCompleteOnce error is " + JSON.stringify(error));
	})
}

/**
 * 帮助人未被选中
 * @param {Bmob.Object} orderRecord HelpOrder 表对象
 * @param {Number} myHHID 自己的ID
 * @param {function} successCallback 成功获取朋友列表后回调函数，定义为 .
 *      successCallback(); 
 * @param {function} errorCallback 操作失败后回调函数，定义为：
 *      errCallback(error); error is a class, {code: number, message:string}
 */
function comHelperNotSelectConfirm(orderRecord, myHHID, successCallback, errorCallback){
	helperNotSelectConfirm(orderRecord, myHHID, function(){
		deleteCacheOrder(orderRecord.get('orderID'), 0, function(){
            freashRunningOrderCall();
            successCallback();
		},errorCallback);
	}, function(error){
        errorCallback(error);
    	consoledebug.log("comHelperNotSelectConfirm helperNotSelectConfirm error is " + JSON.stringify(error));
	})
}

/**
 * 帮助人未被选中
 * @param {Bmob.Object} orderRecord HelpOrder 表对象
 * @param {Number} myHHID 自己的ID
 * @param {function} successCallback 成功获取朋友列表后回调函数，定义为 .
 *      successCallback(); 
 * @param {function} errorCallback 操作失败后回调函数，定义为：
 *      errCallback(error); error is a class, {code: number, message:string}
 */
function comHelperAskerCancelConfirm(orderRecord, myHHID, successCallback, errorCallback){
	helperAskerCancelConfirm(orderRecord, myHHID, function(){
		deleteCacheOrder(orderRecord.get('orderID'), 0, function(){
            freashRunningOrderCall();
            successCallback();
		},errorCallback);
	}, function(error){
        errorCallback(error);
    	consoledebug.log("comHelperNotSelectConfirm helperNotSelectConfirm error is " + JSON.stringify(error));
	})
}

function getLevel(EXP){
	var level;
	if(EXP > 10000){
		level = 9 + Math.floor((EXP - 10000)/5000);
	}else if(EXP > 5000){
		level = 8;
	}else if(EXP > 2000){
		level = 7;
	}else if(EXP > 1000){
		level = 6;
	}else if(EXP > 500){
		level = 5;
	}else if(EXP > 200){
		level = 4;
	}else if(EXP > 100){
		level = 3;
	}else if(EXP > 50){
		level = 2;
	}else{
		level = 1;
	}
	return level;
}

function askerCountEvaluation(helperList, successCallback, errorCallback) {
consoledebug.log("askerCountEvaluation helperList 11111 is " + JSON.stringify(helperList));
	var myAcount = getMyAccount();
	var EXP = 0;
	var score = 0;
	var starsall = 0;
	var stars1 = 0;
	var yourstars = 0;
	var starsNum = 0;
	var yourstarsNum = 0;
	for (var i = 0; i < helperList.length; i++) {
		EXP += helperList[i].get("payment");
		score += helperList[i].get("askerAppraisement");
		starsall += helperList[i].get("TaskEvaluation");
	}
	var UserInfo = Bmob.Object.extend("UserInfo");
	var query = new Bmob.Query(UserInfo);
	query.select("EXP", "score", "times", "level", "appraisement","stars","starsNum","starEvaluation");
	query.get(myAcount.userInfoId, {
		success : function(userInfo) {
			var updateFlag = false;
			var updateData = {};
			var level = getLevel(userInfo.get("EXP") + EXP);
			if(userInfo.get("stars")==null){
				stars1 = 6
			}else{
				stars1 = Number(userInfo.get("stars"));
			}
			if(userInfo.get("starsNum")==null){
				starsNum = 1
			}else{
				starsNum = Number(userInfo.get("starsNum"));
			}
			var stars = starsall*2;
			var appraisement = Math.round((userInfo.get("score") + score) / (userInfo.get("times") + helperList.length));
			var  starEvaluation = Math.round(( stars1 + stars) / (starsNum + helperList.length));
			if (level != userInfo.get("level")) {
				updateData.level = level;
				userInfo.set("level", level);
				updateFlag = true;
			}
			if (appraisement != userInfo.get("appraisement")) {
				updateData.appraisement = appraisement;
				userInfo.set("appraisement", appraisement);
				updateFlag = true;
			}
			if (starEvaluation != userInfo.get("starEvaluation")) {
				updateData.starEvaluation = starEvaluation;
				userInfo.set("starEvaluation", starEvaluation);
				updateFlag = true;
			}
			userInfo.increment("EXP", EXP);
			userInfo.increment("score", appraisement);
			userInfo.increment("stars", stars);
			userInfo.increment("times", helperList.length);
			userInfo.increment("starsNum", helperList.length);
			userInfo.save().then(successCallback, errorCallback)
			if(updateFlag == true){
				updateData.hhID = myAcount.hhID;
				updateCacheUserInfo(updateData,function(){
				},function(error){
    				consoledebug.log("askerCountEvaluation updateCacheUserInfo error is " + JSON.stringify(error));
				});
			}
		},
		error : function(object, error) {
			// 查询失败
			errorCallback(error);
		}
	});
}

function helperCountEvaluation(helperInfo, successCallback, errorCallback) {
	var myAcount = getMyAccount();
	var yourstars = Number((helperInfo.get("yourstars"))*2);
	var EXP = helperInfo.get("payment");
	var score = helperInfo.get("helperAppraisement");
	var yourstars1 = 0;
	var yourstarsNum = 0;
	var UserInfo = Bmob.Object.extend("UserInfo");
	var query = new Bmob.Query(UserInfo);
	query.select("EXP", "score", "times", "level", "appraisement","yourstars","yourstarsNum","yourstarEvaluation");
	query.get(myAcount.userInfoId, {
		success : function(userInfo) {
			var updateFlag = false;
			var updateData = {};
			var level = getLevel(userInfo.get("EXP") + EXP);
			if(userInfo.get("yourstars")==null){
				yourstars1 = 6
			}else{
				yourstars1 += Number(userInfo.get("yourstars"));
			}
			if(userInfo.get("yourstarsNum")==null){
				yourstarsNum = 1
			}else{
				yourstarsNum += Number(userInfo.get("yourstarsNum"));
			}
			var  yourstarEvaluation = Math.round(( yourstars1 + yourstars) / (yourstarsNum + 1));
			var appraisement = Math.round((userInfo.get("score") + score) / (userInfo.get("times") + 1));
    		consoledebug.log("helperCountEvaluation level appraisement is " + level + appraisement + JSON.stringify(userInfo));
			if (level != userInfo.get("level")) {
				updateData.level = level;
				userInfo.set("level", level);
				updateFlag = true;
			}
			if (appraisement != userInfo.get("appraisement")) {
				updateData.appraisement = appraisement;
				userInfo.set("appraisement", appraisement);
				updateFlag = true;
			}
			if (yourstarEvaluation != userInfo.get("yourstarEvaluation")) {
				updateData.yourstarEvaluation = yourstarEvaluation;
				userInfo.set("yourstarEvaluation", yourstarEvaluation);
				updateFlag = true;
			}
			userInfo.increment("EXP", EXP);
			userInfo.increment("score", appraisement);
			userInfo.increment("times", 1);
			userInfo.increment("yourstarsNum", 1);
			userInfo.increment("yourstars", yourstars);
			userInfo.save().then(successCallback, errorCallback)
			if(updateFlag == true){
				updateData.hhID = myAcount.hhID;
    			consoledebug.log("helperCountEvaluation updateData is " + JSON.stringify(updateData));
				updateCacheUserInfo(updateData,function(){
				},function(error){
    				consoledebug.log("helperCountEvaluation updateCacheUserInfo error is " + JSON.stringify(error));
				});
			}
		},
		error : function(object, error) {
			// 查询失败
			errorCallback(error);
		}
	});
}

function comAskerOrderFinish(orderRecord, successCallback, errorCallback){
	orderRecord.set('state', ASKER_ORDER_CLOSE);
	orderRecord.save().then(successCallback, function(error){
    	consoledebug.log("comAskerOrderFinish orderRecord save error is " + JSON.stringify(error));
	})
	deleteCacheOrder(orderRecord.get('orderID'), 0, function(){
        if(orderRecord.get('repeatOrder') == undefined){
           orderDeleteGroup(orderRecord.get('groupID'), function(){},function(){});
        }
        freashRunningOrderCall();
	},function(error){
    });
}

//注意，支付单位为 元
function comOrderIssuePay(helpOrder, pagePath, successCallback, errorCallback) {
	var helperNum = helpOrder.get('helperNum');
	if(helperNum == 0){
		helperNum = 1;
	}
    var paymentID = 'o' + helpOrder.get('orderID') + (new Date()).Format("yyMMddhhmmssS");
    var payment = {
        amount : helpOrder.get('payment')*100*helperNum,
        paymentOrderID : 'HO' + helpOrder.get('orderID') + (new Date()).Format("hhmmss"),
        orderID : helpOrder.get('orderID'),
        orderName : helpOrder.get('orderName'),
        description : '求助订单' + helpOrder.get('classID'),
        paymentID : paymentID,
        subject : '发布求助订单',
        orderType : 1 //1为互助，2为活动，3为参与活动，4为虚拟币充值
    }
    
    api.addEventListener({
        name : 'onPaymentFinished'
    }, function(ret, err) {
    	//从其他页面返回后，再打开等待状态
        waitingForTimeout({
	        title : '订单处理中...',
	        modal : true
    	});
        if (ret.value && ret.value.paymentID == payment.paymentID) {
            if (ret.value.result == 'success') {
                successCallback();
            } else {
                var payError = {
                    code : 889,
                    message : 'pay ' + ret.value.result,
                    result : ret.value.result
                }
                errorCallback(payError);
            }
        } else {
            consoledebug.log('onPaymentFinished ret and err is : ' + JSON.stringify(ret) + JSON.stringify(err));
            var payError = {
                code : 889,
                message : 'pay error',
                result : ret.value.result
            }
            errorCallback(err);
        }
    });
    clearWaitingForTimeout();	//打开其他页面时先关闭等待状态
    comOpenWin('RMBpay', pagePath, payment, 0); 
}

//注意，支付单位为 元
function comOrderSelectPay(helpOrder, selectList) {
    var promise = new Bmob.Promise();
    var paymentID = 'o' + helpOrder.get('orderID') + (new Date()).Format("yyMMddhhmmssS");
    var payment = {
        amount : helpOrder.get('payment')*100 * (selectList.length),
        paymentOrderID : 'HS' + helpOrder.get('orderID') + (new Date()).Format("hhmmss"),
        orderID : helpOrder.get('orderID'),
        orderName : helpOrder.get('orderName'),
        description : '求助订单' + helpOrder.get('classID'),
        paymentID : paymentID,
        selectList : selectList,
        subject : '补交求助订单报酬',
        orderType : 5 //1为互助，2为活动，3为参与活动，4为虚拟币充值，5为补交求助押金并确认人选
    }
    consoledebug.log('comOrderSelectPay payment is : ' + JSON.stringify(payment));
    
    api.addEventListener({
        name : 'onPaymentFinished'
    }, function(ret, err) {
    	//从其他页面返回后，再打开等待状态
        waitingForTimeout({
	        title : '订单处理中...',
	        modal : true
    	});
        if (ret.value && ret.value.paymentID == payment.paymentID) {
            if (ret.value.result == 'success') {
                promise.resolve();
            } else {
                var payError = {
                    code : 889,
                    message : 'pay ' + ret.value.result,
                    result : ret.value.result
                }
                promise.reject(payError);
            }
        } else {
            consoledebug.log('onPaymentFinished ret and err is : ' + JSON.stringify(ret) + JSON.stringify(err));
            var payError = {
                code : 889,
                message : 'pay error',
                result : ret.value.result
            }
            promise.reject(err);
        }
    });
    clearWaitingForTimeout();	//打开其他页面时先关闭等待状态
    comOpenWin('RMBpay', '../../paymentGroup/', payment, 0); 
    return promise;
}

//注意，支付单位为 元
function comEnrollRechargePay(helpOrder, successCallback, errorCallback) {
    var paymentID = 'o' + helpOrder.get('orderID') + (new Date()).Format("yyMMddhhmmssS");
    var payment = {
        amount : helpOrder.get('payment')*100,
        paymentOrderID : 'HE' + helpOrder.get('orderID') + (new Date()).Format("hhmmss"),
        orderID : helpOrder.get('orderID'),
        orderName : helpOrder.get('orderName'),
        description : '帮助订单' + helpOrder.get('classID'),
        paymentID : paymentID,
        subject : '求助订单报名虚拟币充值',
        orderType : 4 //1为互助，2为活动，3为参与活动，4为虚拟币充值
    }
    
    api.addEventListener({
        name : 'onPaymentFinished'
    }, function(ret, err) {
    	//从其他页面返回后，再打开等待状态
        waitingForTimeout({
	        title : '订单处理中...',
	        modal : true
    	});
        if (ret.value && ret.value.paymentID == payment.paymentID) {
            if (ret.value.result == 'success') {
                successCallback();
            } else {
                var payError = {
                    code : 889,
                    message : 'pay ' + ret.value.result,
                    result : ret.value.result
                }
                errorCallback(payError);
            }
        } else {
            consoledebug.log('onPaymentFinished ret and err is : ' + JSON.stringify(ret) + JSON.stringify(err));
            var payError = {
                code : 889,
                message : 'pay error',
                result : ret.value.result
            }
            errorCallback(err);
        }
    });
    clearWaitingForTimeout();	//打开其他页面时先关闭等待状态
    comOpenWin('RMBpay', '../paymentGroup/', payment, 0); 
}

function comHelpEnrollPay(helpOrder, successCallback, errorCallback){
    var paymentID = 'o' + helpOrder.get('orderID') + (new Date()).Format("yyMMddhhmmssS");
    var payment = {
        amount : helpOrder.get('payment')*SERVICE_FEE_RATE,
        orderID : helpOrder.get('orderID'),
        paymentID : paymentID,
        orderType : 1 //1为互助，2为活动，3为参与活动，4为虚拟币充值
    }
    if(helpOrder.get("selectMode") == 3 && helpOrder.get("isPaid") == 1){
    	payment.paymentType = 3;
    }else{
    	payment.paymentType = 1;
    }
    
    api.addEventListener({
        name : 'onHCoinPaymentFinished'
    }, function(ret, err) {
    	//从其他页面返回后，再打开等待状态
        waitingForTimeout({
	        title : '订单处理中...',
	        modal : true
    	});
        if (ret.value && ret.value.paymentID == payment.paymentID) {
            if (ret.value.result == 'success') {
                successCallback();
            } else {
                var payError = {
                    code : 889,
                    message : 'pay ' + ret.value.result,
                    result : ret.value.result
                }
                errorCallback(payError);
            }
        } else {
            consoledebug.log('onPaymentFinished ret and err is : ' + JSON.stringify(ret) + JSON.stringify(err));
            var payError = {
                code : 889,
                message : 'pay error',
                result : ret.value.result
            }
            errorCallback(err);
        }
    });
    clearWaitingForTimeout();	//打开其他页面时先关闭等待状态
    comOpenWin('sunshinePay', '../paymentGroup/', payment, 0); 
}

//
function comHCoinRechargePay(amount, successCallback, errorCallback){
    var paymentID = 'o' + helperList.get('orderID') + (new Date()).Format("yyMMddhhmmssS");
    var payment = {
        amount : helperList.get('entryfee'),
        orderID : helperList.get('orderID'),
        paymentID : paymentID,
        orderType : 1 //1为互助，2为活动，3为参与活动，4为虚拟币充值
    }
    
    api.addEventListener({
        name : 'onHCoinPaymentFinished'
    }, function(ret, err) {
    	//从其他页面返回后，再打开等待状态
        waitingForTimeout({
	        title : '订单处理中...',
	        modal : true
    	});
        if (ret.value && ret.value.paymentID == payment.paymentID) {
            if (ret.value.result == 'success') {
                successCallback();
            } else {
                var payError = {
                    code : 889,
                    message : 'pay ' + ret.value.result,
                    result : ret.value.result
                }
                errorCallback(payError);
            }
        } else {
            consoledebug.log('onPaymentFinished ret and err is : ' + JSON.stringify(ret) + JSON.stringify(err));
            var payError = {
                code : 889,
                message : 'pay error',
                result : ret.value.result
            }
            errorCallback(err);
        }
    });
    clearWaitingForTimeout();	//打开其他页面时先关闭等待状态
    comOpenWin('sunshinePay', '../paymentGroup/', payment, 0); 
}

//带重试的读取锁定后的结果
function readHelpOrderLockerState(retryTimes, orderRecord, oldLockerTime, successCallback, errCallback) {
	var comError = {
		code : 888,
		message : 'lock failed.'
	}
	if (retryTimes > 4) {
		consoledebug.log("retryTimes is " + retryTimes);
		errCallback(comError);
		return;
	}
	retryTimes++;
	var HelpOrder = Bmob.Object.extend("HelpOrder");
	var query = new Bmob.Query(HelpOrder);
	query.equalTo("orderID", orderRecord.get("orderID"));
	query.select("lockerTime", "locker", "state", "ownerID");
	query.find().then(function(results) {
		if(results.length > 0){
    		var result = results[0];
			consoledebug.log("readHelpOrderLockerState oldLockerTime is " + oldLockerTime + " get time is " + result.get("lockerTime"));
			//注意！平台有此bug，刚刚写入后立即查询读取，有可能读回缓存的原先的数据，因此需要判断一下。
    		if(oldLockerTime == result.get("lockerTime")){
				consoledebug.log("readHelpOrderLockerState try again ")
    			readHelpOrderLockerState(retryTimes, orderRecord, oldLockerTime, successCallback, errCallback);
    		}else{
    			successCallback(result);
    		}
    	}else{
			consoledebug.log("readHelpOrderLockerState find length is 0, try again")
    		readHelpOrderLockerState(retryTimes, orderRecord, oldLockerTime, successCallback, errCallback);
    	}
	}, function(error) {
		consoledebug.log("readHelpOrderLockerState find error is " + JSON.stringify(error) + ", try again")
    	readHelpOrderLockerState(retryTimes, orderRecord, oldLockerTime, successCallback, errCallback);
	})
}

//求助订单原子操作
function lockHelpOrderTable(retryTimes, orderRecord, successCallback, errCallback){
	var comError = {
		code : 888,
		message : 'lock failed.'
	}
	if (retryTimes > 4) {
		consoledebug.log("lockHelpOrderTable retryTimes is " + retryTimes);
		errCallback(comError);
		return;
	}
	retryTimes++;
	var myHhID = getMyAccount().hhID;
	var HelpOrder = Bmob.Object.extend("HelpOrder");
	var query = new Bmob.Query(HelpOrder);
	var oldLockerTime = 0;
	query.equalTo("orderID", orderRecord.get("orderID"));
	query.select("lockerTime", "locker");
	query.find().then(function(results) {
		if (results.length > 0) {
			var result = results[0];
            consoledebug.log("lockHelpOrderTable try to lock " + JSON.stringify(result))
			var nowTime = new Date().getTime();
            consoledebug.log("lockHelpOrderTable nowTime is " + nowTime)
			if ((!result.get("locker") || result.get("locker") == 0) || (result.get("lockerTime") && result.get("lockerTime") < (nowTime - 1000 * 30))) {
				//添加锁
				oldLockerTime = result.get("lockerTime");
				result.set("locker", myHhID);
				result.set("lockerTime", nowTime);
				result.save().then(function(ret) {
					//刚保存后，需要延时再读取
					setTimeout(function(){
						readHelpOrderLockerState(0, orderRecord, oldLockerTime, function(newResult) {
							if (newResult.get("locker") == myHhID) {
								successCallback(newResult);
							} else {
	                    		consoledebug.log("lockHelpOrderTable readHelpOrderLockerState locker is not myself. " + JSON.stringify(newResult))
								errCallback(comError);
							}
						}, function(error) {
	                    	consoledebug.log("lockHelpOrderTable readHelpOrderLockerState error is" + JSON.stringify(error))
							errCallback(comError);
						})
					},400);
				}, function(error) {
                    consoledebug.log("lockHelpOrderTable result save error is" + JSON.stringify(error))
					errCallback(comError);
				});
			} else {
				setTimeout(function() {
					lockHelpOrderTable(retryTimes, orderRecord, successCallback, errCallback);
				}, 400);
			}
		} else {
            consoledebug.log("lockHelpOrderTable HelpOrder find length is 0")
			errCallback(comError);
		}
	}, function(error){
		consoledebug.log("lockHelpOrderTable HelpOrder find error is " + JSON.stringify(error))
		errCallback(comError);
	})
}

//解锁
function unlockHelpOrder(helpOrderInfo){
	//防止订单在其他地方有操作，因此延时后再解锁
	setTimeout(function(){
		consoledebug.log('unlockHelpOrder helpOrderInfo is ' + JSON.stringify(helpOrderInfo));
		helpOrderInfo.set("locker", 0);
		helpOrderInfo.save();
	},500);
}

//进行操作时判断数据库中的有关订单的状态是否正确
function judgeHelpOrderStateIsStue(helpType,helpOrderInfo,orderRecord,handle,successCallback, errCallback){
	var helpLists = handle.helperListRecord;
	if(helpLists){
		var startState = orderRecord.get("state");
		var endState = helpOrderInfo.get("state");
		var HelperList = Bmob.Object.extend("HelperList");
	    var helpEnroll = new Bmob.Query(HelperList);
	    helpEnroll.equalTo("orderID",orderRecord.get("orderID"));
	    helpEnroll.equalTo("state",helpLists[0].get("state"));
	    helpEnroll.find().then(function(result){
	    	consoledebug.log("judgeHelpOrderStateIsStue result is " + JSON.stringify(result));
	    	consoledebug.log("judgeHelpOrderStateIsStue helpLists is " + JSON.stringify(helpLists));
	    	if(startState != endState || result.length != handle.helperListRecord.length){
				api.alert({
		            title: '提示',
		            msg: '对方定单状态发生变化请重试',
		            buttons: ['知道了']
		        },function( ret, err ){
	            	api.closeWin();
		        });
			}else{
	    		var array1 = [],array2 = [];
	    		for(var i = 0; i < result.length; i++){
	    			array1.push(helpLists[i].get("ownerID"));
	    			array2.push(result[i].get("ownerID"));
	    		}
	    		consoledebug.log("array1  is  " + JSON.stringify(array1)+' array2 is '+ JSON.stringify(array2));
	    		if(array1.sort().toString() == array2.sort().toString()){
					if(helpType == "asker"){
						askerHelpOrderHandle(orderRecord, handle, successCallback, errCallback);
					}else if(helpType == "helper"){
						helperOrderHandle(orderRecord, handle, sucCallback, errCallback);
					}
	    		}else{
	    			api.alert({
			            title: '提示',
			            msg: '对方定单状态发生变化请重试',
			            buttons: ['知道了']
			        },function( ret, err ){
		            	api.closeWin();
			        });
	    		}
			}
	    },errCallback);
	}else{
		if(startState != endState){
			api.alert({
		        title: '提示',
		        msg: '对方状态发生变化请重试',
		        buttons: ['知道了']
		     },function( ret, err ){
	            api.closeWin();
		     });
		}else{
			if(helpType == "asker"){
				askerHelpOrderHandle(orderRecord, handle, successCallback, errCallback);
			}else if(helpType == "helper"){
				helperOrderHandle(orderRecord, handle, successCallback, errCallback);
			}
		}
	}
}
/*
 * 修改秀场的订单成交数量
 */

function changeShowSkillOrderCount(skillID, successCallback, errorCallback) {
	var ShowSkill = Bmob.Object.extend("ShowSkill");
	var query = new Bmob.Query(ShowSkill);
	query.equalTo("skillID", skillID);
	query.find({
		success : function(showSkillInfo) {
			if (showSkillInfo.length > 0) {
				showSkillInfo[0].increment("orderCount");
				showSkillInfo[0].increment("orderBuy");
				showSkillInfo[0].save().then(function() {
					successCallback();
				}, function(error) {
					errorCallback(error);
				})
			}
		},
		error : function(error) {
			errorCallback(error);
		}
	});
}



/**
 * 任务发布者的订单操作接口
 * @param {Bmob.object} orderRecord 订单表对象
 * @param {object} handle 
 * 包含的属性 为：{
 *              operatrion: Number,        //订单操作，值定义参考 求助人的操作日志 操作定义
 *              ...: ...,        //该操作对应的数据。每个操作对应的数据说明如下：
 *             }
 * @param successCallback
 * @param errorCallback
 * @constructor
 */
function askerHandle(orderRecord, handle, sucCallback, errCallback){
	waitingForTimeout({
        title : '订单处理中...',
        modal : true
    },30000);
	lockHelpOrderTable(0,orderRecord,function(ret){
		judgeHelpOrderStateIsStue("asker",ret, orderRecord, handle, function(ret2){
			unlockHelpOrder(ret);
			sucCallback(ret2);
		}, function(error){
			unlockHelpOrder(ret);
			clearWaitingForTimeout();
			errCallback(error);
		});
	}, function(error){
		clearWaitingForTimeout();
		errCallback(error);
	})
}

function askerHelpOrderHandle(orderRecord, handle, sucCallback, errCallback){
//	consoledebug.log('askerHandle handle is : ' + JSON.stringify(handle));
//  waitingForTimeout({
//      title : '订单处理中...',
//      modal : true
//  });
	function errorCallback(error){
        consoledebug.log('askerHandle ' + handle.operatrion + ' error is : ' + JSON.stringify(error));
		clearWaitingForTimeout();
		errCallback(error)
	}
	function successCallback(){
        clearWaitingForTimeout();
        sucCallback()
	}
    switch(handle.operatrion){
        case OPERATION_ASKER_SELECT:
            var promiseDone;
//      	if(handle.confirmList.length > 1 && orderRecord.get("helperNum") == 0){
//      		promiseDone = comOrderSelectPay(orderRecord, handle.confirmList);
//      	}else{
//          	promiseDone = confirmHelper(orderRecord, handle.helperListRecord, handle.confirmList);
//      	}
			promiseDone = comOrderSelectPay(orderRecord, handle.confirmList);
            promiseDone.then(function() {
                if(handle.helperListRecord.length > handle.confirmList.length){
                    var payInfo = {
                        "orderID" : orderRecord.get("orderID"),
                        "paymentType" : 5,
                        "paymentID" : 'p' + orderRecord.get("orderID") + (new Date()).Format("yyMMddhhmmssS")
                    }
                    baePlatformHCoinPay(payInfo, function() {
                        comConfirmHelperDone(orderRecord, handle.confirmList, handle.gGroupNumberID, successCallback, errorCallback)
                    }, errorCallback)
                }else{
                    comConfirmHelperDone(orderRecord, handle.confirmList, handle.gGroupNumberID, successCallback, errorCallback)
                }
            }, errorCallback)
            break;
        case OPERATION_ASKER_QUIT_STOP:
				var payInfo = {
					"orderID" : orderRecord.get("orderID"),
					"paymentType" : 1,
					"paymentID" : 'g' + orderRecord.get("orderID") + (new Date()).Format("yyMMddhhmmssS")
				}
				baeGuaranteePay(payInfo, function() {
					comCancelHelpOrder(orderRecord, successCallback, errorCallback);
				}, errorCallback);
            //orderCancelByHelperQuit(orderRecord, successCallback, errorCallback)
            break;
        case OPERATION_ASKER_CANCEL1:
			var payInfo = {
				"orderID" : orderRecord.get("orderID"),
				"paymentType" : 4,
				"paymentID" : 'p' + orderRecord.get("orderID") + (new Date()).Format("yyMMddhhmmssS")
			}
			baePlatformHCoinPay(payInfo, function() {
				var payInfo = {
					"orderID" : orderRecord.get("orderID"),
					"paymentType" : 1,
					"paymentID" : 'g' + orderRecord.get("orderID") + (new Date()).Format("yyMMddhhmmssS")
				}
				baeGuaranteePay(payInfo, function() {
					comCancelHelpOrder(orderRecord, successCallback, errorCallback);
				}, errorCallback);
			}, errorCallback); 
        	break;
        case OPERATION_ASKER_CANCEL2:
				var payInfo = {
					"orderID" : orderRecord.get("orderID"),
					"paymentType" : 1,
					"paymentID" : 'g' + orderRecord.get("orderID") + (new Date()).Format("yyMMddhhmmssS")
				}
				baeGuaranteePay(payInfo, function() {
					comCancelHelpOrder(orderRecord, successCallback, errorCallback);
				}, errorCallback);
        	break;
        case OPERATION_ASKER_QUIT_GO:
            reactiveHelpOrder(orderRecord, successCallback, errorCallback)
            break;
        case OPERATION_ASKER_COMPLETE_ONCE:
            helpSaveAskerEvaluation(orderRecord.get("payment"), handle.helperListRecord, handle.complaintList, 
            //comHelpCompleteOnce(orderRecord, handle.helperListRecord, handle.complaintList, 
            function(newOrderRecord){
                var payInfo = {
                    "orderID":orderRecord.get("orderID"),
                    "paymentType":2,
                    "paymentID": 'g' + orderRecord.get("orderID") + (new Date()).Format("yyMMddhhmmssS")
                }
                //订单状态的改变在支付后台处理
                baeGuaranteePay(payInfo, function(){
                    repeatNewHelpOrder(orderRecord, function(newOrderRecord){
                        comOrderIssuePay(newOrderRecord, '../../paymentGroup/', function(){
                            comHelpCompleteOnceDone(orderRecord, successCallback, errorCallback);
                        }, errorCallback);
                    },errorCallback)
                }, errorCallback);
            }, errorCallback);
            break;
        case OPERATION_ASKER_COMPLETE_ALL:
            helpSaveAskerEvaluation(orderRecord.get("payment"), handle.helperListRecord, handle.complaintList, 
            function(){
            //comHelpCompleteAll(orderRecord, handle.helperListRecord, handle.complaintList, function(){
                var payInfo = {
                    "orderID":orderRecord.get("orderID"),
                    "paymentType":2,
                    "paymentID": 'g' + orderRecord.get("orderID") + (new Date()).Format("yyMMddhhmmssS")
                }
                //防止 bmob 写入立即读取错误的缺陷
                setTimeout(function(){
	                //订单状态的改变在支付后台处理
	                baeGuaranteePay(payInfo, function(){
	                    comHelpCompleteAllDone(orderRecord, successCallback, errorCallback);
	                }, errorCallback);
                },200)
            }, errorCallback);
            break;
        case OPERATION_ASKER_CLOSE:
            break;
        case OPERATION_ASKER_ACCEPT_CANDIDATE:
            addOneMemberToGroup(handle.rongyunID, handle.senderUserId);
            break;
        case OPERATION_ASKER_ALL_DONE:
        	askerCountEvaluation(handle.helperListRecord, function(){
        		comAskerOrderFinish(orderRecord, successCallback, errorCallback);
        	}, errorCallback)
        	break;
        default:
        	var error = {
        		code:888,
        		message:"not support operatrion"
        	}
        	errorCallback(error);
            break;
    }
}



/**
 * 帮助者的订单操作接口
 * @param {Bmob.object} orderRecord 订单表对象
 * @param {object} handle 
 * 包含的属性 为：{
 *              operatrion: Number,        //订单操作，值定义参考 帮助人的操作日志 操作定义
 *              ...: ...,        //该操作对应的数据。每个操作对应的数据说明如下：
 *             }
 * @param successCallback
 * @param errorCallback
 * @constructor
 */

function helperHandle(orderRecord, handle, sucCallback, errCallback){
	 waitingForTimeout({
        title : '订单处理中...',
        modal : true
    },30000);
	lockHelpOrderTable(0,orderRecord, function(ret){
		judgeHelpOrderStateIsStue("helper",ret, orderRecord, handle, function(ret2){
			unlockHelpOrder(ret);
			clearWaitingForTimeout();
			sucCallback(ret2);
		}, function(error){
			unlockHelpOrder(ret);
			clearWaitingForTimeout();
			errCallback(error);
		});
	}, function(error){
		clearWaitingForTimeout();
		errCallback(error);
	});
}

function helperOrderHandle(orderRecord, handle, sucCallback, errCallback){
	consoledebug.log("helperHandle handle is " + JSON.stringify(handle));
//  waitingForTimeout({
//      title : '订单处理中...',
//      modal : true
//  });
	function errorCallback(error){
        consoledebug.log('helperHandle ' + handle.operatrion + ' error is : ' + JSON.stringify(error));
        clearWaitingForTimeout();
		errCallback(error)
	}
	function successCallback(){
        clearWaitingForTimeout();
        sucCallback()
	}
    switch(handle.operatrion){
        case OPERATION_HELPER_ENROLL:
            comHelpEnrollPay(orderRecord, function() {
                comHelpEnrollDone(orderRecord, successCallback, errorCallback);
            }, function(error) {
                if(error.result != "cancel"){
                    alert("报名支付没有成功，请稍候再试")
                }
                errorCallback(error);
            }); 
            break;
        case OPERATION_HELPER_QUIT1:
			var payInfo = {
				"orderID" : orderRecord.get("orderID"),
				"paymentType" : 3,
				"paymentID" : 'p' + orderRecord.get("orderID") + (new Date()).Format("yyMMddhhmmssS")
			}
			baePlatformHCoinPay(payInfo, function() {
				deleteCacheOrder(orderRecord.get("orderID"), 0, function() {
					freashRunningOrderCall();
					var msg = {
						orderID : orderRecord.get("orderID"), //订单ID
						orderType : 0, //0为求助，1为秀场，2为活动
						state : OPERATION_HELPER_QUIT1, //变化后的状态
						groupID:handle.groupID,
						notifyText : getMyAccount().nickname + NTFMSG_QUIT_ENROLL //用户的提示消息文本
					}
					sendOrderNotificationMsg(orderRecord.get("ownerID"), msg, function() {
					}, function() {
					});
				}, function(err) {
					consoledebug.log("deleteCacheOrder error is " + JSON.stringify(err));
				})
				successCallback();
			}, errorCallback); 
            break;
        case OPERATION_HELPER_COMPLETE:
            comHelperFinish(orderRecord, handle.myHhID, successCallback, errorCallback)
            break;
        case OPERATION_HELPER_QUIT2:
            comQuitHelpEnroll(orderRecord.get("orderID"), orderRecord.get("ownerID"), handle.groupID,successCallback, errorCallback);
            break;
        case OPERATION_HELPER_APPRAISED:
            helperOrderCancelEvaluate(orderRecord, handle.myHhID, handle.appraisement, successCallback, errorCallback);
            break;
        case OPERATION_HELPER_TAKE_MORE:
        	helperCountEvaluation(handle.myhelperOrder, function(){
        		if(orderRecord.get("skillID")){
        			changeShowSkillOrderCount(orderRecord.get("skillID"), function(){}, function(){})
        		}
            	comHelperCompleteOnce(orderRecord, handle.myhelperOrder.get("ownerID"), handle.appraisement, successCallback, errorCallback);
        	}, errorCallback)
            break;
        case OPERATION_HELPER_TAKE_NOMORE:
        	helperCountEvaluation(handle.myhelperOrder, function(){
        		if(orderRecord.get("skillID")){
        			changeShowSkillOrderCount(orderRecord.get("skillID"), function(){}, function(){})
        		}
            	comHelperCompleteAll(orderRecord, handle.myhelperOrder.get("ownerID"), handle.appraisement, successCallback, errorCallback);
        	}, errorCallback)
            break;
        case OPERATION_HELPER_LOSE_SEAT_CONFIRM:
            comHelperNotSelectConfirm(orderRecord, handle.myHhID, successCallback, errorCallback);
            break;
        case OPERATION_HELPER_ASKER_CANCEL:
        	comHelperAskerCancelConfirm(orderRecord, handle.myHhID, successCallback, errorCallback);
            break;
        default:
        	var error = {
        		code:888,
        		message:"not support operatrion"
        	}
        	errorCallback(error);
            break;
    }
}
