
function updateNetToLocal(updateHHIDs, allUserInfos, userInfoCallback, updateAvatarCallback, errorCallback) {
    var avatarArray = [];
    var updateUserInfos = [];
    getNetUserInfos(updateHHIDs, function(userInfos) {
        for (var i = 0; i < userInfos.length; i++) {
            var objUserInfo = new Object();
            var userInfo = userInfos[i];
            if (userInfo.get("hhID") != undefined) {
                objUserInfo.hhID = userInfo.get("hhID");
            } else {
                continue;
            }
            if (userInfo.get("nickName") != undefined) {
                objUserInfo.nickName = userInfo.get("nickName");
            }
            if (userInfo.get("sex") != undefined) {
                objUserInfo.sex = userInfo.get("sex");
            }
            if (userInfo.get("age") != undefined) {
                objUserInfo.age = userInfo.get("age");
            }
            if (userInfo.get("level") != undefined) {
                objUserInfo.level = userInfo.get("level");
            }
            if (userInfo.get("appraisement") != undefined) {
                objUserInfo.appraisement = userInfo.get("appraisement");
            }
            if (userInfo.get("describe") != undefined) {
                objUserInfo.describe = userInfo.get("describe");
            }
            if (userInfo.get("livingPlace") != undefined) {
                objUserInfo.livingPlace = userInfo.get("livingPlace");
            }
            if (userInfo.get("validateState") != undefined) {
                objUserInfo.validateState = userInfo.get("validateState");
            }
            if (userInfo.get("photoThumbnail") != undefined && userInfo.get("photoThumbnail") != '') {
                var avatarObj = new Object();
                avatarObj.hhID = objUserInfo.hhID;
                avatarObj.url = userInfo.get("photoThumbnail");
                avatarArray.push(avatarObj);
                objUserInfo.photo = userInfo.get("photoThumbnail");
            } else {
                //objUserInfo.photo = 'image/defaultAvatar.png';
            }
            updateUserInfos.push(objUserInfo);
            allUserInfos.push(objUserInfo);
        }
        userInfoCallback(allUserInfos);
        inertCacheUserInfos(updateUserInfos, function() {
            getAvatarArray(avatarArray, function(avatars) {
                updateAvatarCallback(avatars);
//              updateCacheUserInfos(avatars, function() {
//              }, function(err) {
//                  err.message = err.msg;
//                  consoledebug.log('updateCacheUserInfos error is ' + err.msg);
//              });
            }, function(error) {
                errorCallback(error);
            });
        }, function(err) {
            err.message = err.msg;
            consoledebug.log('inertCacheUserInfos error is ' + err.msg);
            errorCallback(err);
        });
    }, function(error) {
        userInfoCallback(allUserInfos);
        errorCallback(error);
        consoledebug.log('getNetUserInfos error is ' + error.message);
    })
}


function comUpdateOneUserInfo(userInfo, successCallback, errorCallback) {
	var avatarArray = [];
	var objUserInfo = {}
	keys = ["hhID", "nickName", "describe", "level", "livingPlace", "appraisement", "sex", "age", "homeTown", "birthday","validateState"];
	bmob2Obj(keys, userInfo, objUserInfo);
	if (userInfo.get("photoThumbnail") != undefined && userInfo.get("photoThumbnail") != '') {
		objUserInfo.photo = userInfo.get("photoThumbnail");
	}
	
	updateCacheUserInfos(objUserInfo, function() {
		successCallback();
	}, function(err) {
		err.message = err.msg;
		consoledebug.log('updateCacheUserInfos error is ' + JSON.stringify(err));
		errorCallback(err);
	}); 
	//不将图片缓存在数据库内	
//	if (userInfo.get("photoThumbnail") != undefined && userInfo.get("photoThumbnail") != '') {
//		var avatarObj = new Object();
//		avatarObj.hhID = objUserInfo.hhID;
//		avatarObj.url = userInfo.get("photoThumbnail");
//		avatarArray.push(avatarObj);
//
//		getAvatarArray(avatarArray, function(avatars) {
//			objUserInfo.photo = avatars[0].photo;
//			updateCacheUserInfos(objUserInfo, function() {
//				successCallback();
//			}, function(err) {
//				err.message = err.msg;
//				consoledebug.log('comUpdateOneUserInfo updateCacheUserInfos error is ' + JSON.stringify(err));
//				errorCallback(err);
//			});
//		}, function(error) {
//			consoledebug.log('comUpdateOneUserInfo getAvatarArray error is ' + JSON.stringify(error));
//			errorCallback(error);
//		});
//	} else {
//		updateCacheUserInfos(objUserInfo, function() {
//			successCallback();
//		}, function(err) {
//			err.message = err.msg;
//			consoledebug.log('updateCacheUserInfos error is ' + JSON.stringify(err));
//			errorCallback(err);
//		});
//	}
}


  /**
   * 获取用户信息数据，如果缓存有，则从缓存取，如果没有，则从云端取，并且更新到本地缓存
   *
   * @param {Number[]} hhIDs: 用户ID 数组
   * @param {function} userInfoCallback 获取用户基本信息成功后回调函数，定义为 .
   * 		userInfoCallback(userInfos); userInfos 是 {Object[]} 对象数组，
   * 		包含的属性 为：hhID, nickName, sex, age, level, appraisement, describe, livingPlace, photo, updateAt
   * @param {function} updateAvatarCallback 部分从网络更新后得到的头像列表，此列表里的头像需要刷新到页面中，定义为 .
   * 		avatarCallback(avatars); avatars 是 {Object[]} 对象数组，
   * 		包含的 属性有： {Number} hhID, {String} photo
   * @param {function} errorCallback 操作失败后回调函数，定义为：
   * 		errorCallback(error); error is a class, {code: number, message:string}
   */
function oldGetComUserInfo(hhIDs, userInfoCallback, updateAvatarCallback, errorCallback) {
	var updateHHIDs = [];
	var updateUserInfos = [];
	var allUserInfos = [];
	var avatarArray = [];
	
	updateAllUserInfo();
	getCacheUserInfo(hhIDs, function(cacheUserInfos) {
//      removeNeedUpdatedUserInfos(cacheUserInfos);
		allUserInfos = cacheUserInfos;
		//updateHHIDs = needUpdateUserInfos(cacheUserInfos);
		if (cacheUserInfos.length != hhIDs.length) {
		    consoledebug.log('getComUserInfo local date less then wanted ' + cacheUserInfos.length + hhIDs.length);
            for(var i = 0; i < hhIDs.length; i++){
                for(var j = 0; j < cacheUserInfos.length; j++){
                    if(cacheUserInfos[j].hhID == hhIDs[i]){
                        break;
                    }
                }
                if(j >= cacheUserInfos.length){
                    updateHHIDs.push(hhIDs[i]);
                }
            }
		}
		if(updateHHIDs.length > 0){
			consoledebug.log('getComUserInfo need update user is ' + typeof updateHHIDs[0] + updateHHIDs);
			getNetUserInfos(updateHHIDs, function(userInfos) {
				for(var i = 0; i < userInfos.length; i++) {
					var objUserInfo = new Object();
					var userInfo = userInfos[i];
					if (userInfo.get("hhID") != undefined) {
						objUserInfo.hhID = userInfo.get("hhID");
					}else {
						continue;
					}
					if (userInfo.get("nickName") != undefined) {
						objUserInfo.nickName = userInfo.get("nickName");
					}
					if (userInfo.get("sex") != undefined) {
						objUserInfo.sex = userInfo.get("sex");
					}
					if (userInfo.get("age") != undefined) {
						objUserInfo.age = userInfo.get("age");
					}
					if (userInfo.get("level") != undefined) {
						objUserInfo.level = userInfo.get("level");
					}
					if (userInfo.get("appraisement") != undefined) {
						objUserInfo.appraisement = userInfo.get("appraisement");
					}
					if (userInfo.get("describe") != undefined) {
						objUserInfo.describe = userInfo.get("describe");
					}
					if (userInfo.get("livingPlace") != undefined) {
						objUserInfo.livingPlace = userInfo.get("livingPlace");
					}
					if (userInfo.get("validateState") != undefined) {
		                objUserInfo.validateState = userInfo.get("validateState");
		            }
					if (userInfo.get("photoThumbnail") != undefined && userInfo.get("photoThumbnail") != '') {
						var avatarObj = new Object();
						avatarObj.hhID = objUserInfo.hhID;
						avatarObj.url = userInfo.get("photoThumbnail");
						avatarArray.push(avatarObj);
						objUserInfo.photo = userInfo.get("photoThumbnail");
					}else{
						//objUserInfo.photo = 'image/defaultAvatar.png';
					}
					updateUserInfos.push(objUserInfo);
					allUserInfos.push(objUserInfo);
				}
				userInfoCallback(allUserInfos);
				inertCacheUserInfos(updateUserInfos, function() {
					getAvatarArray(avatarArray, function(avatars){
						updateAvatarCallback(avatars);
//						updateCacheUserInfos(avatars,function(){
//						},function(err){
//							err.message = err.msg;
//							consoledebug.log('updateCacheUserInfos error is ' + err.msg);
//						});
					},function(error){
						errorCallback(error);
					});
				}, function(err) {
					err.message = err.msg;
					consoledebug.log('inertCacheUserInfos error is ' + err.msg);
					errorCallback(err);
				});
			}, function(error) {
				userInfoCallback(allUserInfos);
				errorCallback(error);
				consoledebug.log('getNetUserInfos error is ' + error.message);
			});
		} else {
			userInfoCallback(allUserInfos);
		}
	},function(err){
	   updateNetToLocal(hhIDs, allUserInfos, userInfoCallback, updateAvatarCallback, function(error){
    	   consoledebug.log('getComUserInfo getCacheUserInfo error is ' + error.message);
    	   errorCallback(error);
	   });
	});
}

function getComUserInfo(hhIDs, userInfoCallback, updateAvatarCallback, errorCallback) {
	updateAllUserInfo();
	var updateHHIDs = [];
	var updateUserInfos = [];
	var allUserInfos = [];
	var avatarArray = [];
	getCacheUserInfo(hhIDs, function(cacheUserInfos) {
		allUserInfos = cacheUserInfos;
		//updateHHIDs = needUpdateUserInfos(cacheUserInfos);
		if (cacheUserInfos.length != hhIDs.length) {
		    consoledebug.log('getComUserInfo local date less then wanted ' + cacheUserInfos.length + hhIDs.length);
            for(var i = 0; i < hhIDs.length; i++){
                for(var j = 0; j < cacheUserInfos.length; j++){
                    if(cacheUserInfos[j].hhID == hhIDs[i]){
                        break;
                    }
                }
                if(j >= cacheUserInfos.length){
                    updateHHIDs.push(hhIDs[i]);
                }
            }
		}
		if(updateHHIDs.length > 0){
			consoledebug.log('getComUserInfo need update user is ' + typeof updateHHIDs[0] + updateHHIDs);
			getNetUserInfos(updateHHIDs, function(userInfos) {
				for(var i = 0; i < userInfos.length; i++) {
					var objUserInfo = new Object();
					var userInfo = userInfos[i];
					if (userInfo.get("hhID") != undefined) {
						objUserInfo.hhID = userInfo.get("hhID");
					}else {
						continue;
					}
					if (userInfo.get("nickName") != undefined) {
						objUserInfo.nickName = userInfo.get("nickName");
					}
					if (userInfo.get("sex") != undefined) {
						objUserInfo.sex = userInfo.get("sex");
					}
					if (userInfo.get("age") != undefined) {
						objUserInfo.age = userInfo.get("age");
					}
					if (userInfo.get("level") != undefined) {
						objUserInfo.level = userInfo.get("level");
					}
					if (userInfo.get("appraisement") != undefined) {
						objUserInfo.appraisement = userInfo.get("appraisement");
					}
					if (userInfo.get("describe") != undefined) {
						objUserInfo.describe = userInfo.get("describe");
					}
					if (userInfo.get("livingPlace") != undefined) {
						objUserInfo.livingPlace = userInfo.get("livingPlace");
					}
					if (userInfo.get("validateState") != undefined) {
		                objUserInfo.validateState = userInfo.get("validateState");
		            }
					if (userInfo.get("photoThumbnail") != undefined && userInfo.get("photoThumbnail") != '') {
						var avatarObj = new Object();
						avatarObj.hhID = objUserInfo.hhID;
						avatarObj.url = userInfo.get("photoThumbnail");
						avatarArray.push(avatarObj);
						objUserInfo.photo = userInfo.get("photoThumbnail");
					}else{
						//objUserInfo.photo = 'image/defaultAvatar.png';
					}
					updateUserInfos.push(objUserInfo);
					allUserInfos.push(objUserInfo);
				}
				userInfoCallback(allUserInfos);
				inertCacheUserInfos(updateUserInfos, function() {
					getAvatarArray(avatarArray, function(avatars){
						updateAvatarCallback(avatars);
//						updateCacheUserInfos(avatars,function(){
//						},function(err){
//							err.message = err.msg;
//							consoledebug.log('updateCacheUserInfos error is ' + err.msg);
//						});
					},function(error){
						errorCallback(error);
					});
				}, function(err) {
					err.message = err.msg;
					consoledebug.log('inertCacheUserInfos error is ' + err.msg);
					errorCallback(err);
				});
			}, function(error) {
				userInfoCallback(allUserInfos);
				errorCallback(error);
				consoledebug.log('getNetUserInfos error is ' + error.message);
			});
		} else {
			userInfoCallback(allUserInfos);
		}
	},function(err){
		errorCallback(err);
	})
}


function updateAllUserInfo() {
	var avatarArray = [];
	var hhID = getMyAccount().hhID;
	var cacheUserInfoTag = $api.getStorage(hhID + "cacheUserInfoTag");
	var curLocaleDate = (new Date()).Format("yyyy/MM/dd");
	consoledebug.log('updateAllUserInfo cacheUserInfoTag and curLocaleDate are '+ cacheUserInfoTag +" "+curLocaleDate);
	if (!cacheUserInfoTag || (cacheUserInfoTag && cacheUserInfoTag != curLocaleDate)) {
		$api.setStorage(hhID + "cacheUserInfoTag", curLocaleDate);
	} else {
		consoledebug.log('updateAllUserInfo cacheUserInfoTag is return');
		return;
	}
	consoledebug.log('3333333333333 ' + $api.getStorage(hhID + "cacheUserInfoTag", curLocaleDate));

	getCacheUserInfoUpdatetime(function(earliestTime) {
		consoledebug.log('updateAllUserInfo getCacheUserInfoUpdatetime earliestTime is ' + earliestTime);
		if(earliestTime){
			var earliestTime = new Date(earliestTime).getTime();
		}else{
			var earliestTime = 0;
		}
		var nowTime = new Date().getTime();
		//一天  = 86400000 毫秒
		var lastMonth = nowTime - 30 * 86400000;
//		var lastMonthTime = new Date(lastMonth);
		consoledebug.log('updateAllUserInfo getCacheUserInfoUpdatetime earliestTime 2 is ' + earliestTime);
		deleteCacheUserInfo(lastMonth, function() {
			localhhIDsPromises = getAllCacheUserhhID();
			Bmob.Promise.when(localhhIDsPromises).then(function(localhhIDs) {
				consoledebug.log('updateAllUserInfo getAllCacheUserhhID localhhIDs is ' + JSON.stringify(localhhIDs));
				getNetUpdateUserInfo(earliestTime, localhhIDs, function(userInfos) {
					consoledebug.log('updateAllUserInfo getNetUpdateUserInfo results.length is ' + userInfos.length);
					consoledebug.log('updateAllUserInfo getNetUpdateUserInfo results is ' + JSON.stringify(userInfos));
					var updateUserInfos = [];
					for (var i = 0; i < userInfos.length; i++) {
						var objUserInfo = new Object();
						var userInfo = userInfos[i];
						if (userInfo.get("hhID") != undefined) {
							objUserInfo.hhID = userInfo.get("hhID");
						} else {
							continue;
						}
						if (userInfo.get("nickName") != undefined) {
							objUserInfo.nickName = userInfo.get("nickName");
						}
						if (userInfo.get("sex") != undefined) {
							objUserInfo.sex = userInfo.get("sex");
						}
						if (userInfo.get("age") != undefined) {
							objUserInfo.age = userInfo.get("age");
						}
						if (userInfo.get("level") != undefined) {
							objUserInfo.level = userInfo.get("level");
						}
						if (userInfo.get("appraisement") != undefined) {
							objUserInfo.appraisement = userInfo.get("appraisement");
						}
						if (userInfo.get("describe") != undefined) {
							objUserInfo.describe = userInfo.get("describe");
						}
						if (userInfo.get("livingPlace") != undefined) {
							objUserInfo.livingPlace = userInfo.get("livingPlace");
						}
						if (userInfo.get("validateState") != undefined) {
			                objUserInfo.validateState = userInfo.get("validateState");
			            }
						if (userInfo.get("photoThumbnail") != undefined && userInfo.get("photoThumbnail") != '') {
							var avatarObj = new Object();
							avatarObj.hhID = objUserInfo.hhID;
							avatarObj.url = userInfo.get("photoThumbnail");
							avatarArray.push(avatarObj);
							objUserInfo.photo = userInfo.get("photoThumbnail");
						} else {
							//objUserInfo.photo = 'image/defaultAvatar.png';
						}
						updateUserInfos.push(objUserInfo);
					}
					consoledebug.log('updateAllUserInfo getNetUpdateUserInfo updateUserInfos is ' + JSON.stringify(updateUserInfos));
					updateCacheUserInfos(updateUserInfos, function() {
						changeUpdateUserInfoTime(nowTime,function(){
						}, function(error){
							consoledebug.log('updateAllUserInfo changeUpdateUserInfoTime error is ' + JSON.stringify(error));
						})
					}, function(error) {
						consoledebug.log('updateAllUserInfo updateCacheUserInfos error is ' + JSON.stringify(error));
					})
//					getAvatarArray(avatarArray, function(avatars){
//						updateCacheUserInfos(avatars,function(){
//							
//						},function(err){
//							err.message = err.msg;
//							consoledebug.log('updateCacheUserInfos error is ' + err.msg);
//						});
//					},function(error){
//					});
				}, function(error) {
					consoledebug.log('updateAllUserInfo getNetUpdateUserInfo error is ' + JSON.stringify(error));
				})
			}, function(error) {
			});
		}, function(error) {
			consoledebug.log('updateAllUserInfo deleteCacheOrder error is ' + JSON.stringify(error));
		})
	}, function(error) {
		consoledebug.log('updateAllUserInfo getCacheUserInfoUpdatetime error is ' + JSON.stringify(error));
	})
}


function getNetUpdateUserInfo(earliestTime,localhhIDs,successCallback, errorCallback){
	consoledebug.log('getNetUpdateUserInfo earliestTime 3 is ' + earliestTime);
	consoledebug.log('getNetUpdateUserInfo localhhIDs is ' + JSON.stringify(localhhIDs));
	var UserInfo = Bmob.Object.extend("UserInfo");
    var query = new Bmob.Query(UserInfo);
    if(earliestTime){
	    query.greaterThan("updateUserInfoTime", earliestTime);
    }
    query.containedIn("hhID", localhhIDs);
    query.select("hhID","nickName","sex","age","level","appraisement","describe","livingPlace","photo","validateState");
    query.descending("updatedAt");
    query.find(function(results){
    	successCallback(results);
    },function(error){
    	errorCallback(error);
    })
}

/*
 * 修改本地缓存时间
 */

function changeUpdateUserInfoTime(nowTime,successCallback, errorCallback){
	consoledebug.log('changeUpdateUserInfoTime nowTime is ' + nowTime);
	getAllCacheUserInfo(function(userInfos){
		var promise = new Bmob.Promise();
		var promises = [];
        for(var i=0;i<userInfos.length;i++){
        	promises.push(updateCacheUserInfoTime(userInfos[i],nowTime));
        }
        Bmob.Promise.when(promises).then(function(){
        	successCallback();
        },function(error){
        	errorCallback(error);
        })
	}, function(error){
		errorCallback(error);
	})
}


  /**
   * 获取用户信息数据，如果缓存有，则从缓存取，如果没有，则从云端取，并且更新到本地缓存
   *
   * @param {Number[]} hhIDs: 用户ID 数组
   * @param {function} userInfoCallback 获取用户基本信息成功后回调函数，定义为 .
   *        userInfoCallback(userInfos); userInfos 是 {Object[]} 对象数组，
   *        包含的属性 为：hhID, nickName, sex, age, level, appraisement, describe, livingPlace, photo, updateAt
   * @param {function} updateAvatarCallback 部分从网络更新后得到的头像列表，此列表里的头像需要刷新到页面中，定义为 .
   *        avatarCallback(avatars); avatars 是 {Object[]} 对象数组，
   *        包含的 属性有： {Number} hhID, {String} photo
   * @param {function} errorCallback 操作失败后回调函数，定义为：
   *        errorCallback(error); error is a class, {code: number, message:string}
   */
function getComAllUserInfo(hhIDs, successCallback, errorCallback) {
//function oldGetComAllUserInfo(hhIDs, successCallback, errorCallback) {
	consoledebug.log("getComAllUserInfo hhIDs is  "+JSON.stringify(hhIDs));
	updateAllUserInfo();
    var updateHHIDs = [];
    var updateUserInfos = [];
    var allUserInfos = [];
    var avatarArray = [];
    if(hhIDs.length == 0){
        return;
    }
    getCacheUserInfo(hhIDs, function(userInfos) {
    consoledebug.log("getComAllUserInfo getCacheUserInfo userInfos is  "+JSON.stringify(userInfos));
//      removeNeedUpdatedUserInfos(userInfos);
        allUserInfos = userInfos;
        if (userInfos.length != hhIDs.length) {
            consoledebug.log('getComUserInfo local date less then wanted ' + userInfos.length + hhIDs.length);
            for(var i = 0; i < hhIDs.length; i++){
                for(var j = 0; j < userInfos.length; j++){
                    if(userInfos[j].hhID == hhIDs[i]){
                        break;
                    }
                }
                if(j >= userInfos.length){
                    updateHHIDs.push(hhIDs[i]);
                }
            }
        }
        if(updateHHIDs.length > 0){
            consoledebug.log('getComUserInfo need update user is ' + typeof updateHHIDs[0] + updateHHIDs);
            getNetUserInfos(updateHHIDs, function(userInfos) {
                keys = ["nickName","sex","age","level","appraisement","describe","livingPlace","photo","photoThumbnail","validateState"];
                for(var i = 0; i < userInfos.length; i++) {
                    var objUserInfo = new Object();
                    var userInfo = userInfos[i];
                    if (userInfo.get("hhID") != undefined) {
                        objUserInfo.hhID = userInfo.get("hhID");
                    }else {
                        continue;
                    }
                    bmob2Obj(keys, userInfos[i], objUserInfo);
                    if (userInfo.get("photoThumbnail") != undefined && userInfo.get("photoThumbnail") != '') {
                    	var avatarObj = new Object();
                        avatarObj.hhID = objUserInfo.hhID;
                        avatarObj.url = userInfo.get("photoThumbnail");
                        avatarArray.push(avatarObj);
	                    objUserInfo.photo = userInfo.get("photoThumbnail");
                    }else{
                    	if (userInfo.get("photo") != undefined && userInfo.get("photo") != '') {
	                        var avatarObj = new Object();
	                        avatarObj.hhID = objUserInfo.hhID;
	                        avatarObj.url = userInfo.get("photo");
	                        avatarArray.push(avatarObj);
	                        objUserInfo.photo = userInfo.get("photo");
	                    }else{
//	                        objUserInfo.photo = 'image/defaultAvatar.png';
	                    }
                    }
                    updateUserInfos.push(objUserInfo);
                    allUserInfos.push(objUserInfo);
                }
                successCallback(allUserInfos);
                inertCacheUserInfos(updateUserInfos, function() {
//                  getAvatarArray(avatarArray, function(avatars){
//                      updateCacheUserInfos(avatars,function(){
//                      },function(err){
//                          err.message = err.msg;
//                          consoledebug.log('updateCacheUserInfos error is ' + err.msg);
//                          errorCallback(err);
//                      });
//                  },function(error){
//                      errorCallback(error);
//                  });
                }, function(err) {
                    err.message = err.msg;
                    consoledebug.log('inertCacheUserInfos error is ' + err.msg);
                });
            }, function(error) {
                successCallback(allUserInfos);
                errorCallback(error);
                consoledebug.log('getNetUserInfos error is ' + error.message);
            });
        } else {
            successCallback(allUserInfos);
        }
    },function(err){
       updateNetToLocal(hhIDs, allUserInfos, successCallback, function(){}, function(error){
           consoledebug.log('getComUserInfo getCacheUserInfo error is ' + error.message);
           errorCallback(error);
       });
    });

}



  /**
   * 从网络获取一个完整的用户信息数据，并且更新到本地缓存
   *
   * @param {Number[]} hhID: 用户ID 
   * @param {function} successCallback 获取用户基本信息成功后回调函数，定义为 .
   *        userInfoCallback(userInfo); userInfo 是 {Object} 对象，
   *        包含的属性 为：hhID, nickName, sex, age, level, appraisement, describe, livingPlace, photo, updateAt
   * @param {function} errorCallback 操作失败后回调函数，定义为：
   *        errorCallback(error); error is a class, {code: number, message:string}
   */
function downloadOneUserInfo(hhID, successCallback, errorCallback) {
    var hhIDs = [Number(hhID)];
    consoledebug.log('downloadOneUserInfo hhIDs are ' + JSON.stringify(hhIDs));
    getNetUserInfos(hhIDs, function(userInfos) {
        if (userInfos.length > 0) {
            var objUserInfo = new Object();
            var userInfo = userInfos[0];
            if (userInfo.get("hhID") != undefined) {
                objUserInfo.hhID = userInfo.get("hhID");
            } else {
            	var error = {};
                error.code = 888;
                error.message = "hhID key is must";
                errorCallback(error);
                return;
            }
            keys = ["nickName", "sex", "age", "level", "appraisement", "describe", "livingPlace","validateState"];
            bmob2Obj(keys, userInfo, objUserInfo);
            //objUserInfo.photo = 'image/defaultAvatar.png';
            if (userInfo.get("photoThumbnail") != undefined && userInfo.get("photoThumbnail") != '') {
                var avatarObj = new Object();
                var avatarArray = [];
                avatarObj.hhID = objUserInfo.hhID;
                avatarObj.url = userInfo.get("photoThumbnail");
                avatarArray.push(avatarObj);

				objUserInfo.photo = userInfo.get("photoThumbnail");
				
                getAvatarArray(avatarArray, function(avatars) {
                    if (avatars.length > 0) {
                        //objUserInfo.photo = avatars[0].photo;
                    }
                    successCallback(objUserInfo);
                    var newUserInfos = [objUserInfo];
                    inertCacheUserInfos(newUserInfos, function() {
                    }, function(err) {
                        err.message = err.msg;
                        consoledebug.log(JSON.stringify(hhIDs) + ' downloadOneUserInfo inertCacheUserInfos error is ' + err.msg);
                        errorCallback(err);
                    });
                }, function(error) {
                    errorCallback(error);
                });
            }else {
                successCallback(objUserInfo);
                var newUserInfos = [objUserInfo];
                inertCacheUserInfos(newUserInfos, function() {
                }, function(err) {
                    err.message = err.msg;
                    consoledebug.log(JSON.stringify(hhIDs) + ' downloadOneUserInfo inertCacheUserInfos error is ' + err.msg);
                    errorCallback(err);
                });
            }
        }else {
        	consoledebug.log(JSON.stringify(hhIDs) + ' downloadOneUserInfo getNetUserInfos userInfos length is 0.');
            error.code = 888;
            error.message = "userInfos length is 0.";
            errorCallback(error);
        }
    }, function(error) {
        errorCallback(error);
        consoledebug.log(JSON.stringify(hhIDs) + ' downloadOneUserInfo getNetUserInfos error is ' + error.message);
    });
}

  /**
   * 获取一个完整的用户信息数据，如果缓存有，则从缓存取，如果没有，则从云端取，并且更新到本地缓存
   *
   * @param {Number[]} hhID: 用户ID 
   * @param {function} successCallback 获取用户基本信息成功后回调函数，定义为 .
   *        userInfoCallback(userInfo); userInfo 是 {Object} 对象，
   *        包含的属性 为：hhID, nickName, sex, age, level, appraisement, describe, livingPlace, photo, updateAt
   * @param {function} errorCallback 操作失败后回调函数，定义为：
   *        errorCallback(error); error is a class, {code: number, message:string}
   */
function getComOneUserInfo(hhID, successCallback, errorCallback) {
    var updateHHIDs = [];
    var hhIDs = [hhID];
    var error = {};
    
    updateAllUserInfo();
    getCacheUserInfo(hhIDs, function(userInfos) {
        //updateHHIDs = needUpdateUserInfos(userInfos);
//      removeNeedUpdatedUserInfos(userInfos);
        if(userInfos.length > 0){
            successCallback(userInfos[0]);
        } else {
            new downloadOneUserInfo(hhID, successCallback, errorCallback);
        }
    },function(err){
        new downloadOneUserInfo(hhID, successCallback, errorCallback);
    });

}

  /**
   * 找出并返回太久远的需要更新的用户信息
   *
   * @param {Object[]} datas: 需要检查的所有用户信息数组
   * 		包含的属性 为：hhID, nickName, sex, age, level, appraisement, describe, livingPlace, updateAt
   * @return {Object[]} 需要更新的用户信息数组
   */
//function needUpdateUserInfos(datas){
//	var updateData = [];
//	var dateNow = new Date().Format("yyyy-MM-dd");
//	for(var i = 0; i<datas.length; i++) {
//		var arr1 = datas[i].updateAt.split(" ");
//		var recordDate = arr1[0]; 
//		var days = daysBetween(dateNow, recordDate);
//		if(days > 5) {
//			consoledebug.log(datas[i].hhID + dateNow + recordDate + 'needUpdateUserInfos daysBetween is ' + days);
//			//updateData.push(Number(datas[i].hhID));
//			updateData.push(datas[i].hhID);
//		}
//	}
//	return updateData;
//}
function removeNeedUpdatedUserInfos(datas){
	var dateNow = new Date().Format("yyyy-MM-dd");
	for(var i = 0; i<datas.length; i++) {
		//consoledebug.log(datas.length + ' removeNeedUpdatedUserInfos i is ' + i);
		var arr1 = datas[i].updateAt.split(" ");
		var recordDate = arr1[0]; 
		var days = daysBetween(dateNow, recordDate);
		if(days > 5) {
			consoledebug.log(datas[i].hhID + dateNow + recordDate + ' needUpdateUserInfos daysBetween is ' + days);
			datas.splice(i,1);  
			i-=1;
		}
	}
}


  /**
   * 获取我的朋友信息
   * @param {function} userInfoCallback 获取用户基本信息成功后回调函数，定义为 .
   * 		userInfoCallback(userInfos); userInfos 是 {Object[]} 对象数组，
   * 		包含的属性 为：hhID, nickName, sex, age, level, appraisement, describe, livingPlace, updateAt
   * @param {function} updateAvatarCallback 部分从网络更新后得到的头像列表，此列表里的头像需要刷新到页面中，定义为 .
   * 		avatarCallback(avatars); avatars 是 {Object[]} 对象数组，
   * 		包含的 属性有： {Number} hhID, {String} dataurl
   * @param {function} errorCallback 操作失败后回调函数，定义为：
   * 		errorCallback(error); error is a class, {code: number, message:string}
   */
function getComMyFriendsInfo(userInfoCallback, updateAvatarCallback, errorCallback){
	var friendsHHID = [];
	getMyFriends(function(friends){
		for(var i = 0; i<friends.length; i++){
			friendsHHID.push(friends[i].get('friendID'));
		}
		getComUserInfo(friendsHHID, userInfoCallback, updateAvatarCallback, errorCallback);
	},function(error){
	});
}

  /**
   * 获取我的群信息
   * @param {function} groupInfoCallback 获取用户基本信息成功后回调函数，定义为 .
   *        groupInfoCallback(groupInfos); groupInfos 是 {Object[]} 对象数组，
   *        包含的属性 为： groupID, groupName, rongyunID, builderHHID, maintain, photo, updateAt
   * @param {function} updateAvatarCallback 部分从网络更新后得到的头像列表，此列表里的头像需要刷新到页面中，定义为 .
   *        avatarCallback(avatars); avatars 是 {Object[]} 对象数组，
   *        包含的 属性有： {Number} rongyunID, {String} photo
   * @param {function} errorCallback 操作失败后回调函数，定义为：
   *        errorCallback(error); error is a class, {code: number, message:string}
   */
function getComMyGroupsInfo(groupInfoCallback, updateAvatarCallback, errorCallback){
    var myAccount = getMyAccount();
    if (myAccount) {
        var Group = Bmob.Object.extend("GroupMembers");
        var groupQuery = new Bmob.Query(Group);
        groupQuery.equalTo("hhID", myAccount.hhID);
        groupQuery.equalTo("state", 0);
        var Table = Bmob.Object.extend("Group");
        var query = new Bmob.Query(Table);
        query.matchesKeyInQuery("groupID", "groupID", groupQuery);
        query.equalTo("maintain", 1);
        query.descending("updatedAt");
        query.select("rongyunID","groupName", "groupID", "photo", "builderHHID");
        query.find().then(function(results){
        	var groupInfo = [];
			keys = ["rongyunID","groupName", "groupID", "photo", "builderHHID"];
        	for(var i=0;i<results.length;i++){
				var objGroupInfo = {}
				bmob2Obj(keys, results[i], objGroupInfo);
				groupInfo.push(objGroupInfo);
        	}
        	groupInfoCallback(groupInfo);
//          var groupIDs = [];
//          for(var i = 0; i<results.length; i++){
//              groupIDs.push(results[i].get('rongyunID'));
//          }
//          getComGroupInfo(groupIDs, groupInfoCallback, updateAvatarCallback, errorCallback);
        },function(error){
            errorCallback(error);
        });
    }
}

function getComMyGroupsInfoMap(successCallback, errorCallback){
    var myAccount = getMyAccount();
    if (myAccount) {
        var Group = Bmob.Object.extend("GroupMembers");
        var groupQuery = new Bmob.Query(Group);
        groupQuery.equalTo("hhID", myAccount.hhID);
        groupQuery.equalTo("state", 0);
        var Table = Bmob.Object.extend("Group");
        var query = new Bmob.Query(Table);
        query.matchesKeyInQuery("groupID", "groupID", groupQuery);
        query.equalTo("maintain", 1);
        query.descending("updatedAt");
        //query.select("rongyunID");
        query.find().then(function(results){
            var groupMap = [];
            for(var i = 0; i<results.length; i++){
                groupMap[results[i].get('rongyunID')] = results[i];
            }
            successCallback(groupMap);
        },function(error){
            errorCallback(error);
        });
    }
}
  /**
   * 获取群成员信息
   * @param {function} userInfoCallback 获取用户基本信息成功后回调函数，定义为 .
   * 		userInfoCallback(userInfos); userInfos 是 {Object[]} 对象数组，
   * 		包含的属性 为：hhID, nickName, sex, age, level, appraisement, describe, livingPlace, updateAt
   * @param {function} updateAvatarCallback 部分从网络更新后得到的头像列表，此列表里的头像需要刷新到页面中，定义为 .
   * 		avatarCallback(avatars); avatars 是 {Object[]} 对象数组，
   * 		包含的 属性有： {Number} hhID, {String} dataurl
   * @param {function} errorCallback 操作失败后回调函数，定义为：
   * 		errorCallback(error); error is a class, {code: number, message:string}
   */
function getComGroupMembersInfo(groupID, userInfoCallback, updateAvatarCallback, errorCallback){
	var membersHHID = [];
	getGroupMembers(groupID, function(members){
		for(var i = 0; i<members.length; i++){
			membersHHID.push(members[i].get('hhID'));
		}
		getComUserInfo(membersHHID, userInfoCallback, updateAvatarCallback, errorCallback);
	},function(error){
	});
}


  /**
   * 找出并返回太久远的需要更新的群信息
   *
   * @param {Object[]} datas: 需要检查的所有群信息数组
   * 		包含的属性 为：groupID, groupName, rongyunID, builderHHID, maintain, photo, updateAt
   * @return {Object[]} 需要更新的用户信息数组
   */
function needUpdateGroupInfo(datas){
	var updateData = [];
	var dateNow = new Date().Format("yyyy-MM-dd");
	for(var i = 0; i<datas.length; i++) {
		var arr1 = datas[i].updateAt.split(" ");
		var recordDate = arr1[0]; 
		var days = daysBetween(dateNow, recordDate);
		if(days > 5) {
			consoledebug.log(datas[i].hhID + dateNow + recordDate + 'needUpdateGroupInfo daysBetween is ' + days);
			//updateData.push(Number(datas[i].hhID));
			updateData.push(datas[i].groupID);
		}
	}
	return updateData;
}


  /**
   * 获取组名
   * @param {Number[]} groupID 组ID数组
   * @param {function} successCallback 成功获取朋友列表后回调函数，定义为 .
   * 		successCallback(groupInfo); groupInfo 是 {Object[]} 类对象数组，
   * 		可用的 key 有 groupID, groupName, rongyunID, builderHHID, maintain, photo, updateAt
   * @param {function} updateAvatarCallback 更新组头像成功后的回调函数，定义为：
   * 		updateAvatarCallback(avatarArray); avatarArray 是 {Object[]} 对象数组，
   * 		包含的 属性有： {Number} rongyunID, {String} photo
   * @param {function} errorCallback 操作失败后回调函数，定义为：
   * 		errCallback(error); error is a class, {code: number, message:string}
   */
function getComGroupInfo(rongyunIDs, userInfoCallback, updateAvatarCallback, errorCallback){
	var updateGroupIDs = [];
	var updateGroupInfos = [];
	var allGroupInfos = [];
	var avatarArray = [];
	getCacheGroupInfo(rongyunIDs, function(groupInfos) {
		allGroupInfos = groupInfos;
		updateGroupIDs = needUpdateGroupInfo(groupInfos);
		if (groupInfos.length != rongyunIDs.length) {
		    consoledebug.log('getComGroupInfo local date less then wanted ' + groupInfos.length + rongyunIDs.length);
			for(var i = 0; i < rongyunIDs.length; i++){
				for(var j = 0; j < groupInfos.length; j++){
					if(groupInfos[j].rongyunID == rongyunIDs[i]){
						break;
					}
				}
				if(j < rongyunIDs.length){
					updateGroupIDs.push(rongyunIDs[i]);
				}
			}
		}
		if(updateGroupIDs.length > 0){
			consoledebug.log('getComGroupInfo need update user is ' + typeof updateGroupIDs[0] + updateGroupIDs);
			getNetGroupInfos(updateGroupIDs, function(groupInfos) {
				for(var i = 0; i < groupInfos.length; i++) {
					var objInfo = new Object();
					var BmobInfo = groupInfos[i];
					if (BmobInfo.get("groupID") != undefined) {
						objInfo.groupID = BmobInfo.get("groupID");
					}else {
						continue;
					}
					if (BmobInfo.get("groupName") != undefined) {
						objInfo.groupName = BmobInfo.get("groupName");
					}
					if (BmobInfo.get("rongyunID") != undefined) {
						objInfo.rongyunID = BmobInfo.get("rongyunID");
					}
					if (BmobInfo.get("builderHHID") != undefined) {
						objInfo.builderHHID = BmobInfo.get("builderHHID");
					}
					if (BmobInfo.get("maintain") != undefined) {
						objInfo.maintain = BmobInfo.get("maintain");
					}
					if (BmobInfo.get("photo") != undefined && BmobInfo.get("photo") != '') {
						var avatarObj = new Object();
						avatarObj.rongyunID = objInfo.rongyunID;
						avatarObj.url = BmobInfo.get("photo");
						avatarArray.push(avatarObj);
						//objInfo.photo = 'image/m_user_icon.png';
					}else{
						//objInfo.photo = 'image/m_user_icon.png';
					}
					updateGroupInfos.push(objInfo);
					allGroupInfos.push(objInfo);
				}
				userInfoCallback(allGroupInfos);
				inertCacheGroupInfos(updateGroupInfos, function() {
					getGroupAvatarArray(avatarArray, function(avatars){
						updateAvatarCallback(avatars);
						updateCacheGroupInfos(avatars,function(){
						},function(err){
							err.message = err.msg;
							consoledebug.log('updateCacheGroupInfos error is ' + err.msg);
							errorCallback(err);
						});
					},function(error){
						errorCallback(error);
					});
				}, function(err) {
					err.message = err.msg;
					consoledebug.log('inertCacheGroupInfos error is ' + err.msg);
					errorCallback(err);
				});
			}, function(error) {
				userInfoCallback(allGroupInfos);
				errorCallback(error);
				consoledebug.log('getNetGroupInfos error is ' + error.message);
			});
		} else {
			userInfoCallback(allGroupInfos);
		}
	},function(err){
	   updateGroupNetToLocal(rongyunIDs, allGroupInfos, userInfoCallback, updateAvatarCallback, function(error){
    	   consoledebug.log('getComGroupInfo updateGroupNetToLocal error is ' + error.message);
    	   errorCallback(error);
	   });
	});
}


function updateGroupNetToLocal(updateIDs, allInfos, infoCallback, updateAvatarCallback, errorCallback) {
    var avatarArray = [];
    var updateInfos = [];
    getNetGroupInfos(updateIDs, function(infos) {
        for (var i = 0; i < infos.length; i++) {
            var objInfo = new Object();
            var info = infos[i];
            if (info.get("groupID") != undefined) {
                objInfo.groupID = info.get("groupID");
            } else {
                continue;
            }
            keys = ["groupName", "rongyunID", "builderHHID", "maintain"];
            bmob2Obj(keys, info, objInfo);
            if (info.get("photo") != undefined && info.get("photo") != '') {
                var avatarObj = new Object();
                avatarObj.rongyunID = objInfo.rongyunID;
                avatarObj.url = info.get("photo");
                avatarArray.push(avatarObj);
                //objInfo.photo = 'image/m_user_icon.png';
            } else {
                //objInfo.photo = 'image/m_user_icon.png';
            }
            updateInfos.push(objInfo);
            allInfos.push(objInfo);
        }
        infoCallback(allInfos);
        inertCacheGroupInfos(updateInfos, function() {
            getGroupAvatarArray(avatarArray, function(avatars) {
                updateAvatarCallback(avatars);
                updateCacheGroupInfos(avatars, function() {
                }, function(err) {
                    err.message = err.msg;
                    consoledebug.log('updateCacheGroupInfos error is ' + err.msg);
                    errorCallback(err);
                });
            }, function(error) {
                errorCallback(error);
            });
        }, function(err) {
            err.message = err.msg;
            consoledebug.log('inertCacheGroupInfos error is ' + err.msg);
            errorCallback(err);
        });
    }, function(error) {
        infoCallback(allInfos);
        errorCallback(error);
        consoledebug.log('updateGroupNetToLocal error is ' + error.message);
    })
}
