
function initDao(){
	Bmob.initialize(applicationID, restApiKey);
	$api.setStorage('LoginOpenCounts', 0);
}

function BmobajaxRequest(url, method, bodyParam, callBack) {
    var common_url = 'https://api.bmob.cn/1';
    var params = new Object();
    params = {
        url: common_url + url,
        method: method,
        cache: false,
        timeout: 20,
        headers: {
            "X-Bmob-Application-Id": applicationID,
            "X-Bmob-REST-API-Key": restApiKey,
            "Content-type": "application/json"
        }
    }
    if(bodyParam){
    	params.data = new Object();
    	params.data = {
            body: bodyParam
        }
    }
    api.ajax(params, function (ret, err) {
        callBack(ret, err);
    });
}

function BmobUserAjaxRequest(url, method, session, bodyParam, callBack) {
    var common_url = 'https://api.bmob.cn/1';
    var params = new Object();
    params = {
        url: common_url + url,
        method: method,
        cache: false,
        timeout: 20,
        headers: {
            "X-Bmob-Application-Id": applicationID,
            "X-Bmob-REST-API-Key": restApiKey,
            "X-Bmob-Session-Token": session,
            "Content-type": "application/json"
        }
    }
    if(bodyParam){
        params.data = new Object();
        params.data = {
            body: bodyParam
        }
    }
    consoledebug.log('BmobUserAjaxRequest params is : ' + JSON.stringify(params));
    api.ajax(params, function (ret, err) {
        callBack(ret, err);
    });
}
//var gCurrentUser;
//var gOpenCounts = 0;

    function getCurrentUser() {
        //if(!gCurrentUser){
        //var openCounts = $api.getStorage('LoginOpenCounts');
        var currentUser = Bmob.User.current();
        if (!currentUser) {
            //$api.setStorage('LoginOpenCounts', 1);
            consoledebug.log('try to load userLogin.html');
            api.openWin({
                name : 'userLogin',
                url : 'widget://html/userLogin.html',
                opaque : true,
                reload : true,
                vScrollBarEnabled : false
            });
            //api.toast({msg: 'user logoin'+currentUser.get('username'), duration: 4000, location: 'middle'});
        } else {
            //consoledebug.log('currentUser is ');
        }
        //}
        return currentUser;
    }

// 对Date的扩展，将 Date 转化为指定格式的String
// 月(M)、日(d)、小时(h)、分(m)、秒(s)、季度(q) 可以用 1-2 个占位符，
// 年(y)可以用 1-4 个占位符，毫秒(S)只能用 1 个占位符(是 1-3 位的数字)
// 例子：
// (new Date()).Format("yyyy-MM-dd hh:mm:ss.S") ==> 2006-07-02 08:09:04.423
// (new Date()).Format("yyyy-M-d h:m:s.S")      ==> 2006-7-2 8:9:4.18
Date.prototype.Format = function(fmt)
{ //author: meizz
    var o = {
        "M+" : this.getMonth()+1,                 //月份
        "d+" : this.getDate(),                    //日
        "h+" : this.getHours(),                   //小时
        "m+" : this.getMinutes(),                 //分
        "s+" : this.getSeconds(),                 //秒
        "q+" : Math.floor((this.getMonth()+3)/3), //季度
        "S"  : this.getMilliseconds()             //毫秒
    };
    if(/(y+)/.test(fmt))
        fmt=fmt.replace(RegExp.$1, (this.getFullYear()+"").substr(4 - RegExp.$1.length));
    for(var k in o)
        if(new RegExp("("+ k +")").test(fmt))
            fmt = fmt.replace(RegExp.$1, (RegExp.$1.length==1) ? (o[k]) : (("00"+ o[k]).substr((""+ o[k]).length)));
    return fmt;
}

  
//+---------------------------------------------------  
//| 求两个时间的天数差 日期格式为 YYYY-MM-dd   
//+---------------------------------------------------  
function daysBetween(DateOne,DateTwo)
{   
    var OneMonth = DateOne.substring(5,DateOne.lastIndexOf ('-'));  
    var OneDay = DateOne.substring(DateOne.length,DateOne.lastIndexOf ('-')+1);  
    var OneYear = DateOne.substring(0,DateOne.indexOf ('-'));  
  
    var TwoMonth = DateTwo.substring(5,DateTwo.lastIndexOf ('-'));  
    var TwoDay = DateTwo.substring(DateTwo.length,DateTwo.lastIndexOf ('-')+1);  
    var TwoYear = DateTwo.substring(0,DateTwo.indexOf ('-'));  
  
    var cha=((Date.parse(OneMonth+'/'+OneDay+'/'+OneYear)- Date.parse(TwoMonth+'/'+TwoDay+'/'+TwoYear))/86400000);   
    return Math.abs(cha);  
}  
  
	/**
	 *删除数组指定下标或指定对象
	 */
	Array.prototype.remove = function(obj) {
		for (var i = 0; i < this.length; i++) {
			var temp = this[i];
			if (!isNaN(obj)) {
				temp = i;
			}
			if (temp == obj) {
				for (var j = i; j < this.length; j++) {
					this[j] = this[j + 1];
				}
				this.length = this.length - 1;
			}
		}
	} 

function getBmobErrorCh(code) {
	var msg;
	switch (code) {
		case 101: msg = "手机号或密码不正确，请重试";
		break;
		case 108: msg = "手机号或密码不正确，请重试";
		break;
		case 109: msg = "密码输入错误，请重试";
		break;
		case 202: msg = "该手机号已经存在，请换个手机号";
		break;
		case 205: msg = "没有找到此手机号的用户";
		break;
		case 206: msg = "不能修改或删除用户，请重新登录";
		break;
		case 207: msg = "验证码错误";
		break;
		case 210: msg = "旧密码不正确";
		break;
		default: msg = "错误代码为 "+code; 
		break;
	}
	return msg;
}


function debugMsg(msg) {
	api.alert({
		msg : "调试信息：" + msg
	});
}
