/**
 * Created by Administrator on 2015/10/12.
 */

//订单查询能查的最大值，超过此值，则重新查找
var MAX_SKILL_LIST = 200;

/**
 * 获取新的技能ID
 * @param successCallback
 * @param errorCallback
 * @constructor
 */
function NewSkillID(successCallback, errorCallback){

    var skillID;
    var SerialNum = Bmob.Object.extend("serialNum");
    var query = new Bmob.Query(SerialNum);
    query.equalTo("serialName", "skillID");
    query.find({
        success: function (results) {
            if (results.length == 0) {
                var query2 = new SerialNum();
                query2.set("serialName", "skillID");
                query2.set("serialMatrix", 100000);
                query2.fetchWhenSave(true);
                query2.save(null, function (groupID) {
                    // The save was successful.
                    skillID = 100000;
                    successCallback(skillID);
                }, function (error) {
                    // The save failed.  Error is an instance of Bmob.Error.
                    errorCallback(error);
                })
            }
            if (results.length != 0) {
                // 鏌ヨ鎴愬姛锛岃皟鐢╣et鏂规硶鑾峰彇瀵瑰簲灞炴?х殑鍊?
                var serialNum = results [0];
                serialNum.fetchWhenSave(true);
                serialNum.increment("serialMatrix");
                serialNum.save().then(function (groupID) {
                    // The save was successful.
                    skillID = parseInt(groupID.get("serialMatrix"));
                    successCallback(skillID);
                }, function (error) {
                    // The save failed.  Error is an instance of Bmob.Error.
                    errorCallback(error);
                });
            }
        },
        error: function (error) {
            //alert("鏌ヨ澶辫触: " + error.code + " " + error.message);
            //api.toast({msg: error.message, location: 'middle'});
            errorCallback(error);
        }
    });
}

//获取AD表格
function GetADTable(successCallback,errorCallback){
    var aD = Bmob.Object.extend("AD");
    var query = new Bmob.Query(aD);
    query.equalTo("UpDown_frame",0);
    query.equalTo("show_help",2);
    // query.equalTo("AD_type",0);
    query.find({
        success:function(adtable){
            consoledebug.log("GetADTable adtable is" + JSON.stringify(adtable));
            successCallback(adtable);
        },
        error:function(error){
            consoledebug.log("GetADTable error is" + JSON.stringify(error));
            errorCallback(error);
        }
    })
}
/**
 *添加一张秀场图片
 * @param {Bmob.Object} showSkill: 秀场的bmob 对象
 * @param {String} skillphoto; 要添加的图片
 * @param {function} successCallback 成功则返回技能ID .
 * 		successCallback(skillID); skillID: {Number} 成功添加图片的秀场ID
 * @param {function} errorCallback 失败则返回错误信息
 * 		errCallback(error); error is a class, {code: number, message:string}
 */
//function insertSkillPhoto(showSkill,skillphoto,successCallback, errorCallback){
//  var skillID = showSkill.get("skillID");
//  var photo = "";
//  if(skillphoto && skillphoto!="") {
//      var tag = true;
//  	for(var i = 0; i < skillphoto.length; i++){
//  		var showSkillPhoto = skillphoto[i];
//  		var data = showSkillPhoto.split(',')[1];
//  		data = window.atob(data);
//	        var fileName = skillID + new Date().Format("yyyy-MM-dd-hh:mm:ss") + '.png';
//	        var file = BmobFile(fileName, data);
//			
//	        file.save().then(function (obj) {
//	            photo = obj.url();
//	            if(!showSkill.get("firstPhoto")) {
//	            	if(tag){
//		                showSkill.set("firstPhoto", photo);
//		                showSkill.save().then(function(){
//		
//		                },function(error){
//		                    consoledebug.log("insertSkillPhoto showSkill save error is "+JSON.stringify(error));
//		                });
//		                tag = false;
//	                }
//	            }
//	            var Table = Bmob.Object.extend("ShowSkillPhoto");
//	            var showSkillPhoto = new Table();
//	           	
//	            //showSkill.fetchWhenSave(true);
//	            showSkillPhoto.set("skillID", skillID);
//	            showSkillPhoto.set("photo", photo);
//	            showSkillPhoto.save({
//	                success: function (skillPhoto) {
//	                	consoledebug.log("insertSkillPhoto showSkillPhoto save skillPhoto is  "+JSON.stringify(skillPhoto));
//	                    var relation = showSkill.relation("photos");
//	                    relation.add(skillPhoto);
//	                    showSkill.save();
//	                    successCallback(skillPhoto.get('skillID'));
//	                },
//	                error: function (error) {
//	                    //api.toast({msg: error.message, location: 'middle'});
//	                    consoledebug.log("insertSkillPhoto showSkillPhoto save error is  "+JSON.stringify(error));
//	                    errorCallback(error);
//	                }
//	            });
//	        }, function (error) {
//	            // The save failed.  Error is an instance of Bmob.Error.
//	            errorCallback(error);
//	        });
//      }
//  }
//}
//添加秀场上传的图片
function addSkillPhotos(skillID,skillphoto,successCallback, errorCallback){
     consoledebug.log("addSkillPhotos skillID is  "+skillID + skillphoto);
	 var Table = Bmob.Object.extend("ShowSkillPhoto");
     var showSkillPhoto = new Table();
     showSkillPhoto.set("skillID", skillID);
     showSkillPhoto.set("photo", skillphoto);
     showSkillPhoto.save({
         success: function (skillPhoto) {
             consoledebug.log("addSkillPhotos skillPhoto is  "+JSON.stringify(skillPhoto));
             successCallback(skillPhoto);
        },
        error: function (error) {
             //api.toast({msg: error.message, location: 'middle'});
             consoledebug.log("addSkillPhotos showSkillPhoto save error is  "+JSON.stringify(error));
             errorCallback(error);
       }
   });
}



/**
 *添加一个技能
 * @param {Object} skillInfo:
 *          skillID;              Number                技能ID
            ownerID:	          Number                用户ID
            skillName:            String   	            技能名称
            skillType:	          String                技能分类
            skillPay:	          Number                报酬
            skillTime:	          String                帮助时间
            skillDescription:     String	            技能说明
 * @param {Bmob.Object} ownerRecord: 用户信息的 bmob 对象
 * @param {function} successCallback 成功则返回技能ID .
 * 		successCallback(showSkill);showSkill {Bmob.Object} 秀场详情，通过
 * @param {function} errorCallback 失败则返回错误信息
 * 		errCallback(error); error is a class, {code: number, message:string}
 */
function insertShowSkill(skillID, skillInfo, ownerRecord, successCallback, errorCallback){
	var ShowSkill = Bmob.Object.extend("ShowSkill");
	var showSkill = new ShowSkill();
	//showSkill.fetchWhenSave(true);
	showSkill.set("skillID", skillID);
	showSkill.set("ownerID", skillInfo.ownerID);
	showSkill.set("skillName", skillInfo.skillName);
	showSkill.set("serviceName", skillInfo.serviceName);
	showSkill.set("skillType", skillInfo.skillType);
	showSkill.set("classification", Number(skillInfo.classification));
	showSkill.set("skillPay", skillInfo.skillPay);
	showSkill.set("skillTime", skillInfo.skillTime);
	showSkill.set("showUnit", skillInfo.showUnit);
	showSkill.set("skillDescription", skillInfo.skillDescription);
	showSkill.set("firstPhoto", skillInfo.firstPhoto);
	showSkill.set("ownerInfo", ownerRecord);
	showSkill.set("reportNum", 0);
	showSkill.set("orderCount", 0);
	showSkill.set("orderBuy", 0);
	showSkill.set("serviceOffline", 0);
	showSkill.save({
		success : function(showSkill) {
			clearTempFiles(function(){});
			successCallback(showSkill);
		},
		error : function(error) {
			consoledebug.log("insertShowSkill showSkill.save error is  "+JSON.stringify(error));
			//api.toast({msg: error.message, location: 'middle'});
			clearTempFiles(function(){});
			errorCallback(error);
		}
	}); 
}



/*
 * 消息订阅表中填写数据
 * @param	hhID
 * @param	messageType：buySkill  通知类型
 */
function creatMessageNotification(hhID,messageType,successCallback,errorCallback){
	var MessageNotification = Bmob.Object.extend("MessageNotification");
    var query = new Bmob.Query(MessageNotification);
    query.equalTo("hhID",hhID);
    query.equalTo("messageType",messageType);
    query.count({
        success:function(count){
            if(count == 0){
            	var MessageNotification = Bmob.Object.extend("MessageNotification");
				var query = new MessageNotification();
				query.set("hhID", hhID);
				query.set("messageType", messageType);
				query.set("unReadNum", 0);
				query.save({
					success : function(results) {
						successCallback();
					},
					error : function(error) {
						errorCallback(error);
					}
				}); 
            }else{
            	successCallback();
            }
        },
        error: function (error) {
            errorCallback(error);
        }
    });
}



/**
 * 秀场购买成功后插入消息记录
 */


function insertBuySkillRecord(recordInfo, successCallback, errorCallback) {
	consoledebug.log("insertBuySkillRecord MessageNotification start");
	var BuySkillMessage = Bmob.Object.extend("BuySkillMessage");
	var buySkillMessage = new BuySkillMessage();
	buySkillMessage.set("ownerID", recordInfo.ownerID);
	buySkillMessage.set("showID", recordInfo.showID);
	buySkillMessage.set("askerID", recordInfo.askerID);
	buySkillMessage.set("orderID", recordInfo.orderID);
	buySkillMessage.set("isRead", 1);	// 0 :已读   1:未读
	buySkillMessage.save().then(function(results) {
		consoledebug.log("insertBuySkillRecord BuySkillMessage results is" + JSON.stringify(results));
		var MessageNotification = Bmob.Object.extend("MessageNotification");
		var query = new Bmob.Query(MessageNotification);
		query.equalTo("hhID", recordInfo.ownerID);
		query.equalTo("messageType", "buySkill");
		query.find().then(function(result) {
			consoledebug.log("insertBuySkillRecord MessageNotification result is" + JSON.stringify(result));
			if (result.length > 0) {
				result[0].increment("unReadNum");
				result[0].save().then(function() {
					consoledebug.log("insertBuySkillRecord MessageNotification save success1");
					successCallback();
				}, function(error) {
					consoledebug.log("insertBuySkillRecord increment unReadNum error " + + JSON.stringify(error));
					errorCallback(error);
				})
			} else {
//				errorCallback();
				var MessageNotification = Bmob.Object.extend("MessageNotification");
				var query2 = new MessageNotification();
				query2.set("hhID", recordInfo.ownerID);
				query2.set("messageType", "buySkill");
				query2.set("unReadNum", 1);
				query2.save().then(function(results) {
					consoledebug.log("insertBuySkillRecord MessageNotification save success2");
					successCallback();
				}, function(error) {
					consoledebug.log("insertBuySkillRecord increment unReadNum error 2 " + + JSON.stringify(error));
					errorCallback(error);
				});
			}
		}, function(error) {
			consoledebug.log("insertBuySkillRecord MessageNotification find error " + + JSON.stringify(error));
			errorCallback(error);
		})
	}, function(error) {
		consoledebug.log("insertBuySkillRecord MessageNotification error");
		errorCallback(error);
	})
}




/*
 * 评论秀场时，添加未读标记以及相关信息
 */
function insertShowCommentRecord(recordInfo,showSkillRecord,successCallback, errorCallback){
	showSkillRecord.increment("commentIsRead");
	showSkillRecord.save().then(function(){
		consoledebug.log("insertShowCommentRecord commentIsRead is success");
		creatShowMessageNotification(recordInfo,successCallback, errorCallback)
	},function(error){
		errorCallback(error);
	})
}

function creatShowMessageNotification(recordInfo,successCallback, errorCallback) {
	var MessageNotification = Bmob.Object.extend("MessageNotification");
	var query = new Bmob.Query(MessageNotification);
	query.equalTo("hhID", recordInfo.ownerID);
	query.equalTo("messageType", "showComment");
	query.find().then(function(result) {
		consoledebug.log("creatShowMessageNotification result is" + JSON.stringify(result));
		if (result.length > 0) {
			result[0].increment("unReadNum");
			result[0].save().then(function() {
				successCallback();
			}, function(error) {
				errorCallback(error);
			})
		} else {
			errorCallback();
		}
	}, function(error) {
		errorCallback(error);
	})
}



//我的秀场
/**
 * 我的秀场
 * @param ownerID
 * @param {function} successCallback 返回Bmob.Object.extend("ShowSkill")的数组，包含如下列
 *          "skillID","skillName","skillPay","skillDescription","firstPhoto"用.get("")方法提取
 * @param errorCallback
 */
function findMyShowSkill(ownerID,successCallback,errorCallback){
    var ShowSkill = Bmob.Object.extend("ShowSkill");
    var query = new Bmob.Query(ShowSkill);
    query.equalTo("ownerID",ownerID);
    query.notEqualTo("serviceOffline",1);
    query.select("skillID","skillType","skillName","skillPay","skillDescription","firstPhoto");
    query.descending("createdAt");
    query.find({
        success:function(showSkill){
            successCallback(showSkill);
        },
        error: function (error) {
            errorCallback(error);
        }
    });
}
/**
 * 根据skillID提取技能的完整信息
 * @param skillID
 * @param successCallback
 * @param errorCallback
 */
function selectShowSkill(skillID,successCallback,errorCallback){
    var ShowSkill = Bmob.Object.extend("ShowSkill");
    var query = new Bmob.Query(ShowSkill);
    query.equalTo("skillID",skillID);
    query.notEqualTo("serviceOffline",1);
//  query.include("ownerInfo");
    query.include("photos");
    query.find({
        success:function(showSkill) {
            if(showSkill.length > 0){
                successCallback(showSkill[0]);
            }else{
                var error = {};
                error.code = 888;
                error.message = 'length is 0';
                errorCallback(error);
            }
        },
        error:function(error){
            errorCallback(error);
        }
    });
}

//获取用户的地理位置
function getUserLocation(hhID,successCallback,errorCallback){
	var UserInfo = Bmob.Object.extend("UserInfo");
    var query = new Bmob.Query(UserInfo);
    query.equalTo("hhID",hhID);
    query.select("location","hhID");
    query.find({
        success: function (results) {
            successCallback(results);
        },
        error: function (error) {
            errorCallback(error);
        }
    });
}


//获取秀场邀请列表
function getInviteShowSkillOrders(hhID,successCallback, errorCallback){
    var ShowSkill = Bmob.Object.extend("ShowSkill");
    var ShowSkill = new Bmob.Query(ShowSkill);
    ShowSkill.equalTo("ownerID", hhID);
	ShowSkill.notEqualTo("serviceOffline",1);
    ShowSkill.select("ownerID","skillID","skillType","skillName","skillPay","skillDescription","firstPhoto","skillTime","showUnit");
    ShowSkill.descending("createdAt");
    ShowSkill.find({
        success: function (results) {
            successCallback(results);
        },
        error: function (error) {
            errorCallback(error);
        }
    });
}

//删除我的秀场列表中某个技能
function delThisShowMessage2(hhID,skillID,successCallback, errorCallback){
	var ShowSkill = Bmob.Object.extend("ShowSkill");
	var query = new Bmob.Query(ShowSkill);
	query.equalTo("skillID",skillID);
    query.equalTo("ownerID", hhID);
    query.destroyAll({
		success : function() {
            successCallback();
		},
		error : function(error) {
			consoledebug.log('deleteHelpOrder HelpOrder error is '+ JSON.stringify(error));
            errorCallback(error);
		}
	});
}

//删除我的秀场列表中某个技能
function delThisShowMessage(hhID,skillID,successCallback, errorCallback){
	var ShowSkill = Bmob.Object.extend("ShowSkill");
	var query = new Bmob.Query(ShowSkill);
	query.equalTo("skillID",skillID);
    query.equalTo("ownerID", hhID);
    query.find().then(function(results) {
    	results[0].set("serviceOffline",1);
    	results[0].save().then(function(){
    		successCallback();
    	},function(error){
    		errorCallback(error);
    	})
	},function(error) {
		consoledebug.log('deleteHelpOrder HelpOrder error is '+ JSON.stringify(error));
        errorCallback(error);
	});
}
/**
 * 秀场首页
 * @param {object}Condition
 *          ageMin:Number 年龄最小值
 *          ageMax:Number 年龄最大值
 *          paymentMin:Number 金额最小值
 *          paymentMax:Number 金额最大值
 *          sex:String 性别，空时为所有性别
 *          location：Bmob.GeoPoint 当前用户的地理位置
 *          skillType：String 类别
 * @param {function} successCallback(showSkill) 返回Bmob.Object.extend("ShowSkill")的数组，包含如下列
 *          "skillID","skillName","skillPay","skillDescription","ownerID", "skillTime","firstPhoto"
 *          skillID;              Number                技能ID
            ownerID:              Number                用户ID
            skillName:            String                技能名称
            skillType:            String                技能分类
            skillPay:             Number                报酬
            skillTime:            String                帮助时间
            skillDescription:     String                技能说明
            firstPhoto:           String                首张照片 url
 *          用 showSkill[0].get("skillID")方法提取
 * @param errorCallback
 */

function makeShowSkillQuery2(Condition){
	var UserInfo = Bmob.Object.extend("UserInfo");
    var userInfo = new Bmob.Query(UserInfo);
    var ShowSkill = Bmob.Object.extend("ShowSkill");
    var showSkill = new Bmob.Query(ShowSkill);
    if(Condition.hasOwnProperty('ageMin')){
        userInfo.greaterThanOrEqualTo("age",Condition.ageMin);
    }
    if(Condition.hasOwnProperty('ageMax')){
        userInfo.lessThanOrEqualTo("age",Condition.ageMax);
    }
    if(Condition.hasOwnProperty('sex'))
    {
    	if(Condition.sex == 1){
            userInfo.notEqualTo("sex","女");
        }
		if(Condition.sex == 2){
        	userInfo.notEqualTo("sex","男");
        }
    }
    if(Condition.hasOwnProperty('paymentMin')){
        showSkill.greaterThanOrEqualTo("skillPay",Condition.paymentMin);
    }
    if(Condition.hasOwnProperty('paymentMax')){
        showSkill.lessThanOrEqualTo("skillPay",Condition.paymentMax);
    }
    if(Condition.hasOwnProperty('location')){
        userInfo.withinKilometers("location", Condition.location, 100);
        //userInfo.near("location", Condition.location);
    }
    if(Condition.hasOwnProperty('skillType')){
        showSkill.containedIn("skillType",Condition.skillType);
    }
    showSkill.matchesKeyInQuery("ownerID","hhID",userInfo);
    showSkill.include("ownerInfo");
    
    showSkill.lessThanOrEqualTo("reportNum",3);
    ShowSkill.notEqualTo("serviceOffline",1);
    showSkill.notEqualTo("ownerID",getMyAccount().hhID);
    showSkill.descending("createdAt");
    //showSkill.select("skillID","skillName","skillPay","skillDescription","ownerID");
    showSkill.limit(SKIP_NUMBER);
    
    return showSkill;
}



/*秀场排序规则：
 * 1.三天内	80公里内	时间降序	5条
 * 2.15天内	80公里内	成交数降序	20条
 * 3.三天内	80公里内	时间降序	不限
 * 4.80公里内	其余单	成交数降序	不限
 * 5.八十公里外		成交数降序		不限
 */


var gGonditionLevel = 1;	//条件级别		1.（1）三天内 ，（2）80公里内  （3）时间降序   (获取5条) 2.（1）80公里内（2）15天内（3）成交数量降序(获取10条)
								//  3.（1）80公里内（2）其余订单（3）成交数量降序	4.（1）80公里外（2）成交数量降序
var time_ms = 86400000;	   //一天的毫秒数
function makeShowSkillQuery(Condition){
	consoledebug.log("makeShowSkillQuery Condition is "+JSON.stringify(Condition));
	var UserInfo = Bmob.Object.extend("UserInfo");
    var userInfo = new Bmob.Query(UserInfo);
    var ShowSkill = Bmob.Object.extend("ShowSkill");
    var showSkill = new Bmob.Query(ShowSkill);
    showSkill.notEqualTo("serviceOffline",1);
    if(Condition.hasOwnProperty('ageMin')){
        userInfo.greaterThanOrEqualTo("age",Condition.ageMin);
    }
    if(Condition.hasOwnProperty('ageMax')){
        userInfo.lessThanOrEqualTo("age",Condition.ageMax);
    }
    
    if(Condition.hasOwnProperty('sex'))
    {
    	if(Condition.sex == 1){
            userInfo.notEqualTo("sex","女");
        }
		if(Condition.sex == 2){
        	userInfo.notEqualTo("sex","男");
        }
    }
    if(Condition.hasOwnProperty('paymentMin')){
        showSkill.greaterThanOrEqualTo("skillPay",Condition.paymentMin);
    }
    if(Condition.hasOwnProperty('paymentMax')){
        showSkill.lessThanOrEqualTo("skillPay",Condition.paymentMax);
    }
    
    if(Condition.hasOwnProperty('skillType')){
        showSkill.containedIn("skillType",Condition.skillType);
    }
    
    if(Condition.hasOwnProperty('classification')){
        showSkill.equalTo("classification", Number(Condition.classification));
    }
    
//  showSkill.include("ownerInfo");
    
    showSkill.lessThanOrEqualTo("reportNum",3);
    showSkill.notEqualTo("ownerID",getMyAccount().hhID);
    
    if(gGonditionLevel == 1){
    	if(Condition.hasOwnProperty('geo')){
		     userInfo.withinKilometers("location", Condition.geo, 80);
		     //userInfo.near("location", Condition.location);
		}
    
	    var myDate = new Date();
	    var mytime=new Date(myDate.getTime()-(3*time_ms));
	    consoledebug.log("makeShowSkillQuery mytime is "+mytime);
	    consoledebug.log("makeShowSkillQuery myDate is "+JSON.stringify(myDate));
	    consoledebug.log("makeShowSkillQuery myDate is "+myDate);
	    showSkill.matchesKeyInQuery("ownerID","hhID",userInfo);
	    showSkill.greaterThanOrEqualTo("createdAt",mytime);
//	    showSkill.equalTo("classification", Number(Condition.classification));
	    showSkill.descending("createdAt");
    	showSkill.limit(LIMIT_NUMBER);
    }else if(gGonditionLevel == 2){
    	if(Condition.hasOwnProperty('geo')){
	        userInfo.withinKilometers("location", Condition.geo, 80);
	    }
    	var myDate = new Date();
	    var mytime=new Date(myDate.getTime()-(15*time_ms));
	    showSkill.greaterThanOrEqualTo("createdAt",mytime);
	    
    	showSkill.matchesKeyInQuery("ownerID","hhID",userInfo);
//  	showSkill.descending("orderCount");
    	showSkill.descending("orderBuy");
//  	showSkill.equalTo("classification", Number(Condition.classification));
		showSkill.descending("createdAt");
    	showSkill.limit(LIMIT_NUMBER2);
    }else if(gGonditionLevel == 3){
	    if(Condition.hasOwnProperty('geo')){
		     userInfo.withinKilometers("location", Condition.geo, 80);
		     //userInfo.near("location", Condition.location);
		}
	    var myDate = new Date();
	    var mytime=new Date(myDate.getTime()-(3*time_ms));
	    consoledebug.log("makeShowSkillQuery mytime is "+mytime);
	    consoledebug.log("makeShowSkillQuery myDate is "+JSON.stringify(myDate));
	    consoledebug.log("makeShowSkillQuery myDate is "+myDate);
	    showSkill.matchesKeyInQuery("ownerID","hhID",userInfo);
	    showSkill.greaterThanOrEqualTo("createdAt",mytime);
//	    showSkill.equalTo("classification", Number(Condition.classification));
	    showSkill.descending("createdAt");
	    showSkill.descending("orderBuy");
    	showSkill.limit(SKIP_NUMBER);
    }else if(gGonditionLevel == 4){
    	if(Condition.hasOwnProperty('geo')){
	        userInfo.withinKilometers("location", Condition.geo, 80);
	    }
    	var myDate = new Date();
	    var mytime=new Date(myDate.getTime()-(15*time_ms));
	    showSkill.matchesKeyInQuery("ownerID","hhID",userInfo);
//	    showSkill.equalTo("classification", Number(Condition.classification));
	    showSkill.lessThan("createdAt",mytime);
//	    showSkill.descending("orderCount");
	    showSkill.descending("orderBuy");
	    showSkill.descending("createdAt");
    	showSkill.limit(SKIP_NUMBER);
    }else if(gGonditionLevel == 5){
    	
	    consoledebug.log("makeShowSkillQuery gGonditionLevel is 444");
    	if(Condition.hasOwnProperty('geo')){
	        userInfo.withinKilometers("location", Condition.geo, 80);
	    }
    	showSkill.doesNotMatchKeyInQuery("ownerID","hhID",userInfo);
//  	showSkill.descending("orderCount");
    	showSkill.descending("orderBuy");
//  	showSkill.equalTo("classification", Number(Condition.classification));
    	showSkill.descending("createdAt");
    	showSkill.limit(SKIP_NUMBER);
    }
    return showSkill;
}



var SKIP_NUMBER = 5;
var LIMIT_NUMBER = 5;
var LIMIT_NUMBER2 = 20;
var gSkillSkipNum = 0;
var gShowSkillQuery;
var gShowSkillNewQuery
var gCondition;
var gShowSkillNewQuery;
var gSkillSkipNewNum = 0;
var gShowSkillZone = 3;
var gShowSkillMark = [];

var gShowSkillinfos_
function showSkillList(Condition,successCallback,errorCallback){
	gShowSkillNewQuery = null;
	gSkillSkipNewNum = 0;
	gGonditionLevel = 1;
   	gCondition = Condition;
   	var showSkill = makeShowSkillQuery(gCondition);
   	
   	gSkillSkipNum = 0;
    gShowSkillQuery = showSkill;
    
    showSkill.find({
        success: function (showSkillInfo) {
        	consoledebug.log("showSkillList showSkillInfo is "+JSON.stringify(showSkillInfo));
	        consoledebug.log("showSkillList gShowSkillMark is "+JSON.stringify(gShowSkillMark));
			if(showSkillInfo.length >= SKIP_NUMBER) {
	        	gShowSkillinfos_ = showSkillInfo;
                gSkillSkipNum += showSkillInfo.length;
                successCallback(showSkillInfo);
            }else{
                showSkillListNext(showSkillInfo,successCallback, errorCallback);
            }
        },
        error: function (error) {
            errorCallback(error);
        }
    });
}



/**
 * 获取秀场列表的下一页，与showSkillList 方法配套使用，参数一致
 */
var gIsFirst = true;
var gCondShowSkillInfo2;
function showSkillListNext(foundOrders, successCallback, errorCallback) {
	var myError = {};
	if (gSkillSkipNum == 0) {
		if (gGonditionLevel >= 5) {
			myError.code = 888;
			myError.message = "No more record";
			errorCallback(myError);
			return;
		}
		gGonditionLevel++;
		var newQuery = makeShowSkillQuery(gCondition);
		//在条件一二获取的数量都小于限制数量时，并且是第一次进入条件三时，应该跳过条件一获取到的五个，（即使在条件一下就不够5个也满足，以为条件一和三基本相同）
		if(gGonditionLevel == 3){
			gShowSkillQuery.skip(LIMIT_NUMBER);
		}
		gShowSkillQuery = newQuery;
	} else if (gSkillSkipNum < MAX_SKILL_LIST) {
		if(gGonditionLevel == 1 || gGonditionLevel == 2){
			gGonditionLevel++;
			gShowSkillQuery = makeShowSkillQuery(gCondition);
			//当第一次进入条件三时，应该跳过条件一获取到的五个，（即使在条件一下就不够5个也满足，以为条件一和三基本相同）
			if(gGonditionLevel == 3){
				gShowSkillQuery.skip(LIMIT_NUMBER);
			}
		}else{
			gShowSkillQuery.skip(gSkillSkipNum);
		}
	} else {
		myError.code = 888;
		myError.message = "No more record";
		errorCallback(myError);
		return;
	}
	consoledebug.log("123 showSkillListNext gGonditionLevel is " + gGonditionLevel);
	gShowSkillQuery.find().then(function(showSkillInfo) {
		consoledebug.log("showSkillListNext showSkillInfo is " + JSON.stringify(showSkillInfo));
		if (showSkillInfo.length + foundOrders.length < SKIP_NUMBER) {
			gSkillSkipNum = 0;
			foundOrders = foundOrders.concat(showSkillInfo);
			showSkillListNext(foundOrders, successCallback, errorCallback);
		} else {
			gSkillSkipNum += showSkillInfo.length;
			foundOrders = foundOrders.concat(showSkillInfo);
//			consoledebug.log("456 showSkillListNext foundOrders is " + JSON.stringify(foundOrders));
//			consoledebug.log("456 showSkillListNext foundOrders length is " + foundOrders.length);
			successCallback(foundOrders);
		}
	}, errorCallback);
}



function showSkillList2(Condition,successCallback,errorCallback){
	gShowSkillNewQuery = null;
	gSkillSkipNewNum = 0;

   	gCondition = Condition;
   	var showSkill = makeShowSkillQuery(gCondition);
   	
   	gSkillSkipNum = 0;
    gShowSkillQuery = showSkill;
    
    showSkill.find({
        success: function (showSkillInfo) {
			if(showSkillInfo.length >= SKIP_NUMBER) {
                gSkillSkipNum += showSkillInfo.length;
                successCallback(showSkillInfo);
            }else{
                showSkillListNext(successCallback, errorCallback);
            }
        },
        error: function (error) {
            errorCallback(error);
        }
    });
}

/**
 * 获取秀场列表的下一页，与showSkillList 方法配套使用，参数一致
 */
function showSkillListNext2(successCallback,errorCallback){
	if(gShowSkillQuery){
		consoledebug.log("showSkillListNext gSkillSkipNum is "+gSkillSkipNum);
		gShowSkillQuery.skip(gSkillSkipNum);
		gShowSkillQuery.include("ownerInfo");
		gShowSkillQuery.limit(SKIP_NUMBER);
		gShowSkillQuery.find().then(function(showSkillInfo){
			consoledebug.log("showSkillListNext showSkillInfo is "+JSON.stringify(showSkillInfo));
			if(showSkillInfo.length == 0){
				var ShowSkill = Bmob.Object.extend("ShowSkill");
    			var oldQuery = new Bmob.Query(ShowSkill);
    			oldQuery.withinKilometers("orderGeo", gCondition.geo, 100);
    			
    			var condition = clone(gCondition);
				delete condition.location;
				var newQuery = makeShowSkillQuery(condition);

				newQuery.doesNotMatchKeyInQuery("skillID", "skillID", oldQuery);
				
				gShowSkillQuery = null;
	    		gShowSkillNewQuery = newQuery;
	    		gShowSkillNewQuery.find().then(function(showSkillInfo){
			        if(showSkillInfo.length == 0){
			    		errorCallback();
			    	}else{
			    		gSkillSkipNewNum += showSkillInfo.length;
			        	successCallback(showSkillInfo);
			    	}
			    },errorCallback);
			}else{
				gSkillSkipNum += showSkillInfo.length;
		        successCallback(showSkillInfo);
			}
	    },errorCallback);
	}else if(gShowSkillNewQuery){
		gShowSkillNewQuery.skip(gSkillSkipNewNum);
	    gShowSkillNewQuery.include("ownerInfo");	//每次重新find 时都需要再设置此值
	    gShowSkillNewQuery.limit(SKIP_NUMBER);
	    gShowSkillNewQuery.find().then(function(showSkillInfo){
	    	if(showSkillInfo.length == 0){
	    		errorCallback();
	    	}else{
	    		gSkillSkipNewNum += showSkillInfo.length;
	        	successCallback(showSkillInfo);
	    	}
	    },errorCallback);
	}
}


function clone(myObj){  
  if(typeof(myObj) != 'object') return myObj;  
  if(myObj == null) return myObj;  
  var myNewObj = new Object();  
  for(var i in myObj)  
     myNewObj[i] = clone(myObj[i]);  
  return myNewObj;  
}




function makeSearchShowSkillQuery(condition){
	consoledebug.log("makeSearchShowSkillQuery condition is " + JSON.stringify(condition))
	var hhID = getMyAccount().hhID;
	
	var UserInfo = Bmob.Object.extend("UserInfo");
    var userInfo = new Bmob.Query(UserInfo);
    
    var ShowSkill = Bmob.Object.extend("ShowSkill");
    var query1 = new Bmob.Query(ShowSkill);
    query1.lessThanOrEqualTo("reportNum",3);
    query1.notEqualTo("ownerID",hhID);
    query1.notEqualTo("serviceOffline",1);
    if(condition.hasOwnProperty('skillName')){
        query1.contains("skillName",condition.skillName);
    }
    
    var ShowSkill = Bmob.Object.extend("ShowSkill");
    var query2 = new Bmob.Query(ShowSkill);
    query2.lessThanOrEqualTo("reportNum",3);
    query2.notEqualTo("ownerID",hhID);
    query2.notEqualTo("serviceOffline",1);
    if(condition.hasOwnProperty('skillDescription')){
        query2.contains("skillDescription",condition.skillDescription);
    }
    var query = Bmob.Query.or(query1, query2);
    query.matchesKeyInQuery("ownerID","hhID",userInfo);
//  query.include("ownerInfo");
    query.descending("orderBuy");
    query.limit(SEARCH_SKIP_NUMBER);
    query.descending("createdAt");
    return query;
}





var SEARCH_SKIP_NUMBER = 5;
var gSearchSkillSkipNum = 0;
var gSearchShowSkillQuery;
var gSearchShowSkillMark = [];
var gSearchCondition;
//根据关键词进行搜索相关列表
function searchShowSkillList(condition,successCallback,errorCallback){
	consoledebug.log("condition is " + JSON.stringify(condition))
	
	gSearchCondition = condition;
	
    var searchShowSkillQuery = makeSearchShowSkillQuery(condition);
    gSearchSkillSkipNum = 0;
    gSearchShowSkillQuery = searchShowSkillQuery;
    
    searchShowSkillQuery.find({
        success: function (showSkillInfo) {
            if(showSkillInfo.length >= SEARCH_SKIP_NUMBER){
            	gSearchSkillSkipNum += showSkillInfo.length;
            	consoledebug.log("searchShowSkillList gSearchSkillSkipNum is " + gSearchSkillSkipNum);
                successCallback(showSkillInfo);
            }else{
                showSearchSkillListNext(showSkillInfo,successCallback, errorCallback);
            }
        },
        error: function (error) {
            errorCallback(error);
        }
    });
}

function showSearchSkillListNext(foundOrders,successCallback, errorCallback){
    consoledebug.log("searchShowSkillList gSearchSkillSkipNum is " + gSearchSkillSkipNum);
	var myError = {};
	if (gSearchSkillSkipNum == 0) {
		myError.code = 888;
		myError.message = "No more record";
		errorCallback(myError);
		return;
	} else if (gSearchSkillSkipNum < MAX_SKILL_LIST) {
		gSearchShowSkillQuery.skip(gSearchSkillSkipNum);
	} else {
		myError.code = 888;
		myError.message = "No more record";
		errorCallback(myError);
		return;
	}
	gSearchShowSkillQuery.find().then(function(showSkillInfo) {
		consoledebug.log("showSearchSkillListNext showSkillInfo is " + JSON.stringify(showSkillInfo));
		gSearchSkillSkipNum += showSkillInfo.length;
		foundOrders = foundOrders.concat(showSkillInfo);
		successCallback(foundOrders);
	}, errorCallback);
}





var POPSHOW_SKIP_NUMBER = 5;
var gPopularShowSkillSkipNum = 0;
var gPopularShowSkillQuery;
//获取首页服务列表
function GetallPopularShow(successCallback,errorCallback){
	allPopularShow = Bmob.Object.extend("ShowSkill");
	var query = new Bmob.Query(allPopularShow);
	query.descending("orderBuy");
	query.descending("createdAt");
	query.limit(POPSHOW_SKIP_NUMBER);
	gPopularShowSkillQuery = query;
	query.find({
        success: function (showSkillInfo) {
        	if(showSkillInfo.length >= POPSHOW_SKIP_NUMBER){
            	gPopularShowSkillSkipNum += showSkillInfo.length;
            	consoledebug.log("GetallPopularShow gPopularShowSkillSkipNum is " + gPopularShowSkillSkipNum);
                successCallback(showSkillInfo);
            }else{
                getallPopularShowNext(showSkillInfo,successCallback, errorCallback);
            }
        },
        error: function (error) {
            errorCallback(error);
        }
    });
}

function getallPopularShowNext(foundOrders,successCallback, errorCallback){
    consoledebug.log("getallPopularShowNext gPopularShowSkillSkipNum is " + gPopularShowSkillSkipNum);
	var myError = {};
	if (gPopularShowSkillSkipNum == 0) {
		myError.code = 888;
		myError.message = "No more record";
		errorCallback(myError);
		return;
	} else if (gPopularShowSkillSkipNum < MAX_SKILL_LIST) {
		gPopularShowSkillQuery.skip(gPopularShowSkillSkipNum);
	} else {
		myError.code = 888;
		myError.message = "No more record";
		errorCallback(myError);
		return;
	}
	gPopularShowSkillQuery.find().then(function(showSkillInfo) {
		consoledebug.log("getallPopularShowNext showSkillInfo is " + JSON.stringify(showSkillInfo));
		gPopularShowSkillSkipNum += showSkillInfo.length;
		foundOrders = foundOrders.concat(showSkillInfo);
		successCallback(foundOrders);
	}, errorCallback);
}







/**
 * 添加评论
 * @param {string}myInfoId 发布者的人物信息数据库中的id
 * @param {Bmob.Object}showSkillRecord 秀场记录
 * @param {Object}Comment
 *          skillID:Number 技能id
 *          commentID:Number 评论用户的用户ID
 *          commentInfo:String 评论内容
 * @param {function} successCallback 成功则返回技能ID .
 * 		successCallback(id); 评论内部id
 * @param errorCallback
 */
function insertShowSkillComment(myInfoId, showSkillRecord, Comment,successCallback,errorCallback){
    var UserInfo = Bmob.Object.extend("UserInfo");
    var myInfo = new UserInfo();
    myInfo.id = myInfoId;
    var ShowSkillComment = Bmob.Object.extend("ShowSkillComment");
    var showSkillComment = new ShowSkillComment();
    showSkillComment.set("skillID", Comment.skillID);
    showSkillComment.set("commentInfo", Comment.commentInfo);
    showSkillComment.set("showInfo", showSkillRecord);
    showSkillComment.set("OwnerInfo", myInfo);
    consoledebug.log('insertComment showSkillComment is '+ JSON.stringify(showSkillComment));
    showSkillComment.save().then(function(showSkillComment){
    	successCallback(showSkillComment);
    },function(error){
    	 consoledebug.log("insertShowSkillComment error is " + JSON.stringify(error));
    	 errorCallback(error);
    })
    
//  null,{
//      success: function (showSkillComment) {
//      	 consoledebug.log("insertShowSkillComment showSkillComment.id is "+showSkillComment.id);
//          successCallback(showSkillComment.id);
//      },
//      error: function (error) {
//      	 consoledebug.log("insertShowSkillComment error is " + JSON.stringify(error));
//          //alert("鏌ヨ澶辫触: " + error.code + " " + error.message);
////            api.toast({msg: error.message, location: 'middle'});
//          errorCallback(error);
//      }
//  });
}


/**
 * 获取技能的所有评论
 * @param skillID 技能ID
 * @param {function}successCallback
 *          showSkillCommentInfo 为Bmob.Object的数组，用.get("")提取内容
 *          "skillID","commentID","commentInfo"
 *          其中，评论的id 通过 showSkillCommentInfo[0].id 获取
 * @param errorCallback
 */
//获取普通评论
var COMMENT_SKIP_NUMBER = 5;
var gSkillCommentSkipNum = 0;
function makeShowSkillCommentCondition(skillID){
	var ShowSkillComment = Bmob.Object.extend("ShowSkillComment");
    var showSkillComment = new Bmob.Query(ShowSkillComment);
    showSkillComment.include("OwnerInfo");
    showSkillComment.equalTo("skillID",skillID);
    showSkillComment.descending("createdAt");
    showSkillComment.limit(COMMENT_SKIP_NUMBER);
    return showSkillComment;
}
function findShowSkillComments(skillID,successCallback,errorCallback){
	var showSkillComment = makeShowSkillCommentCondition(skillID);
	showSkillComment.skip(gSkillCommentSkipNum);
	showSkillComment.find().then(function(results){
        gSkillCommentSkipNum += results.length;
		successCallback(results);
	},function(error){
		errorCallback(error);
	})
}

//获取普通评论总数
function getSkillCommentListCount(skillID,successCallback,errorCallback){
	var ShowSkillComment = Bmob.Object.extend("ShowSkillComment");
    var showSkillComment = new Bmob.Query(ShowSkillComment);
    showSkillComment.equalTo("skillID",skillID);
    showSkillComment.count().then(function(count){
    	successCallback(count);
    },function(error){
    	errorCallback(error);
    })
}



/*
 * 获取买家对秀场的评论
 * 
 */
var BUYCOMMENT_SKIP_NUMBER = 5;
var gBuySkillCommentSkipNum = 0;
function getBuyerComments(skillID,successCallback,errorCallback){
	var HelperList = Bmob.Object.extend("HelperList");
    var query = new Bmob.Query(HelperList);
	
	var HelpOrder = Bmob.Object.extend("HelpOrder");
    var helpOrder = new Bmob.Query(HelpOrder);

	var ShowSkill = Bmob.Object.extend("ShowSkill");
    var showSkill = new Bmob.Query(ShowSkill);
    showSkill.equalTo("skillID",skillID);
    helpOrder.matchesKeyInQuery("skillID", "skillID", showSkill);
    
    query.matchesKeyInQuery("orderID", "orderID", helpOrder);
    query.select("orderID","commentCon","helperAppraisement","TaskEvaluation","ownerID","isAnonymity","order");
    query.limit(BUYCOMMENT_SKIP_NUMBER);
    query.skip(gBuySkillCommentSkipNum);
    query.descending("createdAt");
    query.include("order");
    query.find().then(function(results){
    	consoledebug.log("getBuyerComments results is " + JSON.stringify(results));
    	gBuySkillCommentSkipNum += results.length;
    	var hhIDArray = [];
    	//var buyCommentInfos = [];
    	for(var i = 0; i < results.length; i++){
    		var order = results[i].get("order")
    		consoledebug.log("getBuyerComments push hhID is " + order.get("ownerID"));
    		hhIDArray.push(order.get("ownerID"));
    		//buyCommentInfos[order.get("ownerID")] = results[i];
    	}
    	var buyerInfos = [];
    	getBuyerInfo(hhIDArray,function(userInfos){
    		consoledebug.log("getBuyerComments getBuyerInfo userInfos is " + JSON.stringify(userInfos));
    		for(var i = 0; i < userInfos.length; i++){
//	    		buyerInfos[userInfos[i].get("hhID")] = userInfos[i];
	    		buyerInfos[userInfos[i].hhID] = userInfos[i];
	    	}
	    	consoledebug.log("getBuyerComments getBuyerInfo buyerInfos is " + JSON.stringify(buyerInfos));
    		successCallback(buyerInfos,results);
    	},function(error){
    		errorCallback(error);
    	})
    },function(error){
    	errorCallback(error);
    })
}
function getBuyerCommentsCount(skillID,successCallback,errorCallback){
	var HelperList = Bmob.Object.extend("HelperList");
    var query = new Bmob.Query(HelperList);

	var HelpOrder = Bmob.Object.extend("HelpOrder");
    var helpOrder = new Bmob.Query(HelpOrder);

	var ShowSkill = Bmob.Object.extend("ShowSkill");
    var showSkill = new Bmob.Query(ShowSkill);
    showSkill.equalTo("skillID",skillID);
    helpOrder.matchesKeyInQuery("skillID", "skillID", showSkill);
    query.matchesKeyInQuery("orderID", "orderID", helpOrder);
    query.count().then(function(count){
    	successCallback(count);
    },function(error){
    	errorCallback(error);
    })
}


/*
 * 获取评论人的人物信息
 */
function getBuyerInfo(hhIDArray,successCallback,errorCallback){
//	var UserInfo = Bmob.Object.extend("UserInfo");
//  var query = new Bmob.Query(UserInfo);
//	query.containedIn("hhID", hhIDArray);
//	query.select("hhID","sex","nickName","photoThumbnail");
//	query.find().then(function(userInfos){
//  	successCallback(userInfos);
//  },function(error){
//  	errorCallback(error);
//  })
	getComAllUserInfo(hhIDArray, function(userInfos){
		successCallback(userInfos);
	}, function(error){
		errorCallback(error);
	})
}


/**
 * 点击举报在工单号列表中，添加求助列表中，被举报人相应信息。

 */

function NewShowSkillTable(htinteractionInfo, successCallback, errorCallback) {
	var ShowReport = Bmob.Object.extend("Show_Report");
	var showReport = new ShowReport();
	showReport.set("targetID", htinteractionInfo.get("ownerID"));
	showReport.set("informerID",getMyAccount().hhID);
	showReport.set("orderID", htinteractionInfo.get("skillID"));
	showReport.set("orderName", htinteractionInfo.get("skillDescription"));
//	showReport.set("photo", htinteractionInfo.get("firstPhoto"));
	showReport.set("YN_type", 0);
	showReport.save().then(function(NHtinteraction) {
		var reportNum = htinteractionInfo.get("reportNum") + 1;
		htinteractionInfo.set("reportNum", reportNum);
		htinteractionInfo.save().then(function() {
			successCallback(NHtinteraction);
		}, function(error) {
			errorCallback(error);
		})
	}, function(error) {
		errorCallback(error);
	})
}
