/**
 * 获取自己报名的订单信息
 * @param orderID  求助订单
 * @param state   帮助人的状态
 * @param type   确定是在哪个页面
 * @param successCallback
 * @param errorCallback
 */
function getHelperLists(type,orderID,successCallback,errorCallback){
	var HelperList = Bmob.Object.extend("HelperList");
    var query = new Bmob.Query(HelperList);
    orderID = Number(orderID);
    query.equalTo("orderID",orderID);
    query.equalTo("ownerID",getMyAccount().hhID);
    query.ascending("createdAt");
    query.find({
        success: function (results) {
            successCallback(results);
        },
        error: function (error) {
            errorCallback(error);
        }
    });
}
/**
 * 根据页面不同获取求助信息以及显示页面
 * @param type   确定是在哪个页面
 * @param successCallback
 * @param errorCallback
 */
function getCommonHelpOrder(type){
	GetHelpOrder(orderID,function(results){
		consoledebug.log('initData GetHelpOrderInfo results is '+ JSON.stringify(results));
		gOrderRecord = results;
		var objEnrollList = bmobChangeObj(results);
		switch(type){
			case "waitPerson":
			 	uiWaitConfirmHelper(objEnrollList);
			 	judgeEnterGroup(objEnrollList, function(){
					var html = '<img src="'+objEnrollList.avatar+'">'+ objEnrollList.groupName +'<span style="color:#999;border:1px solid #999" class="right" orderID="{{=it.activityID}}">进群讨论</span>';
					$api.html($api.byId("eGroup"),html);
				}, function(error){
					consoledebug.log("initActivityData judgeEnterGroup error "+JSON.stringify(error));
				})
	        break;
	        case "Notselect":
				uiNotBeSelected(objEnrollList);
	        break;
	        case "finsh":
				uiHelpDoing(objEnrollList);
	        break;
	        case "waitCheck":
				uiWaitAcceptanceHelp(objEnrollList);
	        break;
	        case "finishHandle":
				uiSettleAccountsHelp(objEnrollList);
				getCommonHelperInfo("finishHandle",objEnrollList,orderID);
				if(gOrderRecord.get("repeatOrder") != undefined){
	        		consoledebug.log("GetHelpOrder repeatOrder is "+JSON.stringify(gOrderRecord.get("repeatOrder")));
			    	api.execScript({
					    name: 'finishHandle',
					    script: "setFooterMode(1);"
					});
				}
	        break;
	        case "helpSuccess":
				uiHelpCompletedIssuer(objEnrollList);
				getCommonHelperInfo("helpSuccess",objEnrollList,orderID)
	        break;
	        case "cancel":
				uiHelpCancel(objEnrollList);
				getCommonHelperInfo("cancel",objEnrollList,orderID)
	        break;
		}
	},function(error){
       	consoledebug.log("GetHelpOrder fail "+JSON.stringify(error));
	});
}

function bmobChangeObj(results){
	var objEnrollList = {} 
	var keys = ["orderID","classID","ownerID","orderName","payment","helperNum","helperSex","beginTime","applyDeadlineTime","place","description","photo","ID","orderGeo","repeatTimes","TaskEvaluation","askerAppraisement","helperAppraisement","repeatTimes"];
	bmob2Obj(keys, results, objEnrollList);
	objEnrollList.updatedAt = results.updatedAt;
    transBeginTime(objEnrollList);
    orderOwner = objEnrollList.ownerID;
	var group = results.get('group');
	objEnrollList.avatar = '../../../image/helpGroup.png';
	var keys2 = ["groupName","rongyunID","avatar","groupID"];
	bmob2Obj(keys2, group, objEnrollList);
	gGroupName = objEnrollList.groupName;
	gGroupID = objEnrollList.rongyunID;
	return objEnrollList;
}

function getCommonHelperInfo(type,objEnrollList,orderID){
	getHelperLists(type,orderID,function(helperOrder){
		gMyhelperOrder = helperOrder;
//		var objEnrollList = {} 
		var keys2 = ["payment","TaskEvaluation","helperAppraisement"];
		bmob2Obj(keys2, helperOrder[0], objEnrollList);
		consoledebug.log('initData helperList objEnrollList is '+ JSON.stringify(objEnrollList));
		switch(type){
			case "cancel":
			 	uiHelpCancelCondition(objEnrollList);
	        break;
			case "finishHandle":
			 	uiSettleAccountsAppraisement(objEnrollList);
	        break;
	        case "helpSuccess":
//				uiHelpCompletedIssuer(objEnrollList);
				uiHelpCompletedIssuerAppraisement(objEnrollList);
	        break;
		}
	},function(error){
		consoledebug.log("getCommonHelperInfo fail "+JSON.stringify(error));
	})
}

