
// 生成guid,主要用于生成随机文件名
function NewGuid() {
	function S4() {
		return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
	}

	return (S4() + S4() + "-" + S4() + "-" + S4() + "-" + S4() + "-" + S4() + S4() + S4());
}

function getFileExt(fileName) {
	consoledebug.log("getFileExt fileName is " + typeof fileName + fileName);
	return fileName.substring(fileName.lastIndexOf('.') + 1);
}

// 获取当前的时间，拼接成2015-11-09这样的格式，主要用于对图片进行时间分类
function getNowFormatDate() {
	var date = new Date();
	var seperator1 = "-";
	var year = date.getFullYear();
	var month = date.getMonth() + 1;
	var strDate = date.getDate();
	if (month >= 1 && month <= 9) {
		month = "0" + month;
	}
	if (strDate >= 0 && strDate <= 9) {
		strDate = "0" + strDate;
	}
	var currentdate = year + seperator1 + month + seperator1 + strDate
	return currentdate;
}

// 图片压缩
// imgsrc：源图片的路径
// quality：图片压缩质量，一般建议0.5
// scale：图片压缩比例，也是建议0.5
// ext：源图片拓展名
// callback：转换成功之后回调函数
function imgCompress(imgsrc, ext, callback) {
	// 压缩文件的保存目录
	var savePath = api.cacheDir + "/temp/";
	// 压缩文件生成的随机文件名称
	var savename = NewGuid() + "." + ext;
	var imageFilter = api.require('imageFilter');

	consoledebug.log("imgCompress imgsrc is " + imgsrc + " savePath is " + savePath + " savename is " + savename);
	
	imageFilter.getAttr({
	    path: imgsrc
	}, function(ret, err){
		consoledebug.log("imageFilter getAttr ret is " + JSON.stringify(ret) + " err: " + JSON.stringify(err));
		if(ret.status){
			var shortLine = (ret.width > ret.height) ? ret.height : ret.width;
			var scale = 800 / shortLine;
			scale = (scale > 1) ? 1 : scale;
			imageFilter.compress({
				img : imgsrc,
				quality : 1,
				scale : scale,
				save : {
					album : false,
					imgPath : savePath,
					imgName : savename
				}
			}, function(ret, err) {
				consoledebug.log("imgCompress imageFilter ret is " + JSON.stringify(ret) + " err: " + JSON.stringify(err));
				if (ret) {
					callback(savePath + savename);
				} else {
					alert(JSON.stringify(err));
				}
			});
		}
	});
}


// 图片压缩
// imgsrc：源图片的路径
// quality：图片压缩质量，一般建议0.5
// scale：图片压缩比例，也是建议0.5
// ext：源图片拓展名
// callback：转换成功之后回调函数,返回本地图片路径
function imgThumbnailCompress(imgsrc, dWidth, dHeight, callback) {
	// 压缩文件的保存目录
	var savePath = api.cacheDir + "/temp/";
	// 压缩文件生成的随机文件名称
	var savename = NewGuid() + "." + getFileExt(imgsrc);
	var imageFilter = api.require('imageFilter');

	consoledebug.log("imgThumbnailCompress imgsrc is " + imgsrc + " savePath is " + savePath + " savename is " + savename);
	
	imageFilter.getAttr({
	    path: imgsrc
	}, function(ret, err){
		consoledebug.log("imageFilter getAttr ret is " + JSON.stringify(ret) + " err: " + JSON.stringify(err));
		if(ret.status){
			var scale;
        	if(ret.width/ret.height > dWidth/dHeight){
        		scale = dHeight/ret.height
        	}else{
        		scale = dWidth/ret.width
        	}
			scale = (scale >1) ? 1 : scale;
        	consoledebug.log("imgThumbnailCompress ret.width "+ret.width+" ret.height "+ret.height+" scale "+scale+" dWidth "+dWidth+" dHeight "+ dHeight);
			imageFilter.compress({
				img : imgsrc,
				quality : 0.8,
				scale : scale,
				save : {
					album : false,
					imgPath : savePath,
					imgName : savename
				}
			}, function(ret, err) {
				consoledebug.log("imgThumbnailCompress imageFilter ret is " + JSON.stringify(ret) + " err: " + JSON.stringify(err));
				if (ret.status == true) {
					callback(savePath + savename);
				} else {
					alert(JSON.stringify(err));
				}
			});
		}
	});
}
//美化图片
function photoEdit(srcPath, successCallback, errorCallback) {
	var obj = api.require('camera360');
	var savePath = 'fs://temp/' + NewGuid() + "." + getFileExt(srcPath);
	var msg = {
		path : srcPath,
		savePath : savePath
	}
	obj.open(msg, function(ret) {
		consoledebug.log("camera360 ret is " + JSON.stringify(ret));
		if (ret.eventType == 'cancel') {
			errorCallback();
		} else if (ret.eventType == 'finish') {
			var fs = api.require('fs');
			fs.exist({
				path : savePath
			}, function(fsRet, err) {
				if (fsRet.exist) {
					successCallback(ret.path);
//					imgCompress(savePath, getFileExt(savePath), function(src) {
//						successCallback(src);
//					})
				} else {
					successCallback(srcPath);
//					imgCompress(srcPath, getFileExt(srcPath), function(src) {
//						successCallback(src);
//					})
				}
			});
		} else {
			errorCallback();
		}
	});
}


function getPictuer(successCallback, errorCallback){
	api.actionSheet({
		cancelTitle : '取消',
		buttons : ['相册', '照相机']
	}, function(ret, err) {
		if (ret.buttonIndex == 1) {
			var scene = 'album';
			select(scene, successCallback, errorCallback);
		} else if (ret.buttonIndex == 2) {
			var scene = 'camera';
			select(scene, successCallback, errorCallback);
		} else {
			errorCallback();
		}
	});
}


function select(scene, successCallback, errorCallback) {
	consoledebug.log("camera360 start ");
	api.getPicture({
		sourceType : scene,
		encodingType : 'jpg',
		mediaValue : 'pic',
		destinationType : 'url'
	}, function(ret, err) {
		if (ret) {
			var imgUrl = ret.data;
			if (!imgUrl) {//如果不选择图片，则退出
				return;
			}
			successCallback(imgUrl);
//			if(api.systemType != 'ios'){
//				photoEdit(imgUrl, function(savePath){
//					consoledebug.log("camera360 return savePath is " + savePath);
//					successCallback(savePath);
//				},function(){
//					errorCallback();
//				});
//			}else{
//				successCallback(imgUrl);
//			}
		} else {
			api.alert({
				msg : err.msg
			});
		}
	});
};

//callback(dataurl)
function photoClip(url, dWidth, dHeight, callback) {
    consoledebug.log("avatarClip url is " + url);
    var canvas = document.createElement('CANVAS'), ctx = canvas.getContext('2d'), img = new Image;
    img.crossOrigin = 'Anonymous';
    img.onload = function() {
        var dataURL;
        var xClip, yClip;
        xClip = (img.width - dWidth) / 2;
        yClip = (img.height - dHeight) / 2;
        consoledebug.log("dWidth and dHeight is " + dWidth +" "+ dHeight+" "+img.width+" "+img.height);
        consoledebug.log("xClip and yClip is " + xClip +" "+ yClip);
        canvas.height = dHeight;
        canvas.width = dWidth;
        
        if(xClip < 0 || yClip < 0){
//			ctx.drawImage(img, 0, 0);
			var oScale = dWidth/dHeight;
			var tScale = img.width/img.height;
			consoledebug.log("oScale and tScale is " + oScale +" "+ tScale);
			if(oScale > tScale){
				//裁高
				canvas.width = img.width;
				canvas.height = img.width/oScale;
				var yp = (img.height-canvas.height)/2;
				consoledebug.log("yp is " + yp);
				ctx.drawImage(img, 0, yp, canvas.width, canvas.height, 0, 0, canvas.width, canvas.height);
			}else{
				//裁宽
				canvas.width = img.height*oScale;
				canvas.height = img.height;
				var xp = (img.width-canvas.width)/2;
				consoledebug.log("xp is " + xp);
				ctx.drawImage(img, xp, 0, canvas.width, canvas.height, 0, 0, canvas.width, canvas.height);
			}
			
			
//			ctx.drawImage(img, 0, 0, img.width, img.width*dHeight/dWidth, 0, 0, img.width, img.width*dHeight/dWidth);
			dataURL = canvas.toDataURL("image/png");
			callback.call(this, dataURL);
        	canvas = null;
        	return;
        }
        
        consoledebug.log("avatarClip img.width "+img.width+" img.height "+img.height+" xClip "+xClip+" yClip "+yClip+" dWidth "+dWidth+" dHeight "+ dHeight);
        ctx.drawImage(img, xClip, yClip, dWidth, dHeight, 0, 0, dWidth, dHeight);
        
        ctx.rect(0,0,dWidth,dHeight);
        //ctx.stroke();
        ctx.clip();
        
        dataURL = canvas.toDataURL("image/png");
        callback.call(this, dataURL);
        canvas = null;
    };
    img.src = url;
}
    
//url: 资源路径，可以是本地路径
function convertImgToBase64(url, callback, dWidth, dHeight) {
	var canvas = document.createElement('CANVAS'), ctx = canvas.getContext('2d'), img = new Image;
	img.crossOrigin = 'Anonymous';
	img.onload = function() {
		var dataURL;
		var scale = 1;
		if(dHeight && dWidth){
        	if(img.width/img.height > dWidth/dHeight){
        		scale = dHeight/img.height
        	}else{
        		scale = dWidth/img.width
        	}
			scale = (scale > 1) ? 1 : scale;
		}
        consoledebug.log("convertImgToBase64 scale is " + scale + " img height is "+img.height + " width " + img.width);
		canvas.height = img.height;
		canvas.width = img.width;
		ctx.drawImage(img, 0, 0);
		dataURL = canvas.toDataURL("image/png", scale);
		callback.call(this, dataURL);
		canvas = null;
	};
	img.src = url;
}

//img : html img 元素
function getBase64Image(img) {
	var canvas = document.createElement("canvas");
	canvas.width = img.width;
	canvas.height = img.height;

	var ctx = canvas.getContext("2d");
	ctx.drawImage(img, 0, 0);

	var dataURL = canvas.toDataURL("image/png");
	return dataURL;
	// return dataURL.replace("data:image/png;base64,", "");
}




