/*
 * 推送的方法是，每个城市区县都有一个表，
 */

function sendPushList(myUserInfo, hhIDs, className, orderType, orderID){
	if (myUserInfo.sex == "男") {
		sex = "帅哥"
	} else {
		sex = "美女"
	}
	var notifyText, notifyTitle;
	if (orderType == 0) {
		notifyTitle = sex + '想让你帮忙';
		notifyText = myUserInfo.nickName + '想找你' + className;
	} else if (orderType == 1) {
		notifyTitle = sex + '想帮你';
		notifyText = myUserInfo.nickName + '想为你' + '服务';
	} else {
		notifyTitle = sex + '邀请你参加活动';
		notifyText = myUserInfo.nickName + '想和你一起' + className;
	}
	for (var i = 0; i < hhIDs.length; i++) {
		var msg = {
			orderID : orderID, //订单ID
			orderType : orderType, //0为求助，1为秀场，2为活动
			notifyTitle : notifyTitle,
			notifyText : notifyText //用户的提示消息文本
		}
		consoledebug.log('sendPushList msg is' + JSON.stringify(msg));
		sendOrderPushMsg(hhIDs[i].get('hhID'), msg, function() {
		}, function() {
		});
	}
}

function getPushList(TableName, hhID, classID, successCallback, errorCallback){
	var bMap = api.require('bMap');
	bMap.getLocation({
		accuracy : '100m',
		autoStop : true,
		filter : 1
	}, function(ret, err) {
		if (ret.status) {
			var geo = new Bmob.GeoPoint({latitude: ret.lat, longitude: ret.lon});
		    var UserInfo = Bmob.Object.extend("UserInfo");
		    var query = new Bmob.Query(UserInfo);
		    query.withinKilometers("location", geo, 10);
		    query.equalTo(TableName, classID);
		    
			var date = new Date();
			var date2 = date.getTime() - 15*24*60*60*1000;	//15天内登陆过的用户
			date.setTime(date2);
			query.greaterThan("updatedAt", date);
			query.notContainedIn("hhID", [hhID]);
			
		    query.descending("updatedAt");
		    query.limit(20);
		    query.select("hhID");
		    query.find().then(successCallback, errorCallback);
		}else{
			errorCallback();
		}
	})
}

function getHelpPushList(hhID, classID, successCallback, errorCallback){
	getPushList("mySkills", hhID, classID, successCallback, errorCallback);
}

function getShowPushList(hhID, classID, successCallback, errorCallback){
	getPushList("wantHelps", hhID, classID, successCallback, errorCallback);
}

function getActivityPushList(hhID, classID, successCallback, errorCallback){
	getPushList("interestEvents", hhID, classID, successCallback, errorCallback);
}

function helpIssuePush(myUserInfo, orderID, classID, className, successCallback, errorCallback){
    consoledebug.log('helpIssuePush classID is '+ typeof classID + classID + className);
	getHelpPushList(myUserInfo.hhID, classID, function(userList){
        consoledebug.log('helpIssuePush getHelpPushList is'+JSON.stringify(userList));
		sendPushList(myUserInfo, userList, className, 0, orderID);
		successCallback();
	}, errorCallback)
}


function showIssuePush(myUserInfo, orderID, classID, className, successCallback, errorCallback){
    consoledebug.log('showIssuePush classID is '+ typeof classID + classID + className);
	getShowPushList(myUserInfo.hhID, classID, function(userList){
        consoledebug.log('helpIssuePush getHelpPushList is'+JSON.stringify(userList));
		sendPushList(myUserInfo, userList, className, 1, orderID);
		successCallback();
	}, errorCallback)
}


function activityIssuePush(myUserInfo, orderID, classID, className, successCallback, errorCallback){
    consoledebug.log('activityIssuePush classID is '+ typeof classID + classID + className);
	getActivityPushList(myUserInfo.hhID, classID, function(userList){
        consoledebug.log('helpIssuePush getHelpPushList is'+JSON.stringify(userList));
		sendPushList(myUserInfo, userList, className, 2, orderID);
		successCallback();
	}, errorCallback)
}
