var RONGYUN_SDK = "rongCloud2";

var rong;
var db;


function rongyunConnectNet(user, successCallback, errorCallback) {
	consoledebug.log('rongyunConnectNet user is : ' + JSON.stringify(user));
	rong = api.require(RONGYUN_SDK);
	getToken(user.hhID, user.nickName, user.photo, function(err, ret) {
		if (!err) {
			var rToken = ret.token;
			consoledebug.log('网络获取的融云Token:' + rToken);
			rong.connect({
				token : rToken
			}, function(ret, err) {
				if (ret) {
					$api.setStorage(user.hhID+'rongyunToken', rToken);
					successCallback();
				} else {
					alert('通讯功能傲娇了，程序猿表示很紧张，请先退出登陆，然后再登陆');
					errorCallback(err);
				}
			});
		} else {
			consoledebug.log('getToken err is : ' + JSON.stringify(err));
			alert('通讯功能傲娇了，程序猿表示很紧张，请先退出登陆，然后再登陆');
			errorCallback(err);
		}
	});
}

function rongyunLogin(user, successCallback, errorCallback) {
	rong = api.require(RONGYUN_SDK);
	var rongyunToken = $api.getStorage(user.hhID + 'rongyunToken');
	if (rongyunToken && rongyunToken != 0) {
		consoledebug.log('本地缓存融云Token:' + rongyunToken);
		rong.connect({
			token : rongyunToken
		}, function(ret, err) {
			if (ret) {
				consoledebug.log('融云 connect 成功');
				successCallback();
			} else {
				consoledebug.log('融云 connect 失败');
				$api.setStorage(user.hhID + 'rongyunToken', 0);
				rongyunConnectNet(user, successCallback, errorCallback);
			}
		});
	} else {
		rongyunConnectNet(user, successCallback, errorCallback);
	}
}


function rongyunAutoLogin(successCallback, errorCallback){
    var myAcount = getMyAccount();
	//var currentUser = Bmob.User.current();
    if(myAcount){
		rongyunLogin(myAcount, successCallback, errorCallback);
    }else {
        consoledebug.log('用户未登录，无法登录融云');
        errorCallback();
    }
}


function rongyunLogout() {
	rong = api.require(RONGYUN_SDK);
	if(getMyAccount().hhID != undefined){
		var hhID = getMyAccount().hhID;
	}
	if(hhID){
		$api.setStorage(hhID + 'rongyunToken', 0);
	}
	// 断开，且不再接收 Push
	rong.logout(function(ret, err) {
		if (ret.status == 'error')
			api.toast({
				msg : err.code
			});
	});
}


function tong() {
	consoledebug.log('应用的ID:' + api.appId + '\n应用名称:' + api.appName + '\n应用版本号:' + api.appVersion + '\n系统类型:' + api.systemType + '\n手机平台:' + api.systemVersion + '\n引擎版本:' + api.version + '\n唯一标识:' + api.deviceId + '\n推送的Token:' + api.deviceToken + '\n设备型号:' + api.deviceModel + '\n设备名称:' + api.deviceName + '\n运营商名称:' + api.operator + '\n当前网络:' + api.connectionType);
}

function rongyunInit(successCallback, errorCallback) {
	var fs = api.require('fs');
	db = api.require('db');
	fs.exist({
		path : "fs://Location/Location.png"
	}, function(ret, err) {
		if (!ret.exist) {
			fs.copyTo({
				oldPath : 'widget://image/Location.png',
				newPath : 'fs://Location/'
			}, function(ret, err) {
			});
		}
	});
	rong = api.require(RONGYUN_SDK);
	//融云初始化
	rong.init(function(ret, err) {
		if (ret.status == 'error'){
			consoledebug.log('融云初始化失败:' + err.code );
			errorCallback(err);
		}else{
			//禁止融云服务器后台自动通知
			rong.disableLocalNotification( function (ret, err) {
        		//api.toast({ msg: ret.status });
			})
		  successCallback();
		}
	});
	
	rong.setConnectionStatusListener(function(ret, err){
		consoledebug.log('融云连接状态变化:' + JSON.stringify(ret) );
//		if(ret.result.connectionStatus == "NETWORK_UNAVAILABLE"){
//			consoledebug.log('融云连接无法找到可用网络,尝试重新连接');
//			var myAcount = getMyAccount();
//			rongyunConnectNet(myAcount, function(){
//				consoledebug.log('重新尝试连接融云成功');
//			},function(){
//				consoledebug.log('重新尝试连接融云失败');
//			});
//		}
	    //api.toast({ msg: ret.result.connectionStatus });
	});

	db.openDatabase({
		name : 'MYDATABASE'
	}, function(ret, err) {
		if (ret.status) {
			//用户组表
			db.executeSql({
				name : 'MYDATABASE',
				sql : 'create table if not exists name (type text,id text,name text)'
			}, function(ret, err) {
			});
		}
	});

}

function sapotenAjaxKeyRequest(url, method, bodyParam, callBack) {
    var common_url = 'https://'+ bdAddress +'/app/Owl/1/';
    api.ajax({
        url: common_url + url,
        method: method,
        headers: {
            "Content-type": "application/json;charset=UTF-8",
        },
        data: {
            body: bodyParam
        }
    }, function (ret, err) {
        consoledebug.log('sapotenAjaxRequest bodyParam is : '+ JSON.stringify(bodyParam));
        consoledebug.log('sapotenAjaxRequest ret and err is : '+ JSON.stringify(ret) + JSON.stringify(err));
        callBack(err, ret);
    });
}
/* 获取token */
function getToken(userId, username, photoUrl, callback) {
	var request = {
		"userId" : userId,
		"name" : username,
		"portraitUri" : photoUrl
	}
	sapotenAjaxKeyRequest('keyService/rongyunToken', 'POST', request, callback);
}

/* 获取token */
//function getToken(appKey, appSecret, userId, username) {
//	var portraitUri = "http://img1.3lian.com/gif/more/11/201206/a5194ba8c27b17def4a7c5495aba5e32.jpg";
//	var callback = function(ret, err) {
//		var rToken = ret.token;
//      consoledebug.log('网络获取的融云Token:' + rToken );
//		rong.connect({
//			token : rToken
//		}, function(ret, err) {
//			if (ret) {
//				$api.setStorage('rongyunToken', rToken);
////					api.setPrefs({
////						key : 'imgUrl',
////						value : 'http://e.hiphotos.baidu.com/image/h%3D300/sign=093a49af9f25bc31345d07986ede8de7/8694a4c27d1ed21b2a3bb284ab6eddc450da3fe4.jpg'
////					});
//					api.setPrefs({
//						key : 'userName',
//						value : userId
//					});
//					api.setPrefs({
//						key : 'userName2',
//						value : username
//					});
//					api.setPrefs({
//						key : 'password',
//						value : '123456'
//					});
//					api.setPrefs({
//						key : 'isLogin',
//						value : 'true'
//					});
//			} else {
//				alert('聊天功能暂不可用');
//			}
//		});
//	};
//	ajaxToRongCloud(appKey, appSecret, userId, username, portraitUri, callback);
//}
//
///*自定义 和融云通信的 ajax 方法.  */
//function ajaxToRongCloud(appKey, appSecret, userId, name, portraitUri, callback) {
//	var appKey = appKey;
//	var appSecret = appSecret;
//	var nonce = Math.floor(Math.random() * 1000000);
//	var timestamp = Date.now();
//	var signature = hex_sha1("" + appSecret + nonce + timestamp);
//	var userId = userId;
//	var name = name;
//	var portraitUri = portraitUri;
//	var url = "https://api.cn.rong.io/user/getToken.json";
//	api.ajax({
//		url : url,
//		method : "post",
//		headers : {
//			"RC-App-Key" : appKey,
//			"RC-Nonce" : "" + nonce,
//			"RC-Timestamp" : "" + timestamp,
//			"RC-Signature" : "" + signature,
//			"Content-Type" : "application/x-www-form-urlencoded"
//		},
//		data : {
//			values : {
//				userId : userId,
//				name : name,
//				portraitUri : portraitUri
//			}
//		}
//	}, function(ret, err) {
//		if ("function" == typeof callback) {
//			callback(ret, err)
//		}
//	});
//}

/**
   * 解析附加内容，返回 JSON 对象  
   *
   * @param {String} 待解析为 JSON 的字符串
   * @return {Object} 解析后的 JSON 对象
   */
function parseExtra(strJson){
	var objJson = {};
	//做简单字符串判断，否则页面直接挂
	if(typeof strJson == 'string'){
		if(strJson.charAt(0) == '{' && strJson.charAt(strJson.length - 1) == '}' ){
    		//consoledebug.log('parseExtra try to parse ' + strJson);
    		objJson = JSON.parse(strJson);
    		return objJson;
		}
	}
    consoledebug.log('parseExtra: the string is not rigth ' + strJson);
	return objJson;
}

function handleDizNtf(message){
//其中 type 为讨论组操作类型 1:加入讨论组 2：退出讨论组 3:讨论组改名 4：讨论组管理员踢人
    consoledebug.log('handleDizNtf message is ' + JSON.stringify(message));
	switch(message.content.type) {
		case 1:
			notify = ': 有人加入';
			var myAccount = getMyAccount();
			var joinIds = message.content.extension.split(',');
			for (var i = 0; i < joinIds.length; i++) {
				//如果是自己被踢，需要删除会话列表
				if (joinIds[i] == myAccount.hhID) {
		            api.sendEvent({
		                name: 'onConversationFreash',
		                extra: {targetId: message.targetId, type: message.conversationType}
		            });
		            api.sendEvent({
		                name: 'onCreateGroup'
		            });
					break;
				}
			}
			break;
		case 2:
			notify = ': 有人退出';
			break;
		case 3:
			notify = ': 讨论组改名';
			break;
		case 4:
			notify = ': 管理员踢人';
			var myAccount = getMyAccount();
			var removeIds = message.content.extension.split(',');
			for (var i = 0; i < removeIds.length; i++) {
				//如果是自己被踢，需要删除会话列表
				if (removeIds[i] == myAccount.hhID) {
					deleteCoversetion(message.targetId);
		            api.sendEvent({
		                name: 'onRemoveGroup'
		            });
					break;
				}
			}
			break;
		default:
			notify = '： 有新消息';
			break;
	}
}

function addOneMemberToGroup(rongyunID, memberID){
	var groupID;
	rong.addMemberToDiscussion({
		discussionId : rongyunID+"",
		userIdList : [memberID+'']
	}, function(ret, err) {
		if (ret.status == 'success') {
//			getGroupInfoByRyid(rongyunID, function(groupInfo){
//				addGroupMember(groupInfo.get("groupID"), Number(memberID), function() {
//					//successCallback();
//				}, function(error) {
//					consoledebug.log("addOneMemberToGroup addGroupMembers err is  " + JSON.stringify(error));
//					//errorCallback(error);
//				});
//			}, function(error){
//				consoledebug.log("addOneMemberToGroup getGroupInfoByRyid err is  " + JSON.stringify(error));
//			})
		} else {
			consoledebug.log("addOneMemberToGroup addMemberToDiscussion err is  " + JSON.stringify(err));
			//errorCallback(err);
		}
		
		getGroupInfoByRyid(rongyunID, function(groupInfo) {
			systemAddGroupMember(groupInfo, Number(memberID), function() {
				consoledebug.log("群主拉人成功");
				//successCallback();
			}, function(error) {
				consoledebug.log("addOneMemberToGroup addGroupMembers err is  " + JSON.stringify(error));
				//errorCallback(error);
			});
		}, function(error) {
			consoledebug.log("addOneMemberToGroup getGroupInfoByRyid err is  " + JSON.stringify(error));
		})

	})
}
//将取消帮助的帮助人退出群

	function quitOneMemberFromGroup(rongyunID, memberID) {
		getGroupInfoByRyid(rongyunID, function(groupInfo) {
			var groupID = groupInfo.get("groupID");
			consoledebug.log("groupID and memberID are " + groupID+" "+Number(memberID))
			systemQuitGroupMember(groupID, Number(memberID), function() {
				consoledebug.log("退群成功");
				//successCallback();
			}, function(error) {
				consoledebug.log("addOneMemberToGroup addGroupMembers err is  " + JSON.stringify(error));
				//errorCallback(error);
			});
		}, function(error) {
			consoledebug.log("addOneMemberToGroup getGroupInfoByRyid err is  " + JSON.stringify(error));
		})
	}

//如果是微信
function repairDiscussion(orderID, joinID){
    var HelpOrder = Bmob.Object.extend("HelpOrder");
    var query = new Bmob.Query(HelpOrder);
    var helpOrder = new HelpOrder();
    query.equalTo("orderID",parseInt(orderID));
    query.select("orderID","classID","groupID","group","state","orderName","applyDeadlineTime","place");
    query.find({
        success: function(helpOrders) {
            if(helpOrders.length > 0){
            	helpOrder = helpOrders[0];
            	if(!helpOrder.get("groupID")){
            		var className = trancClassName(helpOrder.get("classID"));
            		var groupName = getMyAccount().nickname + "的"+className+'求助群';
            		var rong = api.require(RONGYUN_SDK);
				    rong.createDiscussion({
				        name : groupName,
				        userIdList : [joinID+'']
				    }, function(ret, err) {
				        consoledebug.log("orderCreateGroup is  33333" + groupName + " " + JSON.stringify(ret) + " " + JSON.stringify(err));
				        if (ret && ret.status == 'success') {
				            var groupid = ret.result.discussionId;
				            createGroupBySystem(groupName, groupid, function(group) {
				                consoledebug.log('建群结果：成功' + JSON.stringify(group));

						        helpOrder.set("group", group);
						        helpOrder.set("groupID", groupid);
						        helpOrder.save();
						        
						        getOneCacheOrder(orderID, function(orderInfo){
							        setCacheOrderNewState(orderID, 0, helpOrder.get("state"), function(){
					                    api.sendEvent({
					                        name: 'orderStateChange',
					                        extra: {orderType: 0, 
					                                orderID: orderID
					                               }
					                    });
							        }, function(){});
						        },function(error){
						        	var helpInfo = {
						        		"orderID" : orderID,
						        		"orderName" : helpOrder.get("orderName"),
						        		"classID" : helpOrder.get("classID"),
						        		"beginTime" : helpOrder.get("applyDeadlineTime"),
						        		"place" : helpOrder.get("place"),
						        		"state" : helpOrder.get("state"),
						        		"notify" : 1,
						        		"ownership" : 0,
						        		"orderType" : 0,
						        	}
									var aOrders = [];
									aOrders.push(helpInfo);
									insertCacheOrders(aOrders, function() {
										setTimeout(function() {
											freashRunningOrderCall();	//可能是时间不够，直接调用无法刷新
										}, 100)
								        //freashRunningOrderCall();		
									}, function(err) {
										consoledebug.log("comInsertCacheOrders error is " + JSON.stringify(err));
										//err.message = err.msg;
									});
						        });
						        
								systemAddGroupMember(group, Number(joinID), function() {
									consoledebug.log("群主拉人成功");
									//successCallback();
								}, function(error) {
									consoledebug.log("addOneMemberToGroup addGroupMembers err is  " + JSON.stringify(error));
									//errorCallback(error);
								});
								
				            }, function(err) {
				                consoledebug.log('建群结果：error' + JSON.stringify(err));
				            });
				        } else {
				            consoledebug.log('orderCreateGroup rong.createDiscussion：error' + JSON.stringify(err));
				        }
				    })
            	}
            }
        },
        error: function(error) {
        }
    });
}

/**
   * 解析命令消息  
   *
   * @param {Object} message： JSON 对象，参考融云 setOnReceiveMessageListener 方法的参数
   * @return {Object} 解析后的 JSON 对象
   */
function parseCmdNty(message){    
    consoledebug.log('parseCmdNty: ' + JSON.stringify(message));
    if(message.content.name == 'orderStateChanged'){
        var orderState = JSON.parse(message.content.data);
        consoledebug.log("进群 orderState.state is " + orderState.state)
        consoledebug.log("进群 orderState.state is " + orderState.rongyunID)
        switch(orderState.orderType){
            case 0:
                notifyTitle = '求助订单更新';
                if(orderState.state == -1){	//OPERATION_HELPER_ENROLL 有人报名
    				consoledebug.log('parseCmdNty need to addOneMemberToGroup');
    				if(orderState.rongyunID){
                		addOneMemberToGroup(orderState.rongyunID, message.senderUserId);
    				}else{
    					repairDiscussion(orderState.orderID, message.senderUserId);
    					return;
    				}
                }
                if(orderState.state == -2){	//OPERATION_HELPER_ENROLL 有人报名
    				consoledebug.log('parseCmdNty need to quitOneMemberFromGroup');
                	quitOneMemberFromGroup(orderState.groupID, message.senderUserId);
                }
                //放到此处处理的原因是，进行中页面可能没有加载，会出现收不到消息而没有更新本地数据库的情况
                comUpdateOneRunningOrder(orderState.orderID, 0, function(){
	                api.sendEvent({
	                    name: 'orderStateChange',
	                    extra: {orderType: orderState.orderType, 
	                            orderID: orderState.orderID
	                           }
	                });
                },function(error){
                });
            break;
            case 1:
                notifyTitle = '服务更新';
            break;
            case 2:
                notifyTitle = '活动更新';
                if(orderState.state == -1){ //OPERATION_HELPER_ENROLL 有人报名
                    consoledebug.log('parseCmdNty need to addOneMemberToGroup');
                    addOneMemberToGroup(orderState.rongyunID, message.senderUserId);
                }
                //放到此处处理的原因是，进行中页面可能没有加载，会出现收不到消息而没有更新本地数据库的情况
                comUpdateOneRunningOrder(orderState.orderID, 1, function(){
                    api.sendEvent({
                        name: 'orderStateChange',
                        extra: {orderType: orderState.orderType, 
                                orderID: orderState.orderID
                               }
                    });
                },function(error){
                });
            break;
            default:
            break;
        }
    }
}

function deleteMessage(id){
	rong.deleteMessages({
	        messageIds: [id+""]
	    }, function (ret, err) {
	})
}

  /**
   * 融云接收消息后的系统通知功能
   *
   * @param {Object} ret： JSON 对象，参考融云 setOnReceiveMessageListener 方法的参数
   * @param {Object} err： JSON 对象，参考融云 setOnReceiveMessageListener 方法的参数
   */
function rongMessageNotify(ret, err) {
    var connn = '';
    var chattype = ret.result.message.conversationType;
    var mextra = {};
    var type = ret.result.message.objectName;
    if (type == 'RC:TxtMsg') {
        connn = ret.result.message.content.text;
    } else if (type == 'RC:VcMsg') {
        connn = '[语音]';
    } else if (type == 'RC:ImgMsg') {
        connn = '[图片]';
    } else if (type == 'RC:LBSMsg') {
        connn = '[位置]';
    } else if (type == 'RC:ImgTextMsg') {
        connn = '[图文]';
    } else if (type == 'RC:DizNtf') {
        //consoledebug.log('！！ RC:DizNtf 消息出现在 rongMessageNotify');
        //群消息暂不通知
        return;
    } else if (type == 'RC:CmdMsg') {
    	if(chattype == 'DISCUSSION' && ret.result.message.senderUserId == getMyAccount().hhID){	//自己发送的消息不处理
    		return;
    	}
        orderNotification(ret.result.message);
        parseCmdNty(ret.result.message);
        return;
    }
    
    if (chattype == 'DISCUSSION') {
    	var extra = JSON.parse(ret.result.message.content.extra);
        connn = extra.nickname + '：' + connn;
        mextra.notifyType = 'newChatMessage';
        mextra.chattype = chattype;
        mextra.targetId = ret.result.message.targetId;
        mextra.messageId = ret.result.message.messageId;
        getNotificationName(ret.result.message.targetId, connn, mextra);
    } else if (chattype == 'PRIVATE') {
    	var extra = parseExtra(ret.result.message.content.extra);
    	var nickname = '朋友';
    	if(extra && extra.nickname){
        	nickname = extra.nickname;
        }
        mextra.notifyType = 'newChatMessage';
        mextra.chattype = chattype;
        mextra.targetId = ret.result.message.targetId;
        mextra.messageId = ret.result.message.messageId;
        mextra.nickname = nickname;
        sendNotification(nickname, connn, mextra);
        //getH();
    }else if(chattype == 'SYSTEM'){
    	mextra.notifyType = 'newChatMessage';
        mextra.chattype = chattype;
        mextra.targetId = ret.result.message.targetId;
        mextra.messageId = ret.result.message.messageId;
        mextra.nickname = '系统消息';
    	sendNotification("系统消息", connn, mextra);
    }
}

//发送聊天的通知栏消息    
function sendNotification(title, content, extra) {
	consoledebug.log("sendNotification extra is " + JSON.stringify(extra))
	//设置群的消息免打扰功能
	if(extra.chattype == "DISCUSSION" && extra.targetId){
		var groupNoDisturb = $api.getStorage(extra.targetId + getMyAccount().hhID);
		consoledebug.log("sendNotification groupNoDisturb is " +groupNoDisturb)
		if(groupNoDisturb === 'true'){
			return;
		}
	}
	//判断在设置中是否接受新消息提醒
    var infotips = $api.getStorage("infotips" + getMyAccount().hhID);
	if(infotips.newMessage == 2 || infotips.voidM == 2){
		consoledebug.log("聊天通知功能被屏蔽")
		return;
	}
	if(judgeSilenceInfotip()){
		consoledebug.log("静音时段：聊天通知功能被屏蔽")
		return;
	}
    userNotification({
        notify : {
            title : title,
            content : content,
            updateCurrent : true, //是否覆盖新通知
            extra : extra
        }
    }, function(ret, err) {
        api.setPrefs({
            key : 'whatNews',
            value : extra
        });
        api.setPrefs({
            key : 'notification',
            value : ret.id
        });
    });
}

var gUserNotifyTime = 0;
function userNotification(parm, callback){
	var nowTime = (new Date()).getTime();
	if(nowTime - gUserNotifyTime > 3000){
		gUserNotifyTime = nowTime;
		consoledebug.log("发送提醒，参数为：" + JSON.stringify(parm))
	    api.notification(parm, function(ret, err) {
	    	callback(ret, err);
	    });
	}
}

//发送订单变化的通知栏消息    
function sendOrderNotification(title, content, extra) {
	//判断在设置中是否接受新消息提醒
    var infotips = $api.getStorage("infotips" + getMyAccount().hhID);
	consoledebug.log("infotips is " + JSON.stringify(infotips))
	if(infotips.reMessage == 2 || infotips.voidM == 2){
		consoledebug.log("接收订单提醒功能被屏蔽")
		return;
	}
    userNotification({
        //震动和闪光灯
        vibrate : [500, 500],
        light : false,
        notify : {
            title : title,
            content : content,
            updateCurrent : false, //是否覆盖新通知
            extra : extra
        }
    }, function(ret, err) {
    	var saveName = "notify" + getMyAccount().hhID + extra.orderID;
		var notifyid = $api.getStorage(saveName);
		if(notifyid){
			notifyid.push(ret.id);
		}else{
			notifyid = [ret.id];
		}
		$api.setStorage(saveName, notifyid);
		consoledebug.log("sendOrderNotification saveName and notifyid is " + saveName + JSON.stringify(notifyid));
    });
}

function clearNotification(orderID){
	var saveName = "notify" + getMyAccount().hhID + orderID;
	var notifyid = $api.getStorage(saveName);
	consoledebug.log("clearNotification saveName and notifyid is " + saveName + JSON.stringify(notifyid));
	if(notifyid){
		for(var i=0;i<notifyid.length;i++){
			api.cancelNotification({
			    id: notifyid[i]
			});
		}
		$api.setStorage(saveName, []);
	}
}

//根据静音时段设置的时段判断是否静音
function judgeSilenceInfotip(){
    var silenceInfotips = $api.getStorage("silenceInfotips" + getMyAccount().hhID);
    consoledebug.log("silenceInfotips is " + JSON.stringify(silenceInfotips));
    if(silenceInfotips.voidTime == 2){
    	return false;
    }else{
    	var tag = compareTimes(silenceInfotips);
    	consoledebug.log("judgeSilenceInfotip tag is " + tag);
    	if(tag){
    		return true;
    	}else{
    		return false;
    	}
    }
}

function compareTimes(silenceInfotips) {
	var beginTimehours = silenceInfotips.beginTimehours;
	var beginTimeminute = Number(silenceInfotips.beginTimeminute)*60000;
	var endTimehours = silenceInfotips.endTimehours;
	var endTimeminute = Number(silenceInfotips.endTimeminute)*60000;
	beginTimehours1 = beginTimehours.slice(0, 2)
	beginTimehours2 = Number(beginTimehours.slice(2));
	endTimehours1 = endTimehours.slice(0, 2)
	endTimehours2 = Number(endTimehours.slice(2));
	consoledebug.log("hours is " + beginTimehours1 + " " + beginTimehours2 + " " + endTimehours1 + " " + endTimehours2);
	var myDate = new Date();
	var currHour = myDate.getHours()*3600000;
	var currMinutes = myDate.getMinutes()*60000;
	if (beginTimehours1 == "上午") {
		beginTimehours2 = Number(beginTimehours2)*3600000;
	} else {
		beginTimehours2 = (Number(beginTimehours2) + 12)*3600000;
	}
	if (endTimehours1 == "上午") {
		endTimehours2 = Number(endTimehours2)*3600000;
	} else {
		endTimehours2 = (Number(endTimehours2) + 12)*3600000;
	}
	var currentTime = currHour + currMinutes;
	var startTime = beginTimehours2 + beginTimeminute;
	var endTime = endTimehours2 + endTimeminute;
	consoledebug.log("currentTime startTime endTime is " + currentTime + " " + startTime + " " + endTime);
	if(currentTime >= startTime && currentTime <= endTime){
		return true;
	}else{
		return false;
	}
}


//从本地获取群名字   没有就从网上
function getNotificationName(title, content, extra) {
	getComGroupInfo([title], function(groupInfos) {
        if (groupInfos.length != 0) {
        	extra.nickname = groupInfos[0].groupName;
            sendNotification(groupInfos[0].groupName, content, extra);
        } else {
        	extra.nickname = "群";
            sendNotification("群", content, extra);
        }
    }, function(avatars){
    },function(error){
        extra.nickname = "群";
        sendNotification("群", content, extra);
    });
}

function orderNotification(message) {
    var notifyTitle;
    var notifyContent;
    var notifyExtra = {};
    if(message.content.name == 'orderStateChanged'){
        var orderState = JSON.parse(message.content.data);
        notifyExtra.notifyType = message.content.name;
        notifyExtra.orderID = orderState.orderID;
        notifyContent = orderState.notifyText;
        switch(orderState.orderType){
            case 0:
                notifyTitle = '求助订单更新';
            break;
            case 1:
                notifyTitle = '服务更新';
            break;
            case 2:
                notifyTitle = '活动更新';
            break;
            default:
        		consoledebug.log("orderNotification message is " + JSON.stringify(message));
                notifyTitle = '新消息';
            break;
        }
       
       	//判断在设置中是否接受新消息提醒
//		var infotips = $api.getStorage("infotips");
//		consoledebug.log("infotips is " + JSON.stringify(infotips))
//		if(infotips.newMessage == 2){
//			consoledebug.log("接收提醒功能被屏蔽")
//			return;
//		}
        sendOrderNotification(notifyTitle, notifyContent, notifyExtra);
    }else if(message.content.name == 'orderPush'){
        var orderInfo = JSON.parse(message.content.data);
        notifyExtra.notifyType = message.content.name;
        notifyExtra.orderID = orderInfo.orderID;
        notifyExtra.orderType = orderInfo.orderType;
        
        //判断在设置中是否接受新消息提醒
//      var infotips = $api.getStorage("infotips");
//		consoledebug.log("infotips is " + JSON.stringify(infotips))
//		if(infotips.newMessage == 2){
//			consoledebug.log("接收提醒功能被屏蔽")
//			return;
//		}
        sendOrderNotification(orderInfo.notifyTitle, orderInfo.notifyText, notifyExtra);
    }
}


/**
 * 发布消息更新通知
 * @param {Number} hhID:  类对象，发送对方的 hhID
 * @param {Object} notificationMsg:  类对象，通知消息
 * 包含的属性 为：{
 *              orderID: Number,        //订单ID
 *              orderType: Number,        //0为求助，1为秀场，2为活动
 *              state: Number,        //变化后的状态
 *              notifyText:notifyText   //用户的提示消息文本
  *             }
 * @param {function} successCallback 成功后回调函数，定义为 .
 *      successCallback(hhID.orderID);
 * @param {function} errorCallback 操作失败后回调函数，定义为：
 *      errCallback(error); error is a class, {code: number, message:string}
 */
function sendOrderNotificationMsg(hhID, notificationMsg, successCallback, errorCallback) {
    var rong = api.require(RONGYUN_SDK);
    //rong.sendCommandNotificationMessage({
    var hhid = hhID.toString();
    rong.sendCommandMessage({
            conversationType: 'PRIVATE',
            targetId: hhid+"",
            name: 'orderStateChanged',
            data: JSON.stringify(notificationMsg)
        }, function (ret, err) {
            if (ret.status == 'prepare'){
                consoledebug.log("sendCommandNotificationMessage prepare ret is" + JSON.stringify(ret));
            }else if (ret.status == 'success'){
                consoledebug.log("sendCommandNotificationMessage success ret is" + JSON.stringify(ret));
                successCallback();
            }else if (ret.status == 'error'){
                consoledebug.log("sendCommandNotificationMessage error is" + JSON.stringify(err));
                errorCallback();
            }
        }
    );
}

function sendOrderPushMsg(hhID, notificationMsg, successCallback, errorCallback) {
    var rong = api.require(RONGYUN_SDK);
    //rong.sendCommandNotificationMessage({
    var hhid = hhID.toString();
    rong.sendCommandMessage({
            conversationType: 'PRIVATE',
            targetId: hhid+"",
            name: 'orderPush',
            data: JSON.stringify(notificationMsg)
        }, function (ret, err) {
            if (ret.status == 'prepare'){
                consoledebug.log("sendCommandNotificationMessage prepare ret is" + JSON.stringify(ret));
            }else if (ret.status == 'success'){
                consoledebug.log("sendCommandNotificationMessage success ret is" + JSON.stringify(ret));
                successCallback();
            }else if (ret.status == 'error'){
                consoledebug.log("sendCommandNotificationMessage error is" + JSON.stringify(err));
                errorCallback();
            }
        }
    );
}


/**
 * 发布消息更新通知
 * @param {Number} hhID:  类对象，发送对方的 hhID
 * @param {Object} notificationMsg:  类对象，通知消息
 * 包含的属性 为：{
 *              orderID: Number,        //订单ID
 *              orderType: Number,        //0为求助，1为秀场，2为活动
 *              state: Number,        //变化后的状态
 *              notifyText:notifyText   //用户的提示消息文本
  *             }
 * @param {function} successCallback 成功后回调函数，定义为 .
 *      successCallback(hhID.orderID);
 * @param {function} errorCallback 操作失败后回调函数，定义为：
 *      errCallback(error); error is a class, {code: number, message:string}
 */
function sendOrderNotificationMsgGroup(groupID, notificationMsg, successCallback, errorCallback) {
    //consoledebug.log("sendOrderNotificationMsgGroup groupID notificationMsg is" + groupID + JSON.stringify(notificationMsg));
    var rong = api.require(RONGYUN_SDK);
    //rong.sendCommandNotificationMessage({
    if(!groupID){
    	errorCallback();
    	return;
    }
    var groupId = groupID.toString();
    var parm = {
            conversationType: 'DISCUSSION',
            targetId: groupId+"",
            name: 'orderStateChanged',
            data: JSON.stringify(notificationMsg)
    }
    //consoledebug.log("sendOrderNotificationMsgGroup parm is" + JSON.stringify(parm));
    rong.sendCommandMessage(parm, function (ret, err) {
    		//consoledebug.log("sendOrderNotificationMsgGroup ret and err is" + JSON.stringify(ret) + JSON.stringify(err));
            if (ret.status == 'prepare'){
                consoledebug.log("sendOrderNotificationMsgGroup prepare ret is" + JSON.stringify(ret));
            }else if (ret.status == 'success'){
                consoledebug.log("sendOrderNotificationMsgGroup success ret is" + JSON.stringify(ret));
                successCallback();
            }else if (ret.status == 'error'){
                consoledebug.log("sendOrderNotificationMsgGroup error is" + JSON.stringify(err));
                errorCallback();
            }
        }
    );
}

function removeMemberPromis(rongyunID, hhID){
    var rong = api.require(RONGYUN_SDK);
	var promise = new Bmob.Promise();
	rong.removeMemberFromDiscussion({
		discussionId : rongyunID+"",
		userId : hhID+""
	}, function(ret, err) {
		if (ret.status == 'success') {
			promise.resolve();
		} else {
			consoledebug.log("makeHelperGroup addMemberToDiscussion err is  " + JSON.stringify(err));
			promise.reject(err);
		}
	})
	return promise;
}

function removeRongyunMembers(rongyunID, hhIDs, successCallback, errorCallback) {
	var promises = [];
	for (var i = 0; i < hhIDs.length; i++) {
		promises.push(removeMemberPromis(rongyunID, hhIDs[i]));
	}
	Bmob.Promise.when(promises).then(successCallback, errorCallback)
}

function deleteCoversetion(rongyunID) {
	var rong = api.require(RONGYUN_SDK);
	rong.removeConversation({
		conversationType : 'DISCUSSION',
		targetId : rongyunID+""
	}, function(ret, err) {
		if (ret) {
			api.sendEvent({
				name : 'onConversationDelete',
				extra : {
					targetId : rongyunID,
					type : 'DISCUSSION'
				}
			});
		}
	})
	rong.clearMessages({
		conversationType : 'DISCUSSION',
		targetId : rongyunID+""
	}, function(ret, err) {
		//api.toast({ msg: ret.status });
	})
}

function addUserToBlacklis(targetID, successCallback, errorCallback){
	var rong = api.require('rongCloud2');
	rong.addToBlacklist({
	   	userId: targetID+""
	}, function (ret, err) {
	    if (ret.status == 'success') {
	    	successCallback()
		} else {
			successCallback(err)
		}
	})
}
