/**
 * 身份验证上传照片
 * @param ownerID 本人hhID
 * @param validateSign 验证标记      
 * 		 0:未审核
 * 		 1:已通过
 * 		 2:未通过
 * @param nopassReason 未通过的原因   
 * @param {function}successCallback
 * @param errorCallback
 */

function insertValidateUserInfo(ownerID,vphoto,successCallback,errorCallback){
	var UserInfo = Bmob.Object.extend("UserInfo");
	var UserInfos = new Bmob.Query(UserInfo);
	UserInfos.equalTo("hhID",ownerID);
	UserInfos.find({
		success: function (result) {
			result[0].set("validateState",0);
			result[0].save().then(function(){
				convertImgToBase64(vphoto, function(dataurl){
					var data = dataurl.split(',')[1];
				    data = window.atob(data);
				    var fileName = ownerID + new Date().Format("yyyy-MM-dd-hh:mm:ss") + '.png';
				    var file = BmobFile(fileName, data);
				    file.save().then(function (obj) {
				        var photo = obj.url();
						var IdentityValidate = Bmob.Object.extend("IdentityValidate");
					    var query = new IdentityValidate();
						query.set("ownerID", ownerID);
						query.set("validateSign", 0);
						query.set("photo", photo);
						query.set("nopassReason", "");
						query.save().then(function(validateUserInfo){
						   successCallback(validateUserInfo);
						},function(error){
							errorCallback(error);
						});
				    }, function (error) {
				        consoledebug.log("insertActivityPhoto error is"+JSON.stringify(error));
				        errorCallback(error);
				    });
			    });
			},function(error){
				errorCallback(error);
			});
		},
		error: function (error) {
			errorCallback(error);
		}
	});
	
}
/**
 * 身份验证未通过再次上传照片
 * @param ownerID 本人hhID
 * @param validateSign 验证标记      
 * 		 0:未审核
 * 		 1:已通过
 * 		 2:未通过
 * @param nopassReason 未通过的原因   
 * @param {function}successCallback
 * @param errorCallback
 */
function insertAgainValidateUserInfo(ownerID,vphoto,successCallback,errorCallback){
	var UserInfo = Bmob.Object.extend("UserInfo");
	var UserInfos = new Bmob.Query(UserInfo);
	UserInfos.equalTo("hhID",ownerID);
	UserInfos.find({
		success: function (result) {
			result[0].set("validateState",0);
			result[0].save().then(function(){
				convertImgToBase64(vphoto, function(dataurl){
					var data = dataurl.split(',')[1];
				    data = window.atob(data);
				    var fileName = ownerID + new Date().Format("yyyy-MM-dd-hh:mm:ss") + '.png';
				    var file = BmobFile(fileName, data);
				    file.save().then(function (obj) {
				        var photo = obj.url();
				        var IdentityValidate = Bmob.Object.extend("IdentityValidate");
						var query = new Bmob.Query(IdentityValidate);
						query.equalTo("ownerID", ownerID);
						query.equalTo("validateSign", 2);
						query.find({
					        success: function (validateUserInfo) {
					        	validateUserInfo[0].set("validateSign",0);
					        	validateUserInfo[0].set("photo",photo);
					        	validateUserInfo[0].set("nopassReason","");
					            validateUserInfo[0].save().then(function(results){
								   successCallback(results);
								},function(error){
									errorCallback(error);
								});
					        },
					        error: function (error) {
					            errorCallback(error);
					        }
					    })
				    }, function (error) {
				        consoledebug.log("insertActivityPhoto error is"+JSON.stringify(error));
				        errorCallback(error);
				    });
			    });
			},function(error){
				errorCallback(error);
			});
		},
		error: function (error) {
			errorCallback(error);
		}
	});
	
}
/**
 * 身份验证获取上传照片
 * @param ownerID 本人hhID
 * @param validateSign 验证标记      
 * 		 0:未审核
 * 		 1:已通过
 * 		 2:通过
 * @param nopassReason 未通过的原因   
 * @param {function}successCallback
 * @param errorCallback
 */

function GetValidateUserInfo(ownerID,successCallback,errorCallback){
	var IdentityValidate = Bmob.Object.extend("IdentityValidate");
    var query = new Bmob.Query(IdentityValidate);
    query.equalTo("ownerID",ownerID);
    query.find({
        success: function (validateUserInfo) {
            successCallback(validateUserInfo);
        },
        error: function (error) {
            errorCallback(error);
        }
    });
}














